/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_ANALYSIS_EASYANALYZER
#define H_LUCY_ANALYSIS_EASYANALYZER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Analysis/Analyzer.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_EASYANALYZER
extern size_t lucy_EasyAnalyzer_IVARS_OFFSET;
typedef struct lucy_EasyAnalyzerIVARS lucy_EasyAnalyzerIVARS;
static CFISH_INLINE lucy_EasyAnalyzerIVARS*
lucy_EasyAnalyzer_IVARS(lucy_EasyAnalyzer *self) {
   char *ptr = (char*)self + lucy_EasyAnalyzer_IVARS_OFFSET;
   return (lucy_EasyAnalyzerIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define EasyAnalyzerIVARS lucy_EasyAnalyzerIVARS
  #define EasyAnalyzer_IVARS lucy_EasyAnalyzer_IVARS
#endif

struct lucy_EasyAnalyzerIVARS {
    cfish_String* language;
    lucy_StandardTokenizer* tokenizer;
    lucy_Normalizer* normalizer;
    lucy_SnowballStemmer* stemmer;
};

#endif /* C_LUCY_EASYANALYZER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_EasyAnalyzer*
lucy_EasyAnalyzer_new(cfish_String* language);

LUCY_VISIBLE lucy_EasyAnalyzer*
lucy_EasyAnalyzer_init(lucy_EasyAnalyzer* self, cfish_String* language);

void
LUCY_EasyAnalyzer_Destroy_IMP(lucy_EasyAnalyzer* self);

bool
LUCY_EasyAnalyzer_Equals_IMP(lucy_EasyAnalyzer* self, cfish_Obj* other);

lucy_Inversion*
LUCY_EasyAnalyzer_Transform_IMP(lucy_EasyAnalyzer* self, lucy_Inversion* inversion);

lucy_Inversion*
LUCY_EasyAnalyzer_Transform_Text_IMP(lucy_EasyAnalyzer* self, cfish_String* text);

cfish_Hash*
LUCY_EasyAnalyzer_Dump_IMP(lucy_EasyAnalyzer* self);

lucy_EasyAnalyzer*
LUCY_EasyAnalyzer_Load_IMP(lucy_EasyAnalyzer* self, cfish_Obj* dump);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_EasyAnalyzer_Get_RefCount_t)(lucy_EasyAnalyzer *self);

typedef cfish_Obj*
(*LUCY_EasyAnalyzer_Inc_RefCount_t)(lucy_EasyAnalyzer *self);

typedef uint32_t
(*LUCY_EasyAnalyzer_Dec_RefCount_t)(lucy_EasyAnalyzer *self);

typedef void*
(*LUCY_EasyAnalyzer_To_Host_t)(lucy_EasyAnalyzer *self);

typedef cfish_Obj*
(*LUCY_EasyAnalyzer_Clone_t)(lucy_EasyAnalyzer *self);

typedef void
(*LUCY_EasyAnalyzer_Destroy_t)(lucy_EasyAnalyzer *self);

typedef bool
(*LUCY_EasyAnalyzer_Equals_t)(lucy_EasyAnalyzer *self, cfish_Obj* other);

typedef int32_t
(*LUCY_EasyAnalyzer_Compare_To_t)(lucy_EasyAnalyzer *self, cfish_Obj* other);

typedef int32_t
(*LUCY_EasyAnalyzer_Hash_Sum_t)(lucy_EasyAnalyzer *self);

typedef cfish_Class*
(*LUCY_EasyAnalyzer_Get_Class_t)(lucy_EasyAnalyzer *self);

typedef cfish_String*
(*LUCY_EasyAnalyzer_Get_Class_Name_t)(lucy_EasyAnalyzer *self);

typedef bool
(*LUCY_EasyAnalyzer_Is_A_t)(lucy_EasyAnalyzer *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_EasyAnalyzer_To_String_t)(lucy_EasyAnalyzer *self);

typedef int64_t
(*LUCY_EasyAnalyzer_To_I64_t)(lucy_EasyAnalyzer *self);

typedef double
(*LUCY_EasyAnalyzer_To_F64_t)(lucy_EasyAnalyzer *self);

typedef bool
(*LUCY_EasyAnalyzer_To_Bool_t)(lucy_EasyAnalyzer *self);

typedef void
(*LUCY_EasyAnalyzer_Mimic_t)(lucy_EasyAnalyzer *self, cfish_Obj* other);

typedef lucy_Inversion*
(*LUCY_EasyAnalyzer_Transform_t)(lucy_EasyAnalyzer *self, lucy_Inversion* inversion);

typedef lucy_Inversion*
(*LUCY_EasyAnalyzer_Transform_Text_t)(lucy_EasyAnalyzer *self, cfish_String* text);

typedef cfish_VArray*
(*LUCY_EasyAnalyzer_Split_t)(lucy_EasyAnalyzer *self, cfish_String* text);

typedef cfish_Hash*
(*LUCY_EasyAnalyzer_Dump_t)(lucy_EasyAnalyzer *self);

typedef lucy_EasyAnalyzer*
(*LUCY_EasyAnalyzer_Load_t)(lucy_EasyAnalyzer *self, cfish_Obj* dump);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_EasyAnalyzer_Get_RefCount(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_Get_RefCount_t method = (LUCY_EasyAnalyzer_Get_RefCount_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_EasyAnalyzer_Inc_RefCount(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_Inc_RefCount_t method = (LUCY_EasyAnalyzer_Inc_RefCount_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_EasyAnalyzer_Dec_RefCount(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_Dec_RefCount_t method = (LUCY_EasyAnalyzer_Dec_RefCount_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_EasyAnalyzer_To_Host(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_To_Host_t method = (LUCY_EasyAnalyzer_To_Host_t)cfish_obj_method(self, LUCY_EasyAnalyzer_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_EasyAnalyzer_Clone(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_Clone_t method = (LUCY_EasyAnalyzer_Clone_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_EasyAnalyzer_Destroy(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_Destroy_t method = (LUCY_EasyAnalyzer_Destroy_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_EasyAnalyzer_Equals(lucy_EasyAnalyzer *self, cfish_Obj* other) {
    const LUCY_EasyAnalyzer_Equals_t method = (LUCY_EasyAnalyzer_Equals_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_EasyAnalyzer_Compare_To(lucy_EasyAnalyzer *self, cfish_Obj* other) {
    const LUCY_EasyAnalyzer_Compare_To_t method = (LUCY_EasyAnalyzer_Compare_To_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_EasyAnalyzer_Hash_Sum(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_Hash_Sum_t method = (LUCY_EasyAnalyzer_Hash_Sum_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_EasyAnalyzer_Get_Class(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_Get_Class_t method = (LUCY_EasyAnalyzer_Get_Class_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_EasyAnalyzer_Get_Class_Name(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_Get_Class_Name_t method = (LUCY_EasyAnalyzer_Get_Class_Name_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_EasyAnalyzer_Is_A(lucy_EasyAnalyzer *self, cfish_Class* ancestor) {
    const LUCY_EasyAnalyzer_Is_A_t method = (LUCY_EasyAnalyzer_Is_A_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_EasyAnalyzer_To_String(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_To_String_t method = (LUCY_EasyAnalyzer_To_String_t)cfish_obj_method(self, LUCY_EasyAnalyzer_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_EasyAnalyzer_To_I64(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_To_I64_t method = (LUCY_EasyAnalyzer_To_I64_t)cfish_obj_method(self, LUCY_EasyAnalyzer_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_EasyAnalyzer_To_F64(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_To_F64_t method = (LUCY_EasyAnalyzer_To_F64_t)cfish_obj_method(self, LUCY_EasyAnalyzer_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_EasyAnalyzer_To_Bool(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_To_Bool_t method = (LUCY_EasyAnalyzer_To_Bool_t)cfish_obj_method(self, LUCY_EasyAnalyzer_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_EasyAnalyzer_Mimic(lucy_EasyAnalyzer *self, cfish_Obj* other) {
    const LUCY_EasyAnalyzer_Mimic_t method = (LUCY_EasyAnalyzer_Mimic_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Transform_OFFSET;
static CFISH_INLINE lucy_Inversion*
LUCY_EasyAnalyzer_Transform(lucy_EasyAnalyzer *self, lucy_Inversion* inversion) {
    const LUCY_EasyAnalyzer_Transform_t method = (LUCY_EasyAnalyzer_Transform_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Transform_OFFSET);
    return method(self, inversion);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Transform_Text_OFFSET;
static CFISH_INLINE lucy_Inversion*
LUCY_EasyAnalyzer_Transform_Text(lucy_EasyAnalyzer *self, cfish_String* text) {
    const LUCY_EasyAnalyzer_Transform_Text_t method = (LUCY_EasyAnalyzer_Transform_Text_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Transform_Text_OFFSET);
    return method(self, text);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Split_OFFSET;
static CFISH_INLINE cfish_VArray*
LUCY_EasyAnalyzer_Split(lucy_EasyAnalyzer *self, cfish_String* text) {
    const LUCY_EasyAnalyzer_Split_t method = (LUCY_EasyAnalyzer_Split_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Split_OFFSET);
    return method(self, text);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Dump_OFFSET;
static CFISH_INLINE cfish_Hash*
LUCY_EasyAnalyzer_Dump(lucy_EasyAnalyzer *self) {
    const LUCY_EasyAnalyzer_Dump_t method = (LUCY_EasyAnalyzer_Dump_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Dump_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_EasyAnalyzer_Load_OFFSET;
static CFISH_INLINE lucy_EasyAnalyzer*
LUCY_EasyAnalyzer_Load(lucy_EasyAnalyzer *self, cfish_Obj* dump) {
    const LUCY_EasyAnalyzer_Load_t method = (LUCY_EasyAnalyzer_Load_t)cfish_obj_method(self, LUCY_EasyAnalyzer_Load_OFFSET);
    return method(self, dump);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_EASYANALYZER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define EasyAnalyzer lucy_EasyAnalyzer
  #define EASYANALYZER LUCY_EASYANALYZER
  #define EasyAnalyzer_new lucy_EasyAnalyzer_new
  #define EasyAnalyzer_init lucy_EasyAnalyzer_init
  #define EasyAnalyzer_Destroy_IMP LUCY_EasyAnalyzer_Destroy_IMP
  #define EasyAnalyzer_Equals_IMP LUCY_EasyAnalyzer_Equals_IMP
  #define EasyAnalyzer_Transform_IMP LUCY_EasyAnalyzer_Transform_IMP
  #define EasyAnalyzer_Transform_Text_IMP LUCY_EasyAnalyzer_Transform_Text_IMP
  #define EasyAnalyzer_Dump_IMP LUCY_EasyAnalyzer_Dump_IMP
  #define EasyAnalyzer_Load_IMP LUCY_EasyAnalyzer_Load_IMP
  #define EasyAnalyzer_Get_RefCount LUCY_EasyAnalyzer_Get_RefCount
  #define EasyAnalyzer_Get_RefCount_t LUCY_EasyAnalyzer_Get_RefCount_t
  #define EasyAnalyzer_Inc_RefCount LUCY_EasyAnalyzer_Inc_RefCount
  #define EasyAnalyzer_Inc_RefCount_t LUCY_EasyAnalyzer_Inc_RefCount_t
  #define EasyAnalyzer_Dec_RefCount LUCY_EasyAnalyzer_Dec_RefCount
  #define EasyAnalyzer_Dec_RefCount_t LUCY_EasyAnalyzer_Dec_RefCount_t
  #define EasyAnalyzer_To_Host LUCY_EasyAnalyzer_To_Host
  #define EasyAnalyzer_To_Host_t LUCY_EasyAnalyzer_To_Host_t
  #define EasyAnalyzer_Clone LUCY_EasyAnalyzer_Clone
  #define EasyAnalyzer_Clone_t LUCY_EasyAnalyzer_Clone_t
  #define EasyAnalyzer_Destroy LUCY_EasyAnalyzer_Destroy
  #define EasyAnalyzer_Destroy_t LUCY_EasyAnalyzer_Destroy_t
  #define EasyAnalyzer_Equals LUCY_EasyAnalyzer_Equals
  #define EasyAnalyzer_Equals_t LUCY_EasyAnalyzer_Equals_t
  #define EasyAnalyzer_Compare_To LUCY_EasyAnalyzer_Compare_To
  #define EasyAnalyzer_Compare_To_t LUCY_EasyAnalyzer_Compare_To_t
  #define EasyAnalyzer_Hash_Sum LUCY_EasyAnalyzer_Hash_Sum
  #define EasyAnalyzer_Hash_Sum_t LUCY_EasyAnalyzer_Hash_Sum_t
  #define EasyAnalyzer_Get_Class LUCY_EasyAnalyzer_Get_Class
  #define EasyAnalyzer_Get_Class_t LUCY_EasyAnalyzer_Get_Class_t
  #define EasyAnalyzer_Get_Class_Name LUCY_EasyAnalyzer_Get_Class_Name
  #define EasyAnalyzer_Get_Class_Name_t LUCY_EasyAnalyzer_Get_Class_Name_t
  #define EasyAnalyzer_Is_A LUCY_EasyAnalyzer_Is_A
  #define EasyAnalyzer_Is_A_t LUCY_EasyAnalyzer_Is_A_t
  #define EasyAnalyzer_To_String LUCY_EasyAnalyzer_To_String
  #define EasyAnalyzer_To_String_t LUCY_EasyAnalyzer_To_String_t
  #define EasyAnalyzer_To_I64 LUCY_EasyAnalyzer_To_I64
  #define EasyAnalyzer_To_I64_t LUCY_EasyAnalyzer_To_I64_t
  #define EasyAnalyzer_To_F64 LUCY_EasyAnalyzer_To_F64
  #define EasyAnalyzer_To_F64_t LUCY_EasyAnalyzer_To_F64_t
  #define EasyAnalyzer_To_Bool LUCY_EasyAnalyzer_To_Bool
  #define EasyAnalyzer_To_Bool_t LUCY_EasyAnalyzer_To_Bool_t
  #define EasyAnalyzer_Mimic LUCY_EasyAnalyzer_Mimic
  #define EasyAnalyzer_Mimic_t LUCY_EasyAnalyzer_Mimic_t
  #define EasyAnalyzer_Transform LUCY_EasyAnalyzer_Transform
  #define EasyAnalyzer_Transform_t LUCY_EasyAnalyzer_Transform_t
  #define EasyAnalyzer_Transform_Text LUCY_EasyAnalyzer_Transform_Text
  #define EasyAnalyzer_Transform_Text_t LUCY_EasyAnalyzer_Transform_Text_t
  #define EasyAnalyzer_Split LUCY_EasyAnalyzer_Split
  #define EasyAnalyzer_Split_t LUCY_EasyAnalyzer_Split_t
  #define EasyAnalyzer_Dump LUCY_EasyAnalyzer_Dump
  #define EasyAnalyzer_Dump_t LUCY_EasyAnalyzer_Dump_t
  #define EasyAnalyzer_Load LUCY_EasyAnalyzer_Load
  #define EasyAnalyzer_Load_t LUCY_EasyAnalyzer_Load_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_ANALYSIS_EASYANALYZER */




