/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_LEXICONREADER
#define H_LUCY_INDEX_LEXICONREADER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_LEXICONREADER
extern size_t lucy_LexReader_IVARS_OFFSET;
typedef struct lucy_LexiconReaderIVARS lucy_LexiconReaderIVARS;
static CFISH_INLINE lucy_LexiconReaderIVARS*
lucy_LexReader_IVARS(lucy_LexiconReader *self) {
   char *ptr = (char*)self + lucy_LexReader_IVARS_OFFSET;
   return (lucy_LexiconReaderIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define LexiconReaderIVARS lucy_LexiconReaderIVARS
  #define LexReader_IVARS lucy_LexReader_IVARS
#endif

struct lucy_LexiconReaderIVARS {
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    cfish_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
};

#endif /* C_LUCY_LEXICONREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_LexiconReader*
lucy_LexReader_init(lucy_LexiconReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, cfish_VArray* segments, int32_t seg_tick);

lucy_LexiconReader*
LUCY_LexReader_Aggregator_IMP(lucy_LexiconReader* self, cfish_VArray* readers, lucy_I32Array* offsets);

lucy_Lexicon*
LUCY_LexReader_Lexicon_IMP(lucy_LexiconReader* self, cfish_String* field, cfish_Obj* term);

uint32_t
LUCY_LexReader_Doc_Freq_IMP(lucy_LexiconReader* self, cfish_String* field, cfish_Obj* term);

lucy_TermInfo*
LUCY_LexReader_Fetch_Term_Info_IMP(lucy_LexiconReader* self, cfish_String* field, cfish_Obj* term);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_LexReader_Get_RefCount_t)(lucy_LexiconReader *self);

typedef cfish_Obj*
(*LUCY_LexReader_Inc_RefCount_t)(lucy_LexiconReader *self);

typedef uint32_t
(*LUCY_LexReader_Dec_RefCount_t)(lucy_LexiconReader *self);

typedef void*
(*LUCY_LexReader_To_Host_t)(lucy_LexiconReader *self);

typedef cfish_Obj*
(*LUCY_LexReader_Clone_t)(lucy_LexiconReader *self);

typedef void
(*LUCY_LexReader_Destroy_t)(lucy_LexiconReader *self);

typedef bool
(*LUCY_LexReader_Equals_t)(lucy_LexiconReader *self, cfish_Obj* other);

typedef int32_t
(*LUCY_LexReader_Compare_To_t)(lucy_LexiconReader *self, cfish_Obj* other);

typedef int32_t
(*LUCY_LexReader_Hash_Sum_t)(lucy_LexiconReader *self);

typedef cfish_Class*
(*LUCY_LexReader_Get_Class_t)(lucy_LexiconReader *self);

typedef cfish_String*
(*LUCY_LexReader_Get_Class_Name_t)(lucy_LexiconReader *self);

typedef bool
(*LUCY_LexReader_Is_A_t)(lucy_LexiconReader *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_LexReader_To_String_t)(lucy_LexiconReader *self);

typedef int64_t
(*LUCY_LexReader_To_I64_t)(lucy_LexiconReader *self);

typedef double
(*LUCY_LexReader_To_F64_t)(lucy_LexiconReader *self);

typedef bool
(*LUCY_LexReader_To_Bool_t)(lucy_LexiconReader *self);

typedef void
(*LUCY_LexReader_Mimic_t)(lucy_LexiconReader *self, cfish_Obj* other);

typedef lucy_LexiconReader*
(*LUCY_LexReader_Aggregator_t)(lucy_LexiconReader *self, cfish_VArray* readers, lucy_I32Array* offsets);

typedef lucy_Schema*
(*LUCY_LexReader_Get_Schema_t)(lucy_LexiconReader *self);

typedef lucy_Folder*
(*LUCY_LexReader_Get_Folder_t)(lucy_LexiconReader *self);

typedef lucy_Snapshot*
(*LUCY_LexReader_Get_Snapshot_t)(lucy_LexiconReader *self);

typedef cfish_VArray*
(*LUCY_LexReader_Get_Segments_t)(lucy_LexiconReader *self);

typedef lucy_Segment*
(*LUCY_LexReader_Get_Segment_t)(lucy_LexiconReader *self);

typedef int32_t
(*LUCY_LexReader_Get_Seg_Tick_t)(lucy_LexiconReader *self);

typedef void
(*LUCY_LexReader_Close_t)(lucy_LexiconReader *self);

typedef lucy_Lexicon*
(*LUCY_LexReader_Lexicon_t)(lucy_LexiconReader *self, cfish_String* field, cfish_Obj* term);

typedef uint32_t
(*LUCY_LexReader_Doc_Freq_t)(lucy_LexiconReader *self, cfish_String* field, cfish_Obj* term);

typedef lucy_TermInfo*
(*LUCY_LexReader_Fetch_Term_Info_t)(lucy_LexiconReader *self, cfish_String* field, cfish_Obj* term);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_LexReader_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_LexReader_Get_RefCount(lucy_LexiconReader *self) {
    const LUCY_LexReader_Get_RefCount_t method = (LUCY_LexReader_Get_RefCount_t)cfish_obj_method(self, LUCY_LexReader_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_LexReader_Inc_RefCount(lucy_LexiconReader *self) {
    const LUCY_LexReader_Inc_RefCount_t method = (LUCY_LexReader_Inc_RefCount_t)cfish_obj_method(self, LUCY_LexReader_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_LexReader_Dec_RefCount(lucy_LexiconReader *self) {
    const LUCY_LexReader_Dec_RefCount_t method = (LUCY_LexReader_Dec_RefCount_t)cfish_obj_method(self, LUCY_LexReader_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_LexReader_To_Host(lucy_LexiconReader *self) {
    const LUCY_LexReader_To_Host_t method = (LUCY_LexReader_To_Host_t)cfish_obj_method(self, LUCY_LexReader_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_LexReader_Clone(lucy_LexiconReader *self) {
    const LUCY_LexReader_Clone_t method = (LUCY_LexReader_Clone_t)cfish_obj_method(self, LUCY_LexReader_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_LexReader_Destroy(lucy_LexiconReader *self) {
    const LUCY_LexReader_Destroy_t method = (LUCY_LexReader_Destroy_t)cfish_obj_method(self, LUCY_LexReader_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_LexReader_Equals(lucy_LexiconReader *self, cfish_Obj* other) {
    const LUCY_LexReader_Equals_t method = (LUCY_LexReader_Equals_t)cfish_obj_method(self, LUCY_LexReader_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_LexReader_Compare_To(lucy_LexiconReader *self, cfish_Obj* other) {
    const LUCY_LexReader_Compare_To_t method = (LUCY_LexReader_Compare_To_t)cfish_obj_method(self, LUCY_LexReader_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_LexReader_Hash_Sum(lucy_LexiconReader *self) {
    const LUCY_LexReader_Hash_Sum_t method = (LUCY_LexReader_Hash_Sum_t)cfish_obj_method(self, LUCY_LexReader_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_LexReader_Get_Class(lucy_LexiconReader *self) {
    const LUCY_LexReader_Get_Class_t method = (LUCY_LexReader_Get_Class_t)cfish_obj_method(self, LUCY_LexReader_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_LexReader_Get_Class_Name(lucy_LexiconReader *self) {
    const LUCY_LexReader_Get_Class_Name_t method = (LUCY_LexReader_Get_Class_Name_t)cfish_obj_method(self, LUCY_LexReader_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_LexReader_Is_A(lucy_LexiconReader *self, cfish_Class* ancestor) {
    const LUCY_LexReader_Is_A_t method = (LUCY_LexReader_Is_A_t)cfish_obj_method(self, LUCY_LexReader_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_LexReader_To_String(lucy_LexiconReader *self) {
    const LUCY_LexReader_To_String_t method = (LUCY_LexReader_To_String_t)cfish_obj_method(self, LUCY_LexReader_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_LexReader_To_I64(lucy_LexiconReader *self) {
    const LUCY_LexReader_To_I64_t method = (LUCY_LexReader_To_I64_t)cfish_obj_method(self, LUCY_LexReader_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_LexReader_To_F64(lucy_LexiconReader *self) {
    const LUCY_LexReader_To_F64_t method = (LUCY_LexReader_To_F64_t)cfish_obj_method(self, LUCY_LexReader_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_LexReader_To_Bool(lucy_LexiconReader *self) {
    const LUCY_LexReader_To_Bool_t method = (LUCY_LexReader_To_Bool_t)cfish_obj_method(self, LUCY_LexReader_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_LexReader_Mimic(lucy_LexiconReader *self, cfish_Obj* other) {
    const LUCY_LexReader_Mimic_t method = (LUCY_LexReader_Mimic_t)cfish_obj_method(self, LUCY_LexReader_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Aggregator_OFFSET;
static CFISH_INLINE lucy_LexiconReader*
LUCY_LexReader_Aggregator(lucy_LexiconReader *self, cfish_VArray* readers, lucy_I32Array* offsets) {
    const LUCY_LexReader_Aggregator_t method = (LUCY_LexReader_Aggregator_t)cfish_obj_method(self, LUCY_LexReader_Aggregator_OFFSET);
    return method(self, readers, offsets);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Get_Schema_OFFSET;
static CFISH_INLINE lucy_Schema*
LUCY_LexReader_Get_Schema(lucy_LexiconReader *self) {
    const LUCY_LexReader_Get_Schema_t method = (LUCY_LexReader_Get_Schema_t)cfish_obj_method(self, LUCY_LexReader_Get_Schema_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Get_Folder_OFFSET;
static CFISH_INLINE lucy_Folder*
LUCY_LexReader_Get_Folder(lucy_LexiconReader *self) {
    const LUCY_LexReader_Get_Folder_t method = (LUCY_LexReader_Get_Folder_t)cfish_obj_method(self, LUCY_LexReader_Get_Folder_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Get_Snapshot_OFFSET;
static CFISH_INLINE lucy_Snapshot*
LUCY_LexReader_Get_Snapshot(lucy_LexiconReader *self) {
    const LUCY_LexReader_Get_Snapshot_t method = (LUCY_LexReader_Get_Snapshot_t)cfish_obj_method(self, LUCY_LexReader_Get_Snapshot_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Get_Segments_OFFSET;
static CFISH_INLINE cfish_VArray*
LUCY_LexReader_Get_Segments(lucy_LexiconReader *self) {
    const LUCY_LexReader_Get_Segments_t method = (LUCY_LexReader_Get_Segments_t)cfish_obj_method(self, LUCY_LexReader_Get_Segments_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Get_Segment_OFFSET;
static CFISH_INLINE lucy_Segment*
LUCY_LexReader_Get_Segment(lucy_LexiconReader *self) {
    const LUCY_LexReader_Get_Segment_t method = (LUCY_LexReader_Get_Segment_t)cfish_obj_method(self, LUCY_LexReader_Get_Segment_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Get_Seg_Tick_OFFSET;
static CFISH_INLINE int32_t
LUCY_LexReader_Get_Seg_Tick(lucy_LexiconReader *self) {
    const LUCY_LexReader_Get_Seg_Tick_t method = (LUCY_LexReader_Get_Seg_Tick_t)cfish_obj_method(self, LUCY_LexReader_Get_Seg_Tick_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Close_OFFSET;
static CFISH_INLINE void
LUCY_LexReader_Close(lucy_LexiconReader *self) {
    const LUCY_LexReader_Close_t method = (LUCY_LexReader_Close_t)cfish_obj_method(self, LUCY_LexReader_Close_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Lexicon_OFFSET;
static CFISH_INLINE lucy_Lexicon*
LUCY_LexReader_Lexicon(lucy_LexiconReader *self, cfish_String* field, cfish_Obj* term) {
    const LUCY_LexReader_Lexicon_t method = (LUCY_LexReader_Lexicon_t)cfish_obj_method(self, LUCY_LexReader_Lexicon_OFFSET);
    return method(self, field, term);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Doc_Freq_OFFSET;
static CFISH_INLINE uint32_t
LUCY_LexReader_Doc_Freq(lucy_LexiconReader *self, cfish_String* field, cfish_Obj* term) {
    const LUCY_LexReader_Doc_Freq_t method = (LUCY_LexReader_Doc_Freq_t)cfish_obj_method(self, LUCY_LexReader_Doc_Freq_OFFSET);
    return method(self, field, term);
}

extern LUCY_VISIBLE size_t LUCY_LexReader_Fetch_Term_Info_OFFSET;
static CFISH_INLINE lucy_TermInfo*
LUCY_LexReader_Fetch_Term_Info(lucy_LexiconReader *self, cfish_String* field, cfish_Obj* term) {
    const LUCY_LexReader_Fetch_Term_Info_t method = (LUCY_LexReader_Fetch_Term_Info_t)cfish_obj_method(self, LUCY_LexReader_Fetch_Term_Info_OFFSET);
    return method(self, field, term);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_LEXICONREADER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define LexiconReader lucy_LexiconReader
  #define LEXICONREADER LUCY_LEXICONREADER
  #define LexReader_init lucy_LexReader_init
  #define LexReader_Aggregator_IMP LUCY_LexReader_Aggregator_IMP
  #define LexReader_Lexicon_IMP LUCY_LexReader_Lexicon_IMP
  #define LexReader_Doc_Freq_IMP LUCY_LexReader_Doc_Freq_IMP
  #define LexReader_Fetch_Term_Info_IMP LUCY_LexReader_Fetch_Term_Info_IMP
  #define LexReader_Get_RefCount LUCY_LexReader_Get_RefCount
  #define LexReader_Get_RefCount_t LUCY_LexReader_Get_RefCount_t
  #define LexReader_Inc_RefCount LUCY_LexReader_Inc_RefCount
  #define LexReader_Inc_RefCount_t LUCY_LexReader_Inc_RefCount_t
  #define LexReader_Dec_RefCount LUCY_LexReader_Dec_RefCount
  #define LexReader_Dec_RefCount_t LUCY_LexReader_Dec_RefCount_t
  #define LexReader_To_Host LUCY_LexReader_To_Host
  #define LexReader_To_Host_t LUCY_LexReader_To_Host_t
  #define LexReader_Clone LUCY_LexReader_Clone
  #define LexReader_Clone_t LUCY_LexReader_Clone_t
  #define LexReader_Destroy LUCY_LexReader_Destroy
  #define LexReader_Destroy_t LUCY_LexReader_Destroy_t
  #define LexReader_Equals LUCY_LexReader_Equals
  #define LexReader_Equals_t LUCY_LexReader_Equals_t
  #define LexReader_Compare_To LUCY_LexReader_Compare_To
  #define LexReader_Compare_To_t LUCY_LexReader_Compare_To_t
  #define LexReader_Hash_Sum LUCY_LexReader_Hash_Sum
  #define LexReader_Hash_Sum_t LUCY_LexReader_Hash_Sum_t
  #define LexReader_Get_Class LUCY_LexReader_Get_Class
  #define LexReader_Get_Class_t LUCY_LexReader_Get_Class_t
  #define LexReader_Get_Class_Name LUCY_LexReader_Get_Class_Name
  #define LexReader_Get_Class_Name_t LUCY_LexReader_Get_Class_Name_t
  #define LexReader_Is_A LUCY_LexReader_Is_A
  #define LexReader_Is_A_t LUCY_LexReader_Is_A_t
  #define LexReader_To_String LUCY_LexReader_To_String
  #define LexReader_To_String_t LUCY_LexReader_To_String_t
  #define LexReader_To_I64 LUCY_LexReader_To_I64
  #define LexReader_To_I64_t LUCY_LexReader_To_I64_t
  #define LexReader_To_F64 LUCY_LexReader_To_F64
  #define LexReader_To_F64_t LUCY_LexReader_To_F64_t
  #define LexReader_To_Bool LUCY_LexReader_To_Bool
  #define LexReader_To_Bool_t LUCY_LexReader_To_Bool_t
  #define LexReader_Mimic LUCY_LexReader_Mimic
  #define LexReader_Mimic_t LUCY_LexReader_Mimic_t
  #define LexReader_Aggregator LUCY_LexReader_Aggregator
  #define LexReader_Aggregator_t LUCY_LexReader_Aggregator_t
  #define LexReader_Get_Schema LUCY_LexReader_Get_Schema
  #define LexReader_Get_Schema_t LUCY_LexReader_Get_Schema_t
  #define LexReader_Get_Folder LUCY_LexReader_Get_Folder
  #define LexReader_Get_Folder_t LUCY_LexReader_Get_Folder_t
  #define LexReader_Get_Snapshot LUCY_LexReader_Get_Snapshot
  #define LexReader_Get_Snapshot_t LUCY_LexReader_Get_Snapshot_t
  #define LexReader_Get_Segments LUCY_LexReader_Get_Segments
  #define LexReader_Get_Segments_t LUCY_LexReader_Get_Segments_t
  #define LexReader_Get_Segment LUCY_LexReader_Get_Segment
  #define LexReader_Get_Segment_t LUCY_LexReader_Get_Segment_t
  #define LexReader_Get_Seg_Tick LUCY_LexReader_Get_Seg_Tick
  #define LexReader_Get_Seg_Tick_t LUCY_LexReader_Get_Seg_Tick_t
  #define LexReader_Close LUCY_LexReader_Close
  #define LexReader_Close_t LUCY_LexReader_Close_t
  #define LexReader_Lexicon LUCY_LexReader_Lexicon
  #define LexReader_Lexicon_t LUCY_LexReader_Lexicon_t
  #define LexReader_Doc_Freq LUCY_LexReader_Doc_Freq
  #define LexReader_Doc_Freq_t LUCY_LexReader_Doc_Freq_t
  #define LexReader_Fetch_Term_Info LUCY_LexReader_Fetch_Term_Info
  #define LexReader_Fetch_Term_Info_t LUCY_LexReader_Fetch_Term_Info_t
#endif /* LUCY_USE_SHORT_NAMES */



/* Include the header for this class's parent. 
 */

#include "Lucy/Index/LexiconReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_POLYLEXICONREADER
extern size_t lucy_PolyLexReader_IVARS_OFFSET;
typedef struct lucy_PolyLexiconReaderIVARS lucy_PolyLexiconReaderIVARS;
static CFISH_INLINE lucy_PolyLexiconReaderIVARS*
lucy_PolyLexReader_IVARS(lucy_PolyLexiconReader *self) {
   char *ptr = (char*)self + lucy_PolyLexReader_IVARS_OFFSET;
   return (lucy_PolyLexiconReaderIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define PolyLexiconReaderIVARS lucy_PolyLexiconReaderIVARS
  #define PolyLexReader_IVARS lucy_PolyLexReader_IVARS
#endif

struct lucy_PolyLexiconReaderIVARS {
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    cfish_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    cfish_VArray* readers;
    lucy_I32Array* offsets;
};

#endif /* C_LUCY_POLYLEXICONREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_PolyLexiconReader*
lucy_PolyLexReader_new(cfish_VArray* readers, lucy_I32Array* offsets);

LUCY_VISIBLE lucy_PolyLexiconReader*
lucy_PolyLexReader_init(lucy_PolyLexiconReader* self, cfish_VArray* readers, lucy_I32Array* offsets);

void
LUCY_PolyLexReader_Destroy_IMP(lucy_PolyLexiconReader* self);

void
LUCY_PolyLexReader_Close_IMP(lucy_PolyLexiconReader* self);

lucy_Lexicon*
LUCY_PolyLexReader_Lexicon_IMP(lucy_PolyLexiconReader* self, cfish_String* field, cfish_Obj* term);

uint32_t
LUCY_PolyLexReader_Doc_Freq_IMP(lucy_PolyLexiconReader* self, cfish_String* field, cfish_Obj* term);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_PolyLexReader_Get_RefCount_t)(lucy_PolyLexiconReader *self);

typedef cfish_Obj*
(*LUCY_PolyLexReader_Inc_RefCount_t)(lucy_PolyLexiconReader *self);

typedef uint32_t
(*LUCY_PolyLexReader_Dec_RefCount_t)(lucy_PolyLexiconReader *self);

typedef void*
(*LUCY_PolyLexReader_To_Host_t)(lucy_PolyLexiconReader *self);

typedef cfish_Obj*
(*LUCY_PolyLexReader_Clone_t)(lucy_PolyLexiconReader *self);

typedef void
(*LUCY_PolyLexReader_Destroy_t)(lucy_PolyLexiconReader *self);

typedef bool
(*LUCY_PolyLexReader_Equals_t)(lucy_PolyLexiconReader *self, cfish_Obj* other);

typedef int32_t
(*LUCY_PolyLexReader_Compare_To_t)(lucy_PolyLexiconReader *self, cfish_Obj* other);

typedef int32_t
(*LUCY_PolyLexReader_Hash_Sum_t)(lucy_PolyLexiconReader *self);

typedef cfish_Class*
(*LUCY_PolyLexReader_Get_Class_t)(lucy_PolyLexiconReader *self);

typedef cfish_String*
(*LUCY_PolyLexReader_Get_Class_Name_t)(lucy_PolyLexiconReader *self);

typedef bool
(*LUCY_PolyLexReader_Is_A_t)(lucy_PolyLexiconReader *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_PolyLexReader_To_String_t)(lucy_PolyLexiconReader *self);

typedef int64_t
(*LUCY_PolyLexReader_To_I64_t)(lucy_PolyLexiconReader *self);

typedef double
(*LUCY_PolyLexReader_To_F64_t)(lucy_PolyLexiconReader *self);

typedef bool
(*LUCY_PolyLexReader_To_Bool_t)(lucy_PolyLexiconReader *self);

typedef void
(*LUCY_PolyLexReader_Mimic_t)(lucy_PolyLexiconReader *self, cfish_Obj* other);

typedef lucy_LexiconReader*
(*LUCY_PolyLexReader_Aggregator_t)(lucy_PolyLexiconReader *self, cfish_VArray* readers, lucy_I32Array* offsets);

typedef lucy_Schema*
(*LUCY_PolyLexReader_Get_Schema_t)(lucy_PolyLexiconReader *self);

typedef lucy_Folder*
(*LUCY_PolyLexReader_Get_Folder_t)(lucy_PolyLexiconReader *self);

typedef lucy_Snapshot*
(*LUCY_PolyLexReader_Get_Snapshot_t)(lucy_PolyLexiconReader *self);

typedef cfish_VArray*
(*LUCY_PolyLexReader_Get_Segments_t)(lucy_PolyLexiconReader *self);

typedef lucy_Segment*
(*LUCY_PolyLexReader_Get_Segment_t)(lucy_PolyLexiconReader *self);

typedef int32_t
(*LUCY_PolyLexReader_Get_Seg_Tick_t)(lucy_PolyLexiconReader *self);

typedef void
(*LUCY_PolyLexReader_Close_t)(lucy_PolyLexiconReader *self);

typedef lucy_Lexicon*
(*LUCY_PolyLexReader_Lexicon_t)(lucy_PolyLexiconReader *self, cfish_String* field, cfish_Obj* term);

typedef uint32_t
(*LUCY_PolyLexReader_Doc_Freq_t)(lucy_PolyLexiconReader *self, cfish_String* field, cfish_Obj* term);

typedef lucy_TermInfo*
(*LUCY_PolyLexReader_Fetch_Term_Info_t)(lucy_PolyLexiconReader *self, cfish_String* field, cfish_Obj* term);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_PolyLexReader_Get_RefCount(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Get_RefCount_t method = (LUCY_PolyLexReader_Get_RefCount_t)cfish_obj_method(self, LUCY_PolyLexReader_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_PolyLexReader_Inc_RefCount(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Inc_RefCount_t method = (LUCY_PolyLexReader_Inc_RefCount_t)cfish_obj_method(self, LUCY_PolyLexReader_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_PolyLexReader_Dec_RefCount(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Dec_RefCount_t method = (LUCY_PolyLexReader_Dec_RefCount_t)cfish_obj_method(self, LUCY_PolyLexReader_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_PolyLexReader_To_Host(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_To_Host_t method = (LUCY_PolyLexReader_To_Host_t)cfish_obj_method(self, LUCY_PolyLexReader_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_PolyLexReader_Clone(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Clone_t method = (LUCY_PolyLexReader_Clone_t)cfish_obj_method(self, LUCY_PolyLexReader_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_PolyLexReader_Destroy(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Destroy_t method = (LUCY_PolyLexReader_Destroy_t)cfish_obj_method(self, LUCY_PolyLexReader_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_PolyLexReader_Equals(lucy_PolyLexiconReader *self, cfish_Obj* other) {
    const LUCY_PolyLexReader_Equals_t method = (LUCY_PolyLexReader_Equals_t)cfish_obj_method(self, LUCY_PolyLexReader_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_PolyLexReader_Compare_To(lucy_PolyLexiconReader *self, cfish_Obj* other) {
    const LUCY_PolyLexReader_Compare_To_t method = (LUCY_PolyLexReader_Compare_To_t)cfish_obj_method(self, LUCY_PolyLexReader_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_PolyLexReader_Hash_Sum(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Hash_Sum_t method = (LUCY_PolyLexReader_Hash_Sum_t)cfish_obj_method(self, LUCY_PolyLexReader_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_PolyLexReader_Get_Class(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Get_Class_t method = (LUCY_PolyLexReader_Get_Class_t)cfish_obj_method(self, LUCY_PolyLexReader_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_PolyLexReader_Get_Class_Name(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Get_Class_Name_t method = (LUCY_PolyLexReader_Get_Class_Name_t)cfish_obj_method(self, LUCY_PolyLexReader_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_PolyLexReader_Is_A(lucy_PolyLexiconReader *self, cfish_Class* ancestor) {
    const LUCY_PolyLexReader_Is_A_t method = (LUCY_PolyLexReader_Is_A_t)cfish_obj_method(self, LUCY_PolyLexReader_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_PolyLexReader_To_String(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_To_String_t method = (LUCY_PolyLexReader_To_String_t)cfish_obj_method(self, LUCY_PolyLexReader_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_PolyLexReader_To_I64(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_To_I64_t method = (LUCY_PolyLexReader_To_I64_t)cfish_obj_method(self, LUCY_PolyLexReader_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_PolyLexReader_To_F64(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_To_F64_t method = (LUCY_PolyLexReader_To_F64_t)cfish_obj_method(self, LUCY_PolyLexReader_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_PolyLexReader_To_Bool(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_To_Bool_t method = (LUCY_PolyLexReader_To_Bool_t)cfish_obj_method(self, LUCY_PolyLexReader_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_PolyLexReader_Mimic(lucy_PolyLexiconReader *self, cfish_Obj* other) {
    const LUCY_PolyLexReader_Mimic_t method = (LUCY_PolyLexReader_Mimic_t)cfish_obj_method(self, LUCY_PolyLexReader_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Aggregator_OFFSET;
static CFISH_INLINE lucy_LexiconReader*
LUCY_PolyLexReader_Aggregator(lucy_PolyLexiconReader *self, cfish_VArray* readers, lucy_I32Array* offsets) {
    const LUCY_PolyLexReader_Aggregator_t method = (LUCY_PolyLexReader_Aggregator_t)cfish_obj_method(self, LUCY_PolyLexReader_Aggregator_OFFSET);
    return method(self, readers, offsets);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Get_Schema_OFFSET;
static CFISH_INLINE lucy_Schema*
LUCY_PolyLexReader_Get_Schema(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Get_Schema_t method = (LUCY_PolyLexReader_Get_Schema_t)cfish_obj_method(self, LUCY_PolyLexReader_Get_Schema_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Get_Folder_OFFSET;
static CFISH_INLINE lucy_Folder*
LUCY_PolyLexReader_Get_Folder(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Get_Folder_t method = (LUCY_PolyLexReader_Get_Folder_t)cfish_obj_method(self, LUCY_PolyLexReader_Get_Folder_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Get_Snapshot_OFFSET;
static CFISH_INLINE lucy_Snapshot*
LUCY_PolyLexReader_Get_Snapshot(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Get_Snapshot_t method = (LUCY_PolyLexReader_Get_Snapshot_t)cfish_obj_method(self, LUCY_PolyLexReader_Get_Snapshot_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Get_Segments_OFFSET;
static CFISH_INLINE cfish_VArray*
LUCY_PolyLexReader_Get_Segments(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Get_Segments_t method = (LUCY_PolyLexReader_Get_Segments_t)cfish_obj_method(self, LUCY_PolyLexReader_Get_Segments_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Get_Segment_OFFSET;
static CFISH_INLINE lucy_Segment*
LUCY_PolyLexReader_Get_Segment(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Get_Segment_t method = (LUCY_PolyLexReader_Get_Segment_t)cfish_obj_method(self, LUCY_PolyLexReader_Get_Segment_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Get_Seg_Tick_OFFSET;
static CFISH_INLINE int32_t
LUCY_PolyLexReader_Get_Seg_Tick(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Get_Seg_Tick_t method = (LUCY_PolyLexReader_Get_Seg_Tick_t)cfish_obj_method(self, LUCY_PolyLexReader_Get_Seg_Tick_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Close_OFFSET;
static CFISH_INLINE void
LUCY_PolyLexReader_Close(lucy_PolyLexiconReader *self) {
    const LUCY_PolyLexReader_Close_t method = (LUCY_PolyLexReader_Close_t)cfish_obj_method(self, LUCY_PolyLexReader_Close_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Lexicon_OFFSET;
static CFISH_INLINE lucy_Lexicon*
LUCY_PolyLexReader_Lexicon(lucy_PolyLexiconReader *self, cfish_String* field, cfish_Obj* term) {
    const LUCY_PolyLexReader_Lexicon_t method = (LUCY_PolyLexReader_Lexicon_t)cfish_obj_method(self, LUCY_PolyLexReader_Lexicon_OFFSET);
    return method(self, field, term);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Doc_Freq_OFFSET;
static CFISH_INLINE uint32_t
LUCY_PolyLexReader_Doc_Freq(lucy_PolyLexiconReader *self, cfish_String* field, cfish_Obj* term) {
    const LUCY_PolyLexReader_Doc_Freq_t method = (LUCY_PolyLexReader_Doc_Freq_t)cfish_obj_method(self, LUCY_PolyLexReader_Doc_Freq_OFFSET);
    return method(self, field, term);
}

extern LUCY_VISIBLE size_t LUCY_PolyLexReader_Fetch_Term_Info_OFFSET;
static CFISH_INLINE lucy_TermInfo*
LUCY_PolyLexReader_Fetch_Term_Info(lucy_PolyLexiconReader *self, cfish_String* field, cfish_Obj* term) {
    const LUCY_PolyLexReader_Fetch_Term_Info_t method = (LUCY_PolyLexReader_Fetch_Term_Info_t)cfish_obj_method(self, LUCY_PolyLexReader_Fetch_Term_Info_OFFSET);
    return method(self, field, term);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_POLYLEXICONREADER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PolyLexiconReader lucy_PolyLexiconReader
  #define POLYLEXICONREADER LUCY_POLYLEXICONREADER
  #define PolyLexReader_new lucy_PolyLexReader_new
  #define PolyLexReader_init lucy_PolyLexReader_init
  #define PolyLexReader_Destroy_IMP LUCY_PolyLexReader_Destroy_IMP
  #define PolyLexReader_Close_IMP LUCY_PolyLexReader_Close_IMP
  #define PolyLexReader_Lexicon_IMP LUCY_PolyLexReader_Lexicon_IMP
  #define PolyLexReader_Doc_Freq_IMP LUCY_PolyLexReader_Doc_Freq_IMP
  #define PolyLexReader_Get_RefCount LUCY_PolyLexReader_Get_RefCount
  #define PolyLexReader_Get_RefCount_t LUCY_PolyLexReader_Get_RefCount_t
  #define PolyLexReader_Inc_RefCount LUCY_PolyLexReader_Inc_RefCount
  #define PolyLexReader_Inc_RefCount_t LUCY_PolyLexReader_Inc_RefCount_t
  #define PolyLexReader_Dec_RefCount LUCY_PolyLexReader_Dec_RefCount
  #define PolyLexReader_Dec_RefCount_t LUCY_PolyLexReader_Dec_RefCount_t
  #define PolyLexReader_To_Host LUCY_PolyLexReader_To_Host
  #define PolyLexReader_To_Host_t LUCY_PolyLexReader_To_Host_t
  #define PolyLexReader_Clone LUCY_PolyLexReader_Clone
  #define PolyLexReader_Clone_t LUCY_PolyLexReader_Clone_t
  #define PolyLexReader_Destroy LUCY_PolyLexReader_Destroy
  #define PolyLexReader_Destroy_t LUCY_PolyLexReader_Destroy_t
  #define PolyLexReader_Equals LUCY_PolyLexReader_Equals
  #define PolyLexReader_Equals_t LUCY_PolyLexReader_Equals_t
  #define PolyLexReader_Compare_To LUCY_PolyLexReader_Compare_To
  #define PolyLexReader_Compare_To_t LUCY_PolyLexReader_Compare_To_t
  #define PolyLexReader_Hash_Sum LUCY_PolyLexReader_Hash_Sum
  #define PolyLexReader_Hash_Sum_t LUCY_PolyLexReader_Hash_Sum_t
  #define PolyLexReader_Get_Class LUCY_PolyLexReader_Get_Class
  #define PolyLexReader_Get_Class_t LUCY_PolyLexReader_Get_Class_t
  #define PolyLexReader_Get_Class_Name LUCY_PolyLexReader_Get_Class_Name
  #define PolyLexReader_Get_Class_Name_t LUCY_PolyLexReader_Get_Class_Name_t
  #define PolyLexReader_Is_A LUCY_PolyLexReader_Is_A
  #define PolyLexReader_Is_A_t LUCY_PolyLexReader_Is_A_t
  #define PolyLexReader_To_String LUCY_PolyLexReader_To_String
  #define PolyLexReader_To_String_t LUCY_PolyLexReader_To_String_t
  #define PolyLexReader_To_I64 LUCY_PolyLexReader_To_I64
  #define PolyLexReader_To_I64_t LUCY_PolyLexReader_To_I64_t
  #define PolyLexReader_To_F64 LUCY_PolyLexReader_To_F64
  #define PolyLexReader_To_F64_t LUCY_PolyLexReader_To_F64_t
  #define PolyLexReader_To_Bool LUCY_PolyLexReader_To_Bool
  #define PolyLexReader_To_Bool_t LUCY_PolyLexReader_To_Bool_t
  #define PolyLexReader_Mimic LUCY_PolyLexReader_Mimic
  #define PolyLexReader_Mimic_t LUCY_PolyLexReader_Mimic_t
  #define PolyLexReader_Aggregator LUCY_PolyLexReader_Aggregator
  #define PolyLexReader_Aggregator_t LUCY_PolyLexReader_Aggregator_t
  #define PolyLexReader_Get_Schema LUCY_PolyLexReader_Get_Schema
  #define PolyLexReader_Get_Schema_t LUCY_PolyLexReader_Get_Schema_t
  #define PolyLexReader_Get_Folder LUCY_PolyLexReader_Get_Folder
  #define PolyLexReader_Get_Folder_t LUCY_PolyLexReader_Get_Folder_t
  #define PolyLexReader_Get_Snapshot LUCY_PolyLexReader_Get_Snapshot
  #define PolyLexReader_Get_Snapshot_t LUCY_PolyLexReader_Get_Snapshot_t
  #define PolyLexReader_Get_Segments LUCY_PolyLexReader_Get_Segments
  #define PolyLexReader_Get_Segments_t LUCY_PolyLexReader_Get_Segments_t
  #define PolyLexReader_Get_Segment LUCY_PolyLexReader_Get_Segment
  #define PolyLexReader_Get_Segment_t LUCY_PolyLexReader_Get_Segment_t
  #define PolyLexReader_Get_Seg_Tick LUCY_PolyLexReader_Get_Seg_Tick
  #define PolyLexReader_Get_Seg_Tick_t LUCY_PolyLexReader_Get_Seg_Tick_t
  #define PolyLexReader_Close LUCY_PolyLexReader_Close
  #define PolyLexReader_Close_t LUCY_PolyLexReader_Close_t
  #define PolyLexReader_Lexicon LUCY_PolyLexReader_Lexicon
  #define PolyLexReader_Lexicon_t LUCY_PolyLexReader_Lexicon_t
  #define PolyLexReader_Doc_Freq LUCY_PolyLexReader_Doc_Freq
  #define PolyLexReader_Doc_Freq_t LUCY_PolyLexReader_Doc_Freq_t
  #define PolyLexReader_Fetch_Term_Info LUCY_PolyLexReader_Fetch_Term_Info
  #define PolyLexReader_Fetch_Term_Info_t LUCY_PolyLexReader_Fetch_Term_Info_t
#endif /* LUCY_USE_SHORT_NAMES */



/* Include the header for this class's parent. 
 */

#include "Lucy/Index/LexiconReader.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_DEFAULTLEXICONREADER
extern size_t lucy_DefLexReader_IVARS_OFFSET;
typedef struct lucy_DefaultLexiconReaderIVARS lucy_DefaultLexiconReaderIVARS;
static CFISH_INLINE lucy_DefaultLexiconReaderIVARS*
lucy_DefLexReader_IVARS(lucy_DefaultLexiconReader *self) {
   char *ptr = (char*)self + lucy_DefLexReader_IVARS_OFFSET;
   return (lucy_DefaultLexiconReaderIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define DefaultLexiconReaderIVARS lucy_DefaultLexiconReaderIVARS
  #define DefLexReader_IVARS lucy_DefLexReader_IVARS
#endif

struct lucy_DefaultLexiconReaderIVARS {
    lucy_Schema* schema;
    lucy_Folder* folder;
    lucy_Snapshot* snapshot;
    cfish_VArray* segments;
    lucy_Segment* segment;
    int32_t seg_tick;
    cfish_VArray* lexicons;
};

#endif /* C_LUCY_DEFAULTLEXICONREADER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_DefaultLexiconReader*
lucy_DefLexReader_new(lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, cfish_VArray* segments, int32_t seg_tick);

LUCY_VISIBLE lucy_DefaultLexiconReader*
lucy_DefLexReader_init(lucy_DefaultLexiconReader* self, lucy_Schema* schema, lucy_Folder* folder, lucy_Snapshot* snapshot, cfish_VArray* segments, int32_t seg_tick);

void
LUCY_DefLexReader_Destroy_IMP(lucy_DefaultLexiconReader* self);

void
LUCY_DefLexReader_Close_IMP(lucy_DefaultLexiconReader* self);

lucy_Lexicon*
LUCY_DefLexReader_Lexicon_IMP(lucy_DefaultLexiconReader* self, cfish_String* field, cfish_Obj* term);

uint32_t
LUCY_DefLexReader_Doc_Freq_IMP(lucy_DefaultLexiconReader* self, cfish_String* field, cfish_Obj* term);

lucy_TermInfo*
LUCY_DefLexReader_Fetch_Term_Info_IMP(lucy_DefaultLexiconReader* self, cfish_String* field, cfish_Obj* term);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_DefLexReader_Get_RefCount_t)(lucy_DefaultLexiconReader *self);

typedef cfish_Obj*
(*LUCY_DefLexReader_Inc_RefCount_t)(lucy_DefaultLexiconReader *self);

typedef uint32_t
(*LUCY_DefLexReader_Dec_RefCount_t)(lucy_DefaultLexiconReader *self);

typedef void*
(*LUCY_DefLexReader_To_Host_t)(lucy_DefaultLexiconReader *self);

typedef cfish_Obj*
(*LUCY_DefLexReader_Clone_t)(lucy_DefaultLexiconReader *self);

typedef void
(*LUCY_DefLexReader_Destroy_t)(lucy_DefaultLexiconReader *self);

typedef bool
(*LUCY_DefLexReader_Equals_t)(lucy_DefaultLexiconReader *self, cfish_Obj* other);

typedef int32_t
(*LUCY_DefLexReader_Compare_To_t)(lucy_DefaultLexiconReader *self, cfish_Obj* other);

typedef int32_t
(*LUCY_DefLexReader_Hash_Sum_t)(lucy_DefaultLexiconReader *self);

typedef cfish_Class*
(*LUCY_DefLexReader_Get_Class_t)(lucy_DefaultLexiconReader *self);

typedef cfish_String*
(*LUCY_DefLexReader_Get_Class_Name_t)(lucy_DefaultLexiconReader *self);

typedef bool
(*LUCY_DefLexReader_Is_A_t)(lucy_DefaultLexiconReader *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_DefLexReader_To_String_t)(lucy_DefaultLexiconReader *self);

typedef int64_t
(*LUCY_DefLexReader_To_I64_t)(lucy_DefaultLexiconReader *self);

typedef double
(*LUCY_DefLexReader_To_F64_t)(lucy_DefaultLexiconReader *self);

typedef bool
(*LUCY_DefLexReader_To_Bool_t)(lucy_DefaultLexiconReader *self);

typedef void
(*LUCY_DefLexReader_Mimic_t)(lucy_DefaultLexiconReader *self, cfish_Obj* other);

typedef lucy_LexiconReader*
(*LUCY_DefLexReader_Aggregator_t)(lucy_DefaultLexiconReader *self, cfish_VArray* readers, lucy_I32Array* offsets);

typedef lucy_Schema*
(*LUCY_DefLexReader_Get_Schema_t)(lucy_DefaultLexiconReader *self);

typedef lucy_Folder*
(*LUCY_DefLexReader_Get_Folder_t)(lucy_DefaultLexiconReader *self);

typedef lucy_Snapshot*
(*LUCY_DefLexReader_Get_Snapshot_t)(lucy_DefaultLexiconReader *self);

typedef cfish_VArray*
(*LUCY_DefLexReader_Get_Segments_t)(lucy_DefaultLexiconReader *self);

typedef lucy_Segment*
(*LUCY_DefLexReader_Get_Segment_t)(lucy_DefaultLexiconReader *self);

typedef int32_t
(*LUCY_DefLexReader_Get_Seg_Tick_t)(lucy_DefaultLexiconReader *self);

typedef void
(*LUCY_DefLexReader_Close_t)(lucy_DefaultLexiconReader *self);

typedef lucy_Lexicon*
(*LUCY_DefLexReader_Lexicon_t)(lucy_DefaultLexiconReader *self, cfish_String* field, cfish_Obj* term);

typedef uint32_t
(*LUCY_DefLexReader_Doc_Freq_t)(lucy_DefaultLexiconReader *self, cfish_String* field, cfish_Obj* term);

typedef lucy_TermInfo*
(*LUCY_DefLexReader_Fetch_Term_Info_t)(lucy_DefaultLexiconReader *self, cfish_String* field, cfish_Obj* term);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_DefLexReader_Get_RefCount(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Get_RefCount_t method = (LUCY_DefLexReader_Get_RefCount_t)cfish_obj_method(self, LUCY_DefLexReader_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_DefLexReader_Inc_RefCount(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Inc_RefCount_t method = (LUCY_DefLexReader_Inc_RefCount_t)cfish_obj_method(self, LUCY_DefLexReader_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_DefLexReader_Dec_RefCount(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Dec_RefCount_t method = (LUCY_DefLexReader_Dec_RefCount_t)cfish_obj_method(self, LUCY_DefLexReader_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_DefLexReader_To_Host(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_To_Host_t method = (LUCY_DefLexReader_To_Host_t)cfish_obj_method(self, LUCY_DefLexReader_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_DefLexReader_Clone(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Clone_t method = (LUCY_DefLexReader_Clone_t)cfish_obj_method(self, LUCY_DefLexReader_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_DefLexReader_Destroy(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Destroy_t method = (LUCY_DefLexReader_Destroy_t)cfish_obj_method(self, LUCY_DefLexReader_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_DefLexReader_Equals(lucy_DefaultLexiconReader *self, cfish_Obj* other) {
    const LUCY_DefLexReader_Equals_t method = (LUCY_DefLexReader_Equals_t)cfish_obj_method(self, LUCY_DefLexReader_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_DefLexReader_Compare_To(lucy_DefaultLexiconReader *self, cfish_Obj* other) {
    const LUCY_DefLexReader_Compare_To_t method = (LUCY_DefLexReader_Compare_To_t)cfish_obj_method(self, LUCY_DefLexReader_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_DefLexReader_Hash_Sum(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Hash_Sum_t method = (LUCY_DefLexReader_Hash_Sum_t)cfish_obj_method(self, LUCY_DefLexReader_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_DefLexReader_Get_Class(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Get_Class_t method = (LUCY_DefLexReader_Get_Class_t)cfish_obj_method(self, LUCY_DefLexReader_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_DefLexReader_Get_Class_Name(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Get_Class_Name_t method = (LUCY_DefLexReader_Get_Class_Name_t)cfish_obj_method(self, LUCY_DefLexReader_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_DefLexReader_Is_A(lucy_DefaultLexiconReader *self, cfish_Class* ancestor) {
    const LUCY_DefLexReader_Is_A_t method = (LUCY_DefLexReader_Is_A_t)cfish_obj_method(self, LUCY_DefLexReader_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_DefLexReader_To_String(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_To_String_t method = (LUCY_DefLexReader_To_String_t)cfish_obj_method(self, LUCY_DefLexReader_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_DefLexReader_To_I64(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_To_I64_t method = (LUCY_DefLexReader_To_I64_t)cfish_obj_method(self, LUCY_DefLexReader_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_DefLexReader_To_F64(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_To_F64_t method = (LUCY_DefLexReader_To_F64_t)cfish_obj_method(self, LUCY_DefLexReader_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_DefLexReader_To_Bool(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_To_Bool_t method = (LUCY_DefLexReader_To_Bool_t)cfish_obj_method(self, LUCY_DefLexReader_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_DefLexReader_Mimic(lucy_DefaultLexiconReader *self, cfish_Obj* other) {
    const LUCY_DefLexReader_Mimic_t method = (LUCY_DefLexReader_Mimic_t)cfish_obj_method(self, LUCY_DefLexReader_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Aggregator_OFFSET;
static CFISH_INLINE lucy_LexiconReader*
LUCY_DefLexReader_Aggregator(lucy_DefaultLexiconReader *self, cfish_VArray* readers, lucy_I32Array* offsets) {
    const LUCY_DefLexReader_Aggregator_t method = (LUCY_DefLexReader_Aggregator_t)cfish_obj_method(self, LUCY_DefLexReader_Aggregator_OFFSET);
    return method(self, readers, offsets);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Get_Schema_OFFSET;
static CFISH_INLINE lucy_Schema*
LUCY_DefLexReader_Get_Schema(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Get_Schema_t method = (LUCY_DefLexReader_Get_Schema_t)cfish_obj_method(self, LUCY_DefLexReader_Get_Schema_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Get_Folder_OFFSET;
static CFISH_INLINE lucy_Folder*
LUCY_DefLexReader_Get_Folder(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Get_Folder_t method = (LUCY_DefLexReader_Get_Folder_t)cfish_obj_method(self, LUCY_DefLexReader_Get_Folder_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Get_Snapshot_OFFSET;
static CFISH_INLINE lucy_Snapshot*
LUCY_DefLexReader_Get_Snapshot(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Get_Snapshot_t method = (LUCY_DefLexReader_Get_Snapshot_t)cfish_obj_method(self, LUCY_DefLexReader_Get_Snapshot_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Get_Segments_OFFSET;
static CFISH_INLINE cfish_VArray*
LUCY_DefLexReader_Get_Segments(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Get_Segments_t method = (LUCY_DefLexReader_Get_Segments_t)cfish_obj_method(self, LUCY_DefLexReader_Get_Segments_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Get_Segment_OFFSET;
static CFISH_INLINE lucy_Segment*
LUCY_DefLexReader_Get_Segment(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Get_Segment_t method = (LUCY_DefLexReader_Get_Segment_t)cfish_obj_method(self, LUCY_DefLexReader_Get_Segment_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Get_Seg_Tick_OFFSET;
static CFISH_INLINE int32_t
LUCY_DefLexReader_Get_Seg_Tick(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Get_Seg_Tick_t method = (LUCY_DefLexReader_Get_Seg_Tick_t)cfish_obj_method(self, LUCY_DefLexReader_Get_Seg_Tick_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Close_OFFSET;
static CFISH_INLINE void
LUCY_DefLexReader_Close(lucy_DefaultLexiconReader *self) {
    const LUCY_DefLexReader_Close_t method = (LUCY_DefLexReader_Close_t)cfish_obj_method(self, LUCY_DefLexReader_Close_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Lexicon_OFFSET;
static CFISH_INLINE lucy_Lexicon*
LUCY_DefLexReader_Lexicon(lucy_DefaultLexiconReader *self, cfish_String* field, cfish_Obj* term) {
    const LUCY_DefLexReader_Lexicon_t method = (LUCY_DefLexReader_Lexicon_t)cfish_obj_method(self, LUCY_DefLexReader_Lexicon_OFFSET);
    return method(self, field, term);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Doc_Freq_OFFSET;
static CFISH_INLINE uint32_t
LUCY_DefLexReader_Doc_Freq(lucy_DefaultLexiconReader *self, cfish_String* field, cfish_Obj* term) {
    const LUCY_DefLexReader_Doc_Freq_t method = (LUCY_DefLexReader_Doc_Freq_t)cfish_obj_method(self, LUCY_DefLexReader_Doc_Freq_OFFSET);
    return method(self, field, term);
}

extern LUCY_VISIBLE size_t LUCY_DefLexReader_Fetch_Term_Info_OFFSET;
static CFISH_INLINE lucy_TermInfo*
LUCY_DefLexReader_Fetch_Term_Info(lucy_DefaultLexiconReader *self, cfish_String* field, cfish_Obj* term) {
    const LUCY_DefLexReader_Fetch_Term_Info_t method = (LUCY_DefLexReader_Fetch_Term_Info_t)cfish_obj_method(self, LUCY_DefLexReader_Fetch_Term_Info_OFFSET);
    return method(self, field, term);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_DEFAULTLEXICONREADER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define DefaultLexiconReader lucy_DefaultLexiconReader
  #define DEFAULTLEXICONREADER LUCY_DEFAULTLEXICONREADER
  #define DefLexReader_new lucy_DefLexReader_new
  #define DefLexReader_init lucy_DefLexReader_init
  #define DefLexReader_Destroy_IMP LUCY_DefLexReader_Destroy_IMP
  #define DefLexReader_Close_IMP LUCY_DefLexReader_Close_IMP
  #define DefLexReader_Lexicon_IMP LUCY_DefLexReader_Lexicon_IMP
  #define DefLexReader_Doc_Freq_IMP LUCY_DefLexReader_Doc_Freq_IMP
  #define DefLexReader_Fetch_Term_Info_IMP LUCY_DefLexReader_Fetch_Term_Info_IMP
  #define DefLexReader_Get_RefCount LUCY_DefLexReader_Get_RefCount
  #define DefLexReader_Get_RefCount_t LUCY_DefLexReader_Get_RefCount_t
  #define DefLexReader_Inc_RefCount LUCY_DefLexReader_Inc_RefCount
  #define DefLexReader_Inc_RefCount_t LUCY_DefLexReader_Inc_RefCount_t
  #define DefLexReader_Dec_RefCount LUCY_DefLexReader_Dec_RefCount
  #define DefLexReader_Dec_RefCount_t LUCY_DefLexReader_Dec_RefCount_t
  #define DefLexReader_To_Host LUCY_DefLexReader_To_Host
  #define DefLexReader_To_Host_t LUCY_DefLexReader_To_Host_t
  #define DefLexReader_Clone LUCY_DefLexReader_Clone
  #define DefLexReader_Clone_t LUCY_DefLexReader_Clone_t
  #define DefLexReader_Destroy LUCY_DefLexReader_Destroy
  #define DefLexReader_Destroy_t LUCY_DefLexReader_Destroy_t
  #define DefLexReader_Equals LUCY_DefLexReader_Equals
  #define DefLexReader_Equals_t LUCY_DefLexReader_Equals_t
  #define DefLexReader_Compare_To LUCY_DefLexReader_Compare_To
  #define DefLexReader_Compare_To_t LUCY_DefLexReader_Compare_To_t
  #define DefLexReader_Hash_Sum LUCY_DefLexReader_Hash_Sum
  #define DefLexReader_Hash_Sum_t LUCY_DefLexReader_Hash_Sum_t
  #define DefLexReader_Get_Class LUCY_DefLexReader_Get_Class
  #define DefLexReader_Get_Class_t LUCY_DefLexReader_Get_Class_t
  #define DefLexReader_Get_Class_Name LUCY_DefLexReader_Get_Class_Name
  #define DefLexReader_Get_Class_Name_t LUCY_DefLexReader_Get_Class_Name_t
  #define DefLexReader_Is_A LUCY_DefLexReader_Is_A
  #define DefLexReader_Is_A_t LUCY_DefLexReader_Is_A_t
  #define DefLexReader_To_String LUCY_DefLexReader_To_String
  #define DefLexReader_To_String_t LUCY_DefLexReader_To_String_t
  #define DefLexReader_To_I64 LUCY_DefLexReader_To_I64
  #define DefLexReader_To_I64_t LUCY_DefLexReader_To_I64_t
  #define DefLexReader_To_F64 LUCY_DefLexReader_To_F64
  #define DefLexReader_To_F64_t LUCY_DefLexReader_To_F64_t
  #define DefLexReader_To_Bool LUCY_DefLexReader_To_Bool
  #define DefLexReader_To_Bool_t LUCY_DefLexReader_To_Bool_t
  #define DefLexReader_Mimic LUCY_DefLexReader_Mimic
  #define DefLexReader_Mimic_t LUCY_DefLexReader_Mimic_t
  #define DefLexReader_Aggregator LUCY_DefLexReader_Aggregator
  #define DefLexReader_Aggregator_t LUCY_DefLexReader_Aggregator_t
  #define DefLexReader_Get_Schema LUCY_DefLexReader_Get_Schema
  #define DefLexReader_Get_Schema_t LUCY_DefLexReader_Get_Schema_t
  #define DefLexReader_Get_Folder LUCY_DefLexReader_Get_Folder
  #define DefLexReader_Get_Folder_t LUCY_DefLexReader_Get_Folder_t
  #define DefLexReader_Get_Snapshot LUCY_DefLexReader_Get_Snapshot
  #define DefLexReader_Get_Snapshot_t LUCY_DefLexReader_Get_Snapshot_t
  #define DefLexReader_Get_Segments LUCY_DefLexReader_Get_Segments
  #define DefLexReader_Get_Segments_t LUCY_DefLexReader_Get_Segments_t
  #define DefLexReader_Get_Segment LUCY_DefLexReader_Get_Segment
  #define DefLexReader_Get_Segment_t LUCY_DefLexReader_Get_Segment_t
  #define DefLexReader_Get_Seg_Tick LUCY_DefLexReader_Get_Seg_Tick
  #define DefLexReader_Get_Seg_Tick_t LUCY_DefLexReader_Get_Seg_Tick_t
  #define DefLexReader_Close LUCY_DefLexReader_Close
  #define DefLexReader_Close_t LUCY_DefLexReader_Close_t
  #define DefLexReader_Lexicon LUCY_DefLexReader_Lexicon
  #define DefLexReader_Lexicon_t LUCY_DefLexReader_Lexicon_t
  #define DefLexReader_Doc_Freq LUCY_DefLexReader_Doc_Freq
  #define DefLexReader_Doc_Freq_t LUCY_DefLexReader_Doc_Freq_t
  #define DefLexReader_Fetch_Term_Info LUCY_DefLexReader_Fetch_Term_Info
  #define DefLexReader_Fetch_Term_Info_t LUCY_DefLexReader_Fetch_Term_Info_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_LEXICONREADER */




