/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SEGMENT
#define H_LUCY_INDEX_SEGMENT 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SEGMENT
extern size_t lucy_Seg_IVARS_OFFSET;
typedef struct lucy_SegmentIVARS lucy_SegmentIVARS;
static CFISH_INLINE lucy_SegmentIVARS*
lucy_Seg_IVARS(lucy_Segment *self) {
   char *ptr = (char*)self + lucy_Seg_IVARS_OFFSET;
   return (lucy_SegmentIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define SegmentIVARS lucy_SegmentIVARS
  #define Seg_IVARS lucy_Seg_IVARS
#endif

struct lucy_SegmentIVARS {
    cfish_String* name;
    int64_t count;
    int64_t number;
    cfish_Hash* by_name;
    cfish_VArray* by_num;
    cfish_Hash* metadata;
};

#endif /* C_LUCY_SEGMENT */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_Segment*
lucy_Seg_new(int64_t number);

LUCY_VISIBLE lucy_Segment*
lucy_Seg_init(lucy_Segment* self, int64_t number);

LUCY_VISIBLE cfish_String*
lucy_Seg_num_to_name(int64_t number);

LUCY_VISIBLE bool
lucy_Seg_valid_seg_name(cfish_String* name);

void
LUCY_Seg_Destroy_IMP(lucy_Segment* self);

int32_t
LUCY_Seg_Compare_To_IMP(lucy_Segment* self, cfish_Obj* other);

int32_t
LUCY_Seg_Add_Field_IMP(lucy_Segment* self, cfish_String* field);

void
LUCY_Seg_Store_Metadata_IMP(lucy_Segment* self, cfish_String* key, cfish_Obj* metadata);

void
LUCY_Seg_Store_Metadata_Utf8_IMP(lucy_Segment* self, const char* key, size_t len, cfish_Obj* value);

cfish_Obj*
LUCY_Seg_Fetch_Metadata_IMP(lucy_Segment* self, cfish_String* key);

cfish_Obj*
LUCY_Seg_Fetch_Metadata_Utf8_IMP(lucy_Segment* self, const char* key, size_t len);

int32_t
LUCY_Seg_Field_Num_IMP(lucy_Segment* self, cfish_String* field);

cfish_String*
LUCY_Seg_Field_Name_IMP(lucy_Segment* self, int32_t field_num);

cfish_String*
LUCY_Seg_Get_Name_IMP(lucy_Segment* self);

int64_t
LUCY_Seg_Get_Number_IMP(lucy_Segment* self);

void
LUCY_Seg_Set_Count_IMP(lucy_Segment* self, int64_t count);

int64_t
LUCY_Seg_Get_Count_IMP(lucy_Segment* self);

int64_t
LUCY_Seg_Increment_Count_IMP(lucy_Segment* self, int64_t increment);

cfish_Hash*
LUCY_Seg_Get_Metadata_IMP(lucy_Segment* self);

void
LUCY_Seg_Write_File_IMP(lucy_Segment* self, lucy_Folder* folder);

bool
LUCY_Seg_Read_File_IMP(lucy_Segment* self, lucy_Folder* folder);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_Seg_Get_RefCount_t)(lucy_Segment *self);

typedef cfish_Obj*
(*LUCY_Seg_Inc_RefCount_t)(lucy_Segment *self);

typedef uint32_t
(*LUCY_Seg_Dec_RefCount_t)(lucy_Segment *self);

typedef void*
(*LUCY_Seg_To_Host_t)(lucy_Segment *self);

typedef cfish_Obj*
(*LUCY_Seg_Clone_t)(lucy_Segment *self);

typedef void
(*LUCY_Seg_Destroy_t)(lucy_Segment *self);

typedef bool
(*LUCY_Seg_Equals_t)(lucy_Segment *self, cfish_Obj* other);

typedef int32_t
(*LUCY_Seg_Compare_To_t)(lucy_Segment *self, cfish_Obj* other);

typedef int32_t
(*LUCY_Seg_Hash_Sum_t)(lucy_Segment *self);

typedef cfish_Class*
(*LUCY_Seg_Get_Class_t)(lucy_Segment *self);

typedef cfish_String*
(*LUCY_Seg_Get_Class_Name_t)(lucy_Segment *self);

typedef bool
(*LUCY_Seg_Is_A_t)(lucy_Segment *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_Seg_To_String_t)(lucy_Segment *self);

typedef int64_t
(*LUCY_Seg_To_I64_t)(lucy_Segment *self);

typedef double
(*LUCY_Seg_To_F64_t)(lucy_Segment *self);

typedef bool
(*LUCY_Seg_To_Bool_t)(lucy_Segment *self);

typedef void
(*LUCY_Seg_Mimic_t)(lucy_Segment *self, cfish_Obj* other);

typedef int32_t
(*LUCY_Seg_Add_Field_t)(lucy_Segment *self, cfish_String* field);

typedef void
(*LUCY_Seg_Store_Metadata_t)(lucy_Segment *self, cfish_String* key, cfish_Obj* metadata);

typedef void
(*LUCY_Seg_Store_Metadata_Utf8_t)(lucy_Segment *self, const char* key, size_t len, cfish_Obj* value);

typedef cfish_Obj*
(*LUCY_Seg_Fetch_Metadata_t)(lucy_Segment *self, cfish_String* key);

typedef cfish_Obj*
(*LUCY_Seg_Fetch_Metadata_Utf8_t)(lucy_Segment *self, const char* key, size_t len);

typedef int32_t
(*LUCY_Seg_Field_Num_t)(lucy_Segment *self, cfish_String* field);

typedef cfish_String*
(*LUCY_Seg_Field_Name_t)(lucy_Segment *self, int32_t field_num);

typedef cfish_String*
(*LUCY_Seg_Get_Name_t)(lucy_Segment *self);

typedef int64_t
(*LUCY_Seg_Get_Number_t)(lucy_Segment *self);

typedef void
(*LUCY_Seg_Set_Count_t)(lucy_Segment *self, int64_t count);

typedef int64_t
(*LUCY_Seg_Get_Count_t)(lucy_Segment *self);

typedef int64_t
(*LUCY_Seg_Increment_Count_t)(lucy_Segment *self, int64_t increment);

typedef cfish_Hash*
(*LUCY_Seg_Get_Metadata_t)(lucy_Segment *self);

typedef void
(*LUCY_Seg_Write_File_t)(lucy_Segment *self, lucy_Folder* folder);

typedef bool
(*LUCY_Seg_Read_File_t)(lucy_Segment *self, lucy_Folder* folder);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_Seg_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_Seg_Get_RefCount(lucy_Segment *self) {
    const LUCY_Seg_Get_RefCount_t method = (LUCY_Seg_Get_RefCount_t)cfish_obj_method(self, LUCY_Seg_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_Seg_Inc_RefCount(lucy_Segment *self) {
    const LUCY_Seg_Inc_RefCount_t method = (LUCY_Seg_Inc_RefCount_t)cfish_obj_method(self, LUCY_Seg_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_Seg_Dec_RefCount(lucy_Segment *self) {
    const LUCY_Seg_Dec_RefCount_t method = (LUCY_Seg_Dec_RefCount_t)cfish_obj_method(self, LUCY_Seg_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_Seg_To_Host(lucy_Segment *self) {
    const LUCY_Seg_To_Host_t method = (LUCY_Seg_To_Host_t)cfish_obj_method(self, LUCY_Seg_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_Seg_Clone(lucy_Segment *self) {
    const LUCY_Seg_Clone_t method = (LUCY_Seg_Clone_t)cfish_obj_method(self, LUCY_Seg_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_Seg_Destroy(lucy_Segment *self) {
    const LUCY_Seg_Destroy_t method = (LUCY_Seg_Destroy_t)cfish_obj_method(self, LUCY_Seg_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_Seg_Equals(lucy_Segment *self, cfish_Obj* other) {
    const LUCY_Seg_Equals_t method = (LUCY_Seg_Equals_t)cfish_obj_method(self, LUCY_Seg_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_Seg_Compare_To(lucy_Segment *self, cfish_Obj* other) {
    const LUCY_Seg_Compare_To_t method = (LUCY_Seg_Compare_To_t)cfish_obj_method(self, LUCY_Seg_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_Seg_Hash_Sum(lucy_Segment *self) {
    const LUCY_Seg_Hash_Sum_t method = (LUCY_Seg_Hash_Sum_t)cfish_obj_method(self, LUCY_Seg_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_Seg_Get_Class(lucy_Segment *self) {
    const LUCY_Seg_Get_Class_t method = (LUCY_Seg_Get_Class_t)cfish_obj_method(self, LUCY_Seg_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_Seg_Get_Class_Name(lucy_Segment *self) {
    const LUCY_Seg_Get_Class_Name_t method = (LUCY_Seg_Get_Class_Name_t)cfish_obj_method(self, LUCY_Seg_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_Seg_Is_A(lucy_Segment *self, cfish_Class* ancestor) {
    const LUCY_Seg_Is_A_t method = (LUCY_Seg_Is_A_t)cfish_obj_method(self, LUCY_Seg_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_Seg_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_Seg_To_String(lucy_Segment *self) {
    const LUCY_Seg_To_String_t method = (LUCY_Seg_To_String_t)cfish_obj_method(self, LUCY_Seg_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_Seg_To_I64(lucy_Segment *self) {
    const LUCY_Seg_To_I64_t method = (LUCY_Seg_To_I64_t)cfish_obj_method(self, LUCY_Seg_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_Seg_To_F64(lucy_Segment *self) {
    const LUCY_Seg_To_F64_t method = (LUCY_Seg_To_F64_t)cfish_obj_method(self, LUCY_Seg_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_Seg_To_Bool(lucy_Segment *self) {
    const LUCY_Seg_To_Bool_t method = (LUCY_Seg_To_Bool_t)cfish_obj_method(self, LUCY_Seg_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_Seg_Mimic(lucy_Segment *self, cfish_Obj* other) {
    const LUCY_Seg_Mimic_t method = (LUCY_Seg_Mimic_t)cfish_obj_method(self, LUCY_Seg_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Add_Field_OFFSET;
static CFISH_INLINE int32_t
LUCY_Seg_Add_Field(lucy_Segment *self, cfish_String* field) {
    const LUCY_Seg_Add_Field_t method = (LUCY_Seg_Add_Field_t)cfish_obj_method(self, LUCY_Seg_Add_Field_OFFSET);
    return method(self, field);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Store_Metadata_OFFSET;
static CFISH_INLINE void
LUCY_Seg_Store_Metadata(lucy_Segment *self, cfish_String* key, cfish_Obj* metadata) {
    const LUCY_Seg_Store_Metadata_t method = (LUCY_Seg_Store_Metadata_t)cfish_obj_method(self, LUCY_Seg_Store_Metadata_OFFSET);
    method(self, key, metadata);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Store_Metadata_Utf8_OFFSET;
static CFISH_INLINE void
LUCY_Seg_Store_Metadata_Utf8(lucy_Segment *self, const char* key, size_t len, cfish_Obj* value) {
    const LUCY_Seg_Store_Metadata_Utf8_t method = (LUCY_Seg_Store_Metadata_Utf8_t)cfish_obj_method(self, LUCY_Seg_Store_Metadata_Utf8_OFFSET);
    method(self, key, len, value);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Fetch_Metadata_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_Seg_Fetch_Metadata(lucy_Segment *self, cfish_String* key) {
    const LUCY_Seg_Fetch_Metadata_t method = (LUCY_Seg_Fetch_Metadata_t)cfish_obj_method(self, LUCY_Seg_Fetch_Metadata_OFFSET);
    return method(self, key);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Fetch_Metadata_Utf8_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_Seg_Fetch_Metadata_Utf8(lucy_Segment *self, const char* key, size_t len) {
    const LUCY_Seg_Fetch_Metadata_Utf8_t method = (LUCY_Seg_Fetch_Metadata_Utf8_t)cfish_obj_method(self, LUCY_Seg_Fetch_Metadata_Utf8_OFFSET);
    return method(self, key, len);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Field_Num_OFFSET;
static CFISH_INLINE int32_t
LUCY_Seg_Field_Num(lucy_Segment *self, cfish_String* field) {
    const LUCY_Seg_Field_Num_t method = (LUCY_Seg_Field_Num_t)cfish_obj_method(self, LUCY_Seg_Field_Num_OFFSET);
    return method(self, field);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Field_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_Seg_Field_Name(lucy_Segment *self, int32_t field_num) {
    const LUCY_Seg_Field_Name_t method = (LUCY_Seg_Field_Name_t)cfish_obj_method(self, LUCY_Seg_Field_Name_OFFSET);
    return method(self, field_num);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Get_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_Seg_Get_Name(lucy_Segment *self) {
    const LUCY_Seg_Get_Name_t method = (LUCY_Seg_Get_Name_t)cfish_obj_method(self, LUCY_Seg_Get_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Get_Number_OFFSET;
static CFISH_INLINE int64_t
LUCY_Seg_Get_Number(lucy_Segment *self) {
    const LUCY_Seg_Get_Number_t method = (LUCY_Seg_Get_Number_t)cfish_obj_method(self, LUCY_Seg_Get_Number_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Set_Count_OFFSET;
static CFISH_INLINE void
LUCY_Seg_Set_Count(lucy_Segment *self, int64_t count) {
    const LUCY_Seg_Set_Count_t method = (LUCY_Seg_Set_Count_t)cfish_obj_method(self, LUCY_Seg_Set_Count_OFFSET);
    method(self, count);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Get_Count_OFFSET;
static CFISH_INLINE int64_t
LUCY_Seg_Get_Count(lucy_Segment *self) {
    const LUCY_Seg_Get_Count_t method = (LUCY_Seg_Get_Count_t)cfish_obj_method(self, LUCY_Seg_Get_Count_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Increment_Count_OFFSET;
static CFISH_INLINE int64_t
LUCY_Seg_Increment_Count(lucy_Segment *self, int64_t increment) {
    const LUCY_Seg_Increment_Count_t method = (LUCY_Seg_Increment_Count_t)cfish_obj_method(self, LUCY_Seg_Increment_Count_OFFSET);
    return method(self, increment);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Get_Metadata_OFFSET;
static CFISH_INLINE cfish_Hash*
LUCY_Seg_Get_Metadata(lucy_Segment *self) {
    const LUCY_Seg_Get_Metadata_t method = (LUCY_Seg_Get_Metadata_t)cfish_obj_method(self, LUCY_Seg_Get_Metadata_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Write_File_OFFSET;
static CFISH_INLINE void
LUCY_Seg_Write_File(lucy_Segment *self, lucy_Folder* folder) {
    const LUCY_Seg_Write_File_t method = (LUCY_Seg_Write_File_t)cfish_obj_method(self, LUCY_Seg_Write_File_OFFSET);
    method(self, folder);
}

extern LUCY_VISIBLE size_t LUCY_Seg_Read_File_OFFSET;
static CFISH_INLINE bool
LUCY_Seg_Read_File(lucy_Segment *self, lucy_Folder* folder) {
    const LUCY_Seg_Read_File_t method = (LUCY_Seg_Read_File_t)cfish_obj_method(self, LUCY_Seg_Read_File_OFFSET);
    return method(self, folder);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_SEGMENT;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Segment lucy_Segment
  #define SEGMENT LUCY_SEGMENT
  #define Seg_new lucy_Seg_new
  #define Seg_init lucy_Seg_init
  #define Seg_num_to_name lucy_Seg_num_to_name
  #define Seg_valid_seg_name lucy_Seg_valid_seg_name
  #define Seg_Destroy_IMP LUCY_Seg_Destroy_IMP
  #define Seg_Compare_To_IMP LUCY_Seg_Compare_To_IMP
  #define Seg_Add_Field_IMP LUCY_Seg_Add_Field_IMP
  #define Seg_Store_Metadata_IMP LUCY_Seg_Store_Metadata_IMP
  #define Seg_Store_Metadata_Utf8_IMP LUCY_Seg_Store_Metadata_Utf8_IMP
  #define Seg_Fetch_Metadata_IMP LUCY_Seg_Fetch_Metadata_IMP
  #define Seg_Fetch_Metadata_Utf8_IMP LUCY_Seg_Fetch_Metadata_Utf8_IMP
  #define Seg_Field_Num_IMP LUCY_Seg_Field_Num_IMP
  #define Seg_Field_Name_IMP LUCY_Seg_Field_Name_IMP
  #define Seg_Get_Name_IMP LUCY_Seg_Get_Name_IMP
  #define Seg_Get_Number_IMP LUCY_Seg_Get_Number_IMP
  #define Seg_Set_Count_IMP LUCY_Seg_Set_Count_IMP
  #define Seg_Get_Count_IMP LUCY_Seg_Get_Count_IMP
  #define Seg_Increment_Count_IMP LUCY_Seg_Increment_Count_IMP
  #define Seg_Get_Metadata_IMP LUCY_Seg_Get_Metadata_IMP
  #define Seg_Write_File_IMP LUCY_Seg_Write_File_IMP
  #define Seg_Read_File_IMP LUCY_Seg_Read_File_IMP
  #define Seg_Get_RefCount LUCY_Seg_Get_RefCount
  #define Seg_Get_RefCount_t LUCY_Seg_Get_RefCount_t
  #define Seg_Inc_RefCount LUCY_Seg_Inc_RefCount
  #define Seg_Inc_RefCount_t LUCY_Seg_Inc_RefCount_t
  #define Seg_Dec_RefCount LUCY_Seg_Dec_RefCount
  #define Seg_Dec_RefCount_t LUCY_Seg_Dec_RefCount_t
  #define Seg_To_Host LUCY_Seg_To_Host
  #define Seg_To_Host_t LUCY_Seg_To_Host_t
  #define Seg_Clone LUCY_Seg_Clone
  #define Seg_Clone_t LUCY_Seg_Clone_t
  #define Seg_Destroy LUCY_Seg_Destroy
  #define Seg_Destroy_t LUCY_Seg_Destroy_t
  #define Seg_Equals LUCY_Seg_Equals
  #define Seg_Equals_t LUCY_Seg_Equals_t
  #define Seg_Compare_To LUCY_Seg_Compare_To
  #define Seg_Compare_To_t LUCY_Seg_Compare_To_t
  #define Seg_Hash_Sum LUCY_Seg_Hash_Sum
  #define Seg_Hash_Sum_t LUCY_Seg_Hash_Sum_t
  #define Seg_Get_Class LUCY_Seg_Get_Class
  #define Seg_Get_Class_t LUCY_Seg_Get_Class_t
  #define Seg_Get_Class_Name LUCY_Seg_Get_Class_Name
  #define Seg_Get_Class_Name_t LUCY_Seg_Get_Class_Name_t
  #define Seg_Is_A LUCY_Seg_Is_A
  #define Seg_Is_A_t LUCY_Seg_Is_A_t
  #define Seg_To_String LUCY_Seg_To_String
  #define Seg_To_String_t LUCY_Seg_To_String_t
  #define Seg_To_I64 LUCY_Seg_To_I64
  #define Seg_To_I64_t LUCY_Seg_To_I64_t
  #define Seg_To_F64 LUCY_Seg_To_F64
  #define Seg_To_F64_t LUCY_Seg_To_F64_t
  #define Seg_To_Bool LUCY_Seg_To_Bool
  #define Seg_To_Bool_t LUCY_Seg_To_Bool_t
  #define Seg_Mimic LUCY_Seg_Mimic
  #define Seg_Mimic_t LUCY_Seg_Mimic_t
  #define Seg_Add_Field LUCY_Seg_Add_Field
  #define Seg_Add_Field_t LUCY_Seg_Add_Field_t
  #define Seg_Store_Metadata LUCY_Seg_Store_Metadata
  #define Seg_Store_Metadata_t LUCY_Seg_Store_Metadata_t
  #define Seg_Store_Metadata_Utf8 LUCY_Seg_Store_Metadata_Utf8
  #define Seg_Store_Metadata_Utf8_t LUCY_Seg_Store_Metadata_Utf8_t
  #define Seg_Fetch_Metadata LUCY_Seg_Fetch_Metadata
  #define Seg_Fetch_Metadata_t LUCY_Seg_Fetch_Metadata_t
  #define Seg_Fetch_Metadata_Utf8 LUCY_Seg_Fetch_Metadata_Utf8
  #define Seg_Fetch_Metadata_Utf8_t LUCY_Seg_Fetch_Metadata_Utf8_t
  #define Seg_Field_Num LUCY_Seg_Field_Num
  #define Seg_Field_Num_t LUCY_Seg_Field_Num_t
  #define Seg_Field_Name LUCY_Seg_Field_Name
  #define Seg_Field_Name_t LUCY_Seg_Field_Name_t
  #define Seg_Get_Name LUCY_Seg_Get_Name
  #define Seg_Get_Name_t LUCY_Seg_Get_Name_t
  #define Seg_Get_Number LUCY_Seg_Get_Number
  #define Seg_Get_Number_t LUCY_Seg_Get_Number_t
  #define Seg_Set_Count LUCY_Seg_Set_Count
  #define Seg_Set_Count_t LUCY_Seg_Set_Count_t
  #define Seg_Get_Count LUCY_Seg_Get_Count
  #define Seg_Get_Count_t LUCY_Seg_Get_Count_t
  #define Seg_Increment_Count LUCY_Seg_Increment_Count
  #define Seg_Increment_Count_t LUCY_Seg_Increment_Count_t
  #define Seg_Get_Metadata LUCY_Seg_Get_Metadata
  #define Seg_Get_Metadata_t LUCY_Seg_Get_Metadata_t
  #define Seg_Write_File LUCY_Seg_Write_File
  #define Seg_Write_File_t LUCY_Seg_Write_File_t
  #define Seg_Read_File LUCY_Seg_Read_File
  #define Seg_Read_File_t LUCY_Seg_Read_File_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SEGMENT */




