/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_INDEX_SORTWRITER
#define H_LUCY_INDEX_SORTWRITER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Index/DataWriter.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SORTWRITER
extern size_t lucy_SortWriter_IVARS_OFFSET;
typedef struct lucy_SortWriterIVARS lucy_SortWriterIVARS;
static CFISH_INLINE lucy_SortWriterIVARS*
lucy_SortWriter_IVARS(lucy_SortWriter *self) {
   char *ptr = (char*)self + lucy_SortWriter_IVARS_OFFSET;
   return (lucy_SortWriterIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define SortWriterIVARS lucy_SortWriterIVARS
  #define SortWriter_IVARS lucy_SortWriter_IVARS
#endif

struct lucy_SortWriterIVARS {
    lucy_Snapshot* snapshot;
    lucy_Segment* segment;
    lucy_PolyReader* polyreader;
    lucy_Schema* schema;
    lucy_Folder* folder;
    cfish_VArray* field_writers;
    cfish_Hash* counts;
    cfish_Hash* null_ords;
    cfish_Hash* ord_widths;
    lucy_OutStream* temp_ord_out;
    lucy_OutStream* temp_ix_out;
    lucy_OutStream* temp_dat_out;
    lucy_Counter* counter;
    size_t mem_thresh;
    bool flush_at_finish;
};

#endif /* C_LUCY_SORTWRITER */

/* Declare this class's inert variables.
 */

extern LUCY_VISIBLE int32_t lucy_SortWriter_current_file_format;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_SortWriter*
lucy_SortWriter_new(lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

LUCY_VISIBLE lucy_SortWriter*
lucy_SortWriter_init(lucy_SortWriter* self, lucy_Schema* schema, lucy_Snapshot* snapshot, lucy_Segment* segment, lucy_PolyReader* polyreader);

LUCY_VISIBLE void
lucy_SortWriter_set_default_mem_thresh(size_t mem_thresh);

void
LUCY_SortWriter_Destroy_IMP(lucy_SortWriter* self);

void
LUCY_SortWriter_Add_Inverted_Doc_IMP(lucy_SortWriter* self, lucy_Inverter* inverter, int32_t doc_id);

void
LUCY_SortWriter_Add_Segment_IMP(lucy_SortWriter* self, lucy_SegReader* reader, lucy_I32Array* doc_map);

void
LUCY_SortWriter_Finish_IMP(lucy_SortWriter* self);

cfish_Hash*
LUCY_SortWriter_Metadata_IMP(lucy_SortWriter* self);

int32_t
LUCY_SortWriter_Format_IMP(lucy_SortWriter* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_SortWriter_Get_RefCount_t)(lucy_SortWriter *self);

typedef cfish_Obj*
(*LUCY_SortWriter_Inc_RefCount_t)(lucy_SortWriter *self);

typedef uint32_t
(*LUCY_SortWriter_Dec_RefCount_t)(lucy_SortWriter *self);

typedef void*
(*LUCY_SortWriter_To_Host_t)(lucy_SortWriter *self);

typedef cfish_Obj*
(*LUCY_SortWriter_Clone_t)(lucy_SortWriter *self);

typedef void
(*LUCY_SortWriter_Destroy_t)(lucy_SortWriter *self);

typedef bool
(*LUCY_SortWriter_Equals_t)(lucy_SortWriter *self, cfish_Obj* other);

typedef int32_t
(*LUCY_SortWriter_Compare_To_t)(lucy_SortWriter *self, cfish_Obj* other);

typedef int32_t
(*LUCY_SortWriter_Hash_Sum_t)(lucy_SortWriter *self);

typedef cfish_Class*
(*LUCY_SortWriter_Get_Class_t)(lucy_SortWriter *self);

typedef cfish_String*
(*LUCY_SortWriter_Get_Class_Name_t)(lucy_SortWriter *self);

typedef bool
(*LUCY_SortWriter_Is_A_t)(lucy_SortWriter *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_SortWriter_To_String_t)(lucy_SortWriter *self);

typedef int64_t
(*LUCY_SortWriter_To_I64_t)(lucy_SortWriter *self);

typedef double
(*LUCY_SortWriter_To_F64_t)(lucy_SortWriter *self);

typedef bool
(*LUCY_SortWriter_To_Bool_t)(lucy_SortWriter *self);

typedef void
(*LUCY_SortWriter_Mimic_t)(lucy_SortWriter *self, cfish_Obj* other);

typedef void
(*LUCY_SortWriter_Add_Inverted_Doc_t)(lucy_SortWriter *self, lucy_Inverter* inverter, int32_t doc_id);

typedef void
(*LUCY_SortWriter_Add_Segment_t)(lucy_SortWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*LUCY_SortWriter_Delete_Segment_t)(lucy_SortWriter *self, lucy_SegReader* reader);

typedef void
(*LUCY_SortWriter_Merge_Segment_t)(lucy_SortWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map);

typedef void
(*LUCY_SortWriter_Finish_t)(lucy_SortWriter *self);

typedef cfish_Hash*
(*LUCY_SortWriter_Metadata_t)(lucy_SortWriter *self);

typedef int32_t
(*LUCY_SortWriter_Format_t)(lucy_SortWriter *self);

typedef lucy_Snapshot*
(*LUCY_SortWriter_Get_Snapshot_t)(lucy_SortWriter *self);

typedef lucy_Segment*
(*LUCY_SortWriter_Get_Segment_t)(lucy_SortWriter *self);

typedef lucy_PolyReader*
(*LUCY_SortWriter_Get_PolyReader_t)(lucy_SortWriter *self);

typedef lucy_Schema*
(*LUCY_SortWriter_Get_Schema_t)(lucy_SortWriter *self);

typedef lucy_Folder*
(*LUCY_SortWriter_Get_Folder_t)(lucy_SortWriter *self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_SortWriter_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_SortWriter_Get_RefCount(lucy_SortWriter *self) {
    const LUCY_SortWriter_Get_RefCount_t method = (LUCY_SortWriter_Get_RefCount_t)cfish_obj_method(self, LUCY_SortWriter_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SortWriter_Inc_RefCount(lucy_SortWriter *self) {
    const LUCY_SortWriter_Inc_RefCount_t method = (LUCY_SortWriter_Inc_RefCount_t)cfish_obj_method(self, LUCY_SortWriter_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_SortWriter_Dec_RefCount(lucy_SortWriter *self) {
    const LUCY_SortWriter_Dec_RefCount_t method = (LUCY_SortWriter_Dec_RefCount_t)cfish_obj_method(self, LUCY_SortWriter_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_SortWriter_To_Host(lucy_SortWriter *self) {
    const LUCY_SortWriter_To_Host_t method = (LUCY_SortWriter_To_Host_t)cfish_obj_method(self, LUCY_SortWriter_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SortWriter_Clone(lucy_SortWriter *self) {
    const LUCY_SortWriter_Clone_t method = (LUCY_SortWriter_Clone_t)cfish_obj_method(self, LUCY_SortWriter_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_SortWriter_Destroy(lucy_SortWriter *self) {
    const LUCY_SortWriter_Destroy_t method = (LUCY_SortWriter_Destroy_t)cfish_obj_method(self, LUCY_SortWriter_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_SortWriter_Equals(lucy_SortWriter *self, cfish_Obj* other) {
    const LUCY_SortWriter_Equals_t method = (LUCY_SortWriter_Equals_t)cfish_obj_method(self, LUCY_SortWriter_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_SortWriter_Compare_To(lucy_SortWriter *self, cfish_Obj* other) {
    const LUCY_SortWriter_Compare_To_t method = (LUCY_SortWriter_Compare_To_t)cfish_obj_method(self, LUCY_SortWriter_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_SortWriter_Hash_Sum(lucy_SortWriter *self) {
    const LUCY_SortWriter_Hash_Sum_t method = (LUCY_SortWriter_Hash_Sum_t)cfish_obj_method(self, LUCY_SortWriter_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_SortWriter_Get_Class(lucy_SortWriter *self) {
    const LUCY_SortWriter_Get_Class_t method = (LUCY_SortWriter_Get_Class_t)cfish_obj_method(self, LUCY_SortWriter_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_SortWriter_Get_Class_Name(lucy_SortWriter *self) {
    const LUCY_SortWriter_Get_Class_Name_t method = (LUCY_SortWriter_Get_Class_Name_t)cfish_obj_method(self, LUCY_SortWriter_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_SortWriter_Is_A(lucy_SortWriter *self, cfish_Class* ancestor) {
    const LUCY_SortWriter_Is_A_t method = (LUCY_SortWriter_Is_A_t)cfish_obj_method(self, LUCY_SortWriter_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_SortWriter_To_String(lucy_SortWriter *self) {
    const LUCY_SortWriter_To_String_t method = (LUCY_SortWriter_To_String_t)cfish_obj_method(self, LUCY_SortWriter_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_SortWriter_To_I64(lucy_SortWriter *self) {
    const LUCY_SortWriter_To_I64_t method = (LUCY_SortWriter_To_I64_t)cfish_obj_method(self, LUCY_SortWriter_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_SortWriter_To_F64(lucy_SortWriter *self) {
    const LUCY_SortWriter_To_F64_t method = (LUCY_SortWriter_To_F64_t)cfish_obj_method(self, LUCY_SortWriter_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_SortWriter_To_Bool(lucy_SortWriter *self) {
    const LUCY_SortWriter_To_Bool_t method = (LUCY_SortWriter_To_Bool_t)cfish_obj_method(self, LUCY_SortWriter_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_SortWriter_Mimic(lucy_SortWriter *self, cfish_Obj* other) {
    const LUCY_SortWriter_Mimic_t method = (LUCY_SortWriter_Mimic_t)cfish_obj_method(self, LUCY_SortWriter_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Add_Inverted_Doc_OFFSET;
static CFISH_INLINE void
LUCY_SortWriter_Add_Inverted_Doc(lucy_SortWriter *self, lucy_Inverter* inverter, int32_t doc_id) {
    const LUCY_SortWriter_Add_Inverted_Doc_t method = (LUCY_SortWriter_Add_Inverted_Doc_t)cfish_obj_method(self, LUCY_SortWriter_Add_Inverted_Doc_OFFSET);
    method(self, inverter, doc_id);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Add_Segment_OFFSET;
static CFISH_INLINE void
LUCY_SortWriter_Add_Segment(lucy_SortWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    const LUCY_SortWriter_Add_Segment_t method = (LUCY_SortWriter_Add_Segment_t)cfish_obj_method(self, LUCY_SortWriter_Add_Segment_OFFSET);
    method(self, reader, doc_map);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Delete_Segment_OFFSET;
static CFISH_INLINE void
LUCY_SortWriter_Delete_Segment(lucy_SortWriter *self, lucy_SegReader* reader) {
    const LUCY_SortWriter_Delete_Segment_t method = (LUCY_SortWriter_Delete_Segment_t)cfish_obj_method(self, LUCY_SortWriter_Delete_Segment_OFFSET);
    method(self, reader);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Merge_Segment_OFFSET;
static CFISH_INLINE void
LUCY_SortWriter_Merge_Segment(lucy_SortWriter *self, lucy_SegReader* reader, lucy_I32Array* doc_map) {
    const LUCY_SortWriter_Merge_Segment_t method = (LUCY_SortWriter_Merge_Segment_t)cfish_obj_method(self, LUCY_SortWriter_Merge_Segment_OFFSET);
    method(self, reader, doc_map);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Finish_OFFSET;
static CFISH_INLINE void
LUCY_SortWriter_Finish(lucy_SortWriter *self) {
    const LUCY_SortWriter_Finish_t method = (LUCY_SortWriter_Finish_t)cfish_obj_method(self, LUCY_SortWriter_Finish_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Metadata_OFFSET;
static CFISH_INLINE cfish_Hash*
LUCY_SortWriter_Metadata(lucy_SortWriter *self) {
    const LUCY_SortWriter_Metadata_t method = (LUCY_SortWriter_Metadata_t)cfish_obj_method(self, LUCY_SortWriter_Metadata_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Format_OFFSET;
static CFISH_INLINE int32_t
LUCY_SortWriter_Format(lucy_SortWriter *self) {
    const LUCY_SortWriter_Format_t method = (LUCY_SortWriter_Format_t)cfish_obj_method(self, LUCY_SortWriter_Format_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Get_Snapshot_OFFSET;
static CFISH_INLINE lucy_Snapshot*
LUCY_SortWriter_Get_Snapshot(lucy_SortWriter *self) {
    const LUCY_SortWriter_Get_Snapshot_t method = (LUCY_SortWriter_Get_Snapshot_t)cfish_obj_method(self, LUCY_SortWriter_Get_Snapshot_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Get_Segment_OFFSET;
static CFISH_INLINE lucy_Segment*
LUCY_SortWriter_Get_Segment(lucy_SortWriter *self) {
    const LUCY_SortWriter_Get_Segment_t method = (LUCY_SortWriter_Get_Segment_t)cfish_obj_method(self, LUCY_SortWriter_Get_Segment_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Get_PolyReader_OFFSET;
static CFISH_INLINE lucy_PolyReader*
LUCY_SortWriter_Get_PolyReader(lucy_SortWriter *self) {
    const LUCY_SortWriter_Get_PolyReader_t method = (LUCY_SortWriter_Get_PolyReader_t)cfish_obj_method(self, LUCY_SortWriter_Get_PolyReader_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Get_Schema_OFFSET;
static CFISH_INLINE lucy_Schema*
LUCY_SortWriter_Get_Schema(lucy_SortWriter *self) {
    const LUCY_SortWriter_Get_Schema_t method = (LUCY_SortWriter_Get_Schema_t)cfish_obj_method(self, LUCY_SortWriter_Get_Schema_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortWriter_Get_Folder_OFFSET;
static CFISH_INLINE lucy_Folder*
LUCY_SortWriter_Get_Folder(lucy_SortWriter *self) {
    const LUCY_SortWriter_Get_Folder_t method = (LUCY_SortWriter_Get_Folder_t)cfish_obj_method(self, LUCY_SortWriter_Get_Folder_OFFSET);
    return method(self);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_SORTWRITER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SortWriter lucy_SortWriter
  #define SORTWRITER LUCY_SORTWRITER
  #define SortWriter_new lucy_SortWriter_new
  #define SortWriter_init lucy_SortWriter_init
  #define SortWriter_set_default_mem_thresh lucy_SortWriter_set_default_mem_thresh
  #define SortWriter_current_file_format lucy_SortWriter_current_file_format
  #define SortWriter_Destroy_IMP LUCY_SortWriter_Destroy_IMP
  #define SortWriter_Add_Inverted_Doc_IMP LUCY_SortWriter_Add_Inverted_Doc_IMP
  #define SortWriter_Add_Segment_IMP LUCY_SortWriter_Add_Segment_IMP
  #define SortWriter_Finish_IMP LUCY_SortWriter_Finish_IMP
  #define SortWriter_Metadata_IMP LUCY_SortWriter_Metadata_IMP
  #define SortWriter_Format_IMP LUCY_SortWriter_Format_IMP
  #define SortWriter_Get_RefCount LUCY_SortWriter_Get_RefCount
  #define SortWriter_Get_RefCount_t LUCY_SortWriter_Get_RefCount_t
  #define SortWriter_Inc_RefCount LUCY_SortWriter_Inc_RefCount
  #define SortWriter_Inc_RefCount_t LUCY_SortWriter_Inc_RefCount_t
  #define SortWriter_Dec_RefCount LUCY_SortWriter_Dec_RefCount
  #define SortWriter_Dec_RefCount_t LUCY_SortWriter_Dec_RefCount_t
  #define SortWriter_To_Host LUCY_SortWriter_To_Host
  #define SortWriter_To_Host_t LUCY_SortWriter_To_Host_t
  #define SortWriter_Clone LUCY_SortWriter_Clone
  #define SortWriter_Clone_t LUCY_SortWriter_Clone_t
  #define SortWriter_Destroy LUCY_SortWriter_Destroy
  #define SortWriter_Destroy_t LUCY_SortWriter_Destroy_t
  #define SortWriter_Equals LUCY_SortWriter_Equals
  #define SortWriter_Equals_t LUCY_SortWriter_Equals_t
  #define SortWriter_Compare_To LUCY_SortWriter_Compare_To
  #define SortWriter_Compare_To_t LUCY_SortWriter_Compare_To_t
  #define SortWriter_Hash_Sum LUCY_SortWriter_Hash_Sum
  #define SortWriter_Hash_Sum_t LUCY_SortWriter_Hash_Sum_t
  #define SortWriter_Get_Class LUCY_SortWriter_Get_Class
  #define SortWriter_Get_Class_t LUCY_SortWriter_Get_Class_t
  #define SortWriter_Get_Class_Name LUCY_SortWriter_Get_Class_Name
  #define SortWriter_Get_Class_Name_t LUCY_SortWriter_Get_Class_Name_t
  #define SortWriter_Is_A LUCY_SortWriter_Is_A
  #define SortWriter_Is_A_t LUCY_SortWriter_Is_A_t
  #define SortWriter_To_String LUCY_SortWriter_To_String
  #define SortWriter_To_String_t LUCY_SortWriter_To_String_t
  #define SortWriter_To_I64 LUCY_SortWriter_To_I64
  #define SortWriter_To_I64_t LUCY_SortWriter_To_I64_t
  #define SortWriter_To_F64 LUCY_SortWriter_To_F64
  #define SortWriter_To_F64_t LUCY_SortWriter_To_F64_t
  #define SortWriter_To_Bool LUCY_SortWriter_To_Bool
  #define SortWriter_To_Bool_t LUCY_SortWriter_To_Bool_t
  #define SortWriter_Mimic LUCY_SortWriter_Mimic
  #define SortWriter_Mimic_t LUCY_SortWriter_Mimic_t
  #define SortWriter_Add_Inverted_Doc LUCY_SortWriter_Add_Inverted_Doc
  #define SortWriter_Add_Inverted_Doc_t LUCY_SortWriter_Add_Inverted_Doc_t
  #define SortWriter_Add_Segment LUCY_SortWriter_Add_Segment
  #define SortWriter_Add_Segment_t LUCY_SortWriter_Add_Segment_t
  #define SortWriter_Delete_Segment LUCY_SortWriter_Delete_Segment
  #define SortWriter_Delete_Segment_t LUCY_SortWriter_Delete_Segment_t
  #define SortWriter_Merge_Segment LUCY_SortWriter_Merge_Segment
  #define SortWriter_Merge_Segment_t LUCY_SortWriter_Merge_Segment_t
  #define SortWriter_Finish LUCY_SortWriter_Finish
  #define SortWriter_Finish_t LUCY_SortWriter_Finish_t
  #define SortWriter_Metadata LUCY_SortWriter_Metadata
  #define SortWriter_Metadata_t LUCY_SortWriter_Metadata_t
  #define SortWriter_Format LUCY_SortWriter_Format
  #define SortWriter_Format_t LUCY_SortWriter_Format_t
  #define SortWriter_Get_Snapshot LUCY_SortWriter_Get_Snapshot
  #define SortWriter_Get_Snapshot_t LUCY_SortWriter_Get_Snapshot_t
  #define SortWriter_Get_Segment LUCY_SortWriter_Get_Segment
  #define SortWriter_Get_Segment_t LUCY_SortWriter_Get_Segment_t
  #define SortWriter_Get_PolyReader LUCY_SortWriter_Get_PolyReader
  #define SortWriter_Get_PolyReader_t LUCY_SortWriter_Get_PolyReader_t
  #define SortWriter_Get_Schema LUCY_SortWriter_Get_Schema
  #define SortWriter_Get_Schema_t LUCY_SortWriter_Get_Schema_t
  #define SortWriter_Get_Folder LUCY_SortWriter_Get_Folder
  #define SortWriter_Get_Folder_t LUCY_SortWriter_Get_Folder_t
#endif /* LUCY_USE_SHORT_NAMES */



/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_COUNTER
extern size_t lucy_Counter_IVARS_OFFSET;
typedef struct lucy_CounterIVARS lucy_CounterIVARS;
static CFISH_INLINE lucy_CounterIVARS*
lucy_Counter_IVARS(lucy_Counter *self) {
   char *ptr = (char*)self + lucy_Counter_IVARS_OFFSET;
   return (lucy_CounterIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define CounterIVARS lucy_CounterIVARS
  #define Counter_IVARS lucy_Counter_IVARS
#endif

struct lucy_CounterIVARS {
    int64_t value;
};

#endif /* C_LUCY_COUNTER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_Counter*
lucy_Counter_new(void);

LUCY_VISIBLE lucy_Counter*
lucy_Counter_init(lucy_Counter* self);

LUCY_VISIBLE int64_t
LUCY_Counter_Add_IMP(lucy_Counter* self, int64_t amount);

LUCY_VISIBLE int64_t
LUCY_Counter_Get_Value_IMP(lucy_Counter* self);

LUCY_VISIBLE void
LUCY_Counter_Reset_IMP(lucy_Counter* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_Counter_Get_RefCount_t)(lucy_Counter *self);

typedef cfish_Obj*
(*LUCY_Counter_Inc_RefCount_t)(lucy_Counter *self);

typedef uint32_t
(*LUCY_Counter_Dec_RefCount_t)(lucy_Counter *self);

typedef void*
(*LUCY_Counter_To_Host_t)(lucy_Counter *self);

typedef cfish_Obj*
(*LUCY_Counter_Clone_t)(lucy_Counter *self);

typedef void
(*LUCY_Counter_Destroy_t)(lucy_Counter *self);

typedef bool
(*LUCY_Counter_Equals_t)(lucy_Counter *self, cfish_Obj* other);

typedef int32_t
(*LUCY_Counter_Compare_To_t)(lucy_Counter *self, cfish_Obj* other);

typedef int32_t
(*LUCY_Counter_Hash_Sum_t)(lucy_Counter *self);

typedef cfish_Class*
(*LUCY_Counter_Get_Class_t)(lucy_Counter *self);

typedef cfish_String*
(*LUCY_Counter_Get_Class_Name_t)(lucy_Counter *self);

typedef bool
(*LUCY_Counter_Is_A_t)(lucy_Counter *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_Counter_To_String_t)(lucy_Counter *self);

typedef int64_t
(*LUCY_Counter_To_I64_t)(lucy_Counter *self);

typedef double
(*LUCY_Counter_To_F64_t)(lucy_Counter *self);

typedef bool
(*LUCY_Counter_To_Bool_t)(lucy_Counter *self);

typedef void
(*LUCY_Counter_Mimic_t)(lucy_Counter *self, cfish_Obj* other);

typedef int64_t
(*LUCY_Counter_Add_t)(lucy_Counter *self, int64_t amount);

typedef int64_t
(*LUCY_Counter_Get_Value_t)(lucy_Counter *self);

typedef void
(*LUCY_Counter_Reset_t)(lucy_Counter *self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern size_t LUCY_Counter_Get_RefCount_OFFSET;
#define LUCY_Counter_Get_RefCount(self) \
    CFISH_Obj_Get_RefCount_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_Inc_RefCount_OFFSET;
#define LUCY_Counter_Inc_RefCount(self) \
    CFISH_Obj_Inc_RefCount_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_Dec_RefCount_OFFSET;
#define LUCY_Counter_Dec_RefCount(self) \
    CFISH_Obj_Dec_RefCount_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_To_Host_OFFSET;
#define LUCY_Counter_To_Host(self) \
    CFISH_Obj_To_Host_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_Clone_OFFSET;
#define LUCY_Counter_Clone(self) \
    CFISH_Obj_Clone_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_Destroy_OFFSET;
#define LUCY_Counter_Destroy(self) \
    CFISH_Obj_Destroy_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_Equals_OFFSET;
#define LUCY_Counter_Equals(self, other) \
    CFISH_Obj_Equals_IMP((cfish_Obj*)self, other)

extern size_t LUCY_Counter_Compare_To_OFFSET;
#define LUCY_Counter_Compare_To(self, other) \
    CFISH_Obj_Compare_To_IMP((cfish_Obj*)self, other)

extern size_t LUCY_Counter_Hash_Sum_OFFSET;
#define LUCY_Counter_Hash_Sum(self) \
    CFISH_Obj_Hash_Sum_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_Get_Class_OFFSET;
#define LUCY_Counter_Get_Class(self) \
    CFISH_Obj_Get_Class_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_Get_Class_Name_OFFSET;
#define LUCY_Counter_Get_Class_Name(self) \
    CFISH_Obj_Get_Class_Name_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_Is_A_OFFSET;
#define LUCY_Counter_Is_A(self, ancestor) \
    CFISH_Obj_Is_A_IMP((cfish_Obj*)self, ancestor)

extern size_t LUCY_Counter_To_String_OFFSET;
#define LUCY_Counter_To_String(self) \
    CFISH_Obj_To_String_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_To_I64_OFFSET;
#define LUCY_Counter_To_I64(self) \
    CFISH_Obj_To_I64_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_To_F64_OFFSET;
#define LUCY_Counter_To_F64(self) \
    CFISH_Obj_To_F64_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_To_Bool_OFFSET;
#define LUCY_Counter_To_Bool(self) \
    CFISH_Obj_To_Bool_IMP((cfish_Obj*)self)

extern size_t LUCY_Counter_Mimic_OFFSET;
#define LUCY_Counter_Mimic(self, other) \
    CFISH_Obj_Mimic_IMP((cfish_Obj*)self, other)

extern size_t LUCY_Counter_Add_OFFSET;
#define LUCY_Counter_Add(self, amount) \
    LUCY_Counter_Add_IMP((lucy_Counter*)self, amount)

extern size_t LUCY_Counter_Get_Value_OFFSET;
#define LUCY_Counter_Get_Value(self) \
    LUCY_Counter_Get_Value_IMP((lucy_Counter*)self)

extern size_t LUCY_Counter_Reset_OFFSET;
#define LUCY_Counter_Reset(self) \
    LUCY_Counter_Reset_IMP((lucy_Counter*)self)



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_COUNTER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define Counter lucy_Counter
  #define COUNTER LUCY_COUNTER
  #define Counter_new lucy_Counter_new
  #define Counter_init lucy_Counter_init
  #define Counter_Add_IMP LUCY_Counter_Add_IMP
  #define Counter_Get_Value_IMP LUCY_Counter_Get_Value_IMP
  #define Counter_Reset_IMP LUCY_Counter_Reset_IMP
  #define Counter_Get_RefCount LUCY_Counter_Get_RefCount
  #define Counter_Get_RefCount_t LUCY_Counter_Get_RefCount_t
  #define Counter_Inc_RefCount LUCY_Counter_Inc_RefCount
  #define Counter_Inc_RefCount_t LUCY_Counter_Inc_RefCount_t
  #define Counter_Dec_RefCount LUCY_Counter_Dec_RefCount
  #define Counter_Dec_RefCount_t LUCY_Counter_Dec_RefCount_t
  #define Counter_To_Host LUCY_Counter_To_Host
  #define Counter_To_Host_t LUCY_Counter_To_Host_t
  #define Counter_Clone LUCY_Counter_Clone
  #define Counter_Clone_t LUCY_Counter_Clone_t
  #define Counter_Destroy LUCY_Counter_Destroy
  #define Counter_Destroy_t LUCY_Counter_Destroy_t
  #define Counter_Equals LUCY_Counter_Equals
  #define Counter_Equals_t LUCY_Counter_Equals_t
  #define Counter_Compare_To LUCY_Counter_Compare_To
  #define Counter_Compare_To_t LUCY_Counter_Compare_To_t
  #define Counter_Hash_Sum LUCY_Counter_Hash_Sum
  #define Counter_Hash_Sum_t LUCY_Counter_Hash_Sum_t
  #define Counter_Get_Class LUCY_Counter_Get_Class
  #define Counter_Get_Class_t LUCY_Counter_Get_Class_t
  #define Counter_Get_Class_Name LUCY_Counter_Get_Class_Name
  #define Counter_Get_Class_Name_t LUCY_Counter_Get_Class_Name_t
  #define Counter_Is_A LUCY_Counter_Is_A
  #define Counter_Is_A_t LUCY_Counter_Is_A_t
  #define Counter_To_String LUCY_Counter_To_String
  #define Counter_To_String_t LUCY_Counter_To_String_t
  #define Counter_To_I64 LUCY_Counter_To_I64
  #define Counter_To_I64_t LUCY_Counter_To_I64_t
  #define Counter_To_F64 LUCY_Counter_To_F64
  #define Counter_To_F64_t LUCY_Counter_To_F64_t
  #define Counter_To_Bool LUCY_Counter_To_Bool
  #define Counter_To_Bool_t LUCY_Counter_To_Bool_t
  #define Counter_Mimic LUCY_Counter_Mimic
  #define Counter_Mimic_t LUCY_Counter_Mimic_t
  #define Counter_Add LUCY_Counter_Add
  #define Counter_Add_t LUCY_Counter_Add_t
  #define Counter_Get_Value LUCY_Counter_Get_Value
  #define Counter_Get_Value_t LUCY_Counter_Get_Value_t
  #define Counter_Reset LUCY_Counter_Reset
  #define Counter_Reset_t LUCY_Counter_Reset_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_INDEX_SORTWRITER */




