/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_ANDMATCHER
#define H_LUCY_SEARCH_ANDMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/PolyMatcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_ANDMATCHER
extern size_t lucy_ANDMatcher_IVARS_OFFSET;
typedef struct lucy_ANDMatcherIVARS lucy_ANDMatcherIVARS;
static CFISH_INLINE lucy_ANDMatcherIVARS*
lucy_ANDMatcher_IVARS(lucy_ANDMatcher *self) {
   char *ptr = (char*)self + lucy_ANDMatcher_IVARS_OFFSET;
   return (lucy_ANDMatcherIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define ANDMatcherIVARS lucy_ANDMatcherIVARS
  #define ANDMatcher_IVARS lucy_ANDMatcher_IVARS
#endif

struct lucy_ANDMatcherIVARS {
    cfish_VArray* children;
    lucy_Similarity* sim;
    uint32_t num_kids;
    uint32_t matching_kids;
    float* coord_factors;
    lucy_Matcher** kids;
    bool more;
    bool first_time;
};

#endif /* C_LUCY_ANDMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_ANDMatcher*
lucy_ANDMatcher_new(cfish_VArray* children, lucy_Similarity* sim);

LUCY_VISIBLE lucy_ANDMatcher*
lucy_ANDMatcher_init(lucy_ANDMatcher* self, cfish_VArray* children, lucy_Similarity* similarity);

void
LUCY_ANDMatcher_Destroy_IMP(lucy_ANDMatcher* self);

int32_t
LUCY_ANDMatcher_Next_IMP(lucy_ANDMatcher* self);

int32_t
LUCY_ANDMatcher_Advance_IMP(lucy_ANDMatcher* self, int32_t target);

int32_t
LUCY_ANDMatcher_Get_Doc_ID_IMP(lucy_ANDMatcher* self);

float
LUCY_ANDMatcher_Score_IMP(lucy_ANDMatcher* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_ANDMatcher_Get_RefCount_t)(lucy_ANDMatcher *self);

typedef cfish_Obj*
(*LUCY_ANDMatcher_Inc_RefCount_t)(lucy_ANDMatcher *self);

typedef uint32_t
(*LUCY_ANDMatcher_Dec_RefCount_t)(lucy_ANDMatcher *self);

typedef void*
(*LUCY_ANDMatcher_To_Host_t)(lucy_ANDMatcher *self);

typedef cfish_Obj*
(*LUCY_ANDMatcher_Clone_t)(lucy_ANDMatcher *self);

typedef void
(*LUCY_ANDMatcher_Destroy_t)(lucy_ANDMatcher *self);

typedef bool
(*LUCY_ANDMatcher_Equals_t)(lucy_ANDMatcher *self, cfish_Obj* other);

typedef int32_t
(*LUCY_ANDMatcher_Compare_To_t)(lucy_ANDMatcher *self, cfish_Obj* other);

typedef int32_t
(*LUCY_ANDMatcher_Hash_Sum_t)(lucy_ANDMatcher *self);

typedef cfish_Class*
(*LUCY_ANDMatcher_Get_Class_t)(lucy_ANDMatcher *self);

typedef cfish_String*
(*LUCY_ANDMatcher_Get_Class_Name_t)(lucy_ANDMatcher *self);

typedef bool
(*LUCY_ANDMatcher_Is_A_t)(lucy_ANDMatcher *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_ANDMatcher_To_String_t)(lucy_ANDMatcher *self);

typedef int64_t
(*LUCY_ANDMatcher_To_I64_t)(lucy_ANDMatcher *self);

typedef double
(*LUCY_ANDMatcher_To_F64_t)(lucy_ANDMatcher *self);

typedef bool
(*LUCY_ANDMatcher_To_Bool_t)(lucy_ANDMatcher *self);

typedef void
(*LUCY_ANDMatcher_Mimic_t)(lucy_ANDMatcher *self, cfish_Obj* other);

typedef int32_t
(*LUCY_ANDMatcher_Next_t)(lucy_ANDMatcher *self);

typedef int32_t
(*LUCY_ANDMatcher_Advance_t)(lucy_ANDMatcher *self, int32_t target);

typedef int32_t
(*LUCY_ANDMatcher_Get_Doc_ID_t)(lucy_ANDMatcher *self);

typedef float
(*LUCY_ANDMatcher_Score_t)(lucy_ANDMatcher *self);

typedef void
(*LUCY_ANDMatcher_Collect_t)(lucy_ANDMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_ANDMatcher_Get_RefCount(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Get_RefCount_t method = (LUCY_ANDMatcher_Get_RefCount_t)cfish_obj_method(self, LUCY_ANDMatcher_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_ANDMatcher_Inc_RefCount(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Inc_RefCount_t method = (LUCY_ANDMatcher_Inc_RefCount_t)cfish_obj_method(self, LUCY_ANDMatcher_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_ANDMatcher_Dec_RefCount(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Dec_RefCount_t method = (LUCY_ANDMatcher_Dec_RefCount_t)cfish_obj_method(self, LUCY_ANDMatcher_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_ANDMatcher_To_Host(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_To_Host_t method = (LUCY_ANDMatcher_To_Host_t)cfish_obj_method(self, LUCY_ANDMatcher_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_ANDMatcher_Clone(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Clone_t method = (LUCY_ANDMatcher_Clone_t)cfish_obj_method(self, LUCY_ANDMatcher_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_ANDMatcher_Destroy(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Destroy_t method = (LUCY_ANDMatcher_Destroy_t)cfish_obj_method(self, LUCY_ANDMatcher_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_ANDMatcher_Equals(lucy_ANDMatcher *self, cfish_Obj* other) {
    const LUCY_ANDMatcher_Equals_t method = (LUCY_ANDMatcher_Equals_t)cfish_obj_method(self, LUCY_ANDMatcher_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_ANDMatcher_Compare_To(lucy_ANDMatcher *self, cfish_Obj* other) {
    const LUCY_ANDMatcher_Compare_To_t method = (LUCY_ANDMatcher_Compare_To_t)cfish_obj_method(self, LUCY_ANDMatcher_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_ANDMatcher_Hash_Sum(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Hash_Sum_t method = (LUCY_ANDMatcher_Hash_Sum_t)cfish_obj_method(self, LUCY_ANDMatcher_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_ANDMatcher_Get_Class(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Get_Class_t method = (LUCY_ANDMatcher_Get_Class_t)cfish_obj_method(self, LUCY_ANDMatcher_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_ANDMatcher_Get_Class_Name(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Get_Class_Name_t method = (LUCY_ANDMatcher_Get_Class_Name_t)cfish_obj_method(self, LUCY_ANDMatcher_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_ANDMatcher_Is_A(lucy_ANDMatcher *self, cfish_Class* ancestor) {
    const LUCY_ANDMatcher_Is_A_t method = (LUCY_ANDMatcher_Is_A_t)cfish_obj_method(self, LUCY_ANDMatcher_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_ANDMatcher_To_String(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_To_String_t method = (LUCY_ANDMatcher_To_String_t)cfish_obj_method(self, LUCY_ANDMatcher_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_ANDMatcher_To_I64(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_To_I64_t method = (LUCY_ANDMatcher_To_I64_t)cfish_obj_method(self, LUCY_ANDMatcher_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_ANDMatcher_To_F64(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_To_F64_t method = (LUCY_ANDMatcher_To_F64_t)cfish_obj_method(self, LUCY_ANDMatcher_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_ANDMatcher_To_Bool(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_To_Bool_t method = (LUCY_ANDMatcher_To_Bool_t)cfish_obj_method(self, LUCY_ANDMatcher_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_ANDMatcher_Mimic(lucy_ANDMatcher *self, cfish_Obj* other) {
    const LUCY_ANDMatcher_Mimic_t method = (LUCY_ANDMatcher_Mimic_t)cfish_obj_method(self, LUCY_ANDMatcher_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Next_OFFSET;
static CFISH_INLINE int32_t
LUCY_ANDMatcher_Next(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Next_t method = (LUCY_ANDMatcher_Next_t)cfish_obj_method(self, LUCY_ANDMatcher_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Advance_OFFSET;
static CFISH_INLINE int32_t
LUCY_ANDMatcher_Advance(lucy_ANDMatcher *self, int32_t target) {
    const LUCY_ANDMatcher_Advance_t method = (LUCY_ANDMatcher_Advance_t)cfish_obj_method(self, LUCY_ANDMatcher_Advance_OFFSET);
    return method(self, target);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Get_Doc_ID_OFFSET;
static CFISH_INLINE int32_t
LUCY_ANDMatcher_Get_Doc_ID(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Get_Doc_ID_t method = (LUCY_ANDMatcher_Get_Doc_ID_t)cfish_obj_method(self, LUCY_ANDMatcher_Get_Doc_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Score_OFFSET;
static CFISH_INLINE float
LUCY_ANDMatcher_Score(lucy_ANDMatcher *self) {
    const LUCY_ANDMatcher_Score_t method = (LUCY_ANDMatcher_Score_t)cfish_obj_method(self, LUCY_ANDMatcher_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_ANDMatcher_Collect_OFFSET;
static CFISH_INLINE void
LUCY_ANDMatcher_Collect(lucy_ANDMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    const LUCY_ANDMatcher_Collect_t method = (LUCY_ANDMatcher_Collect_t)cfish_obj_method(self, LUCY_ANDMatcher_Collect_OFFSET);
    method(self, collector, deletions);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_ANDMATCHER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define ANDMatcher lucy_ANDMatcher
  #define ANDMATCHER LUCY_ANDMATCHER
  #define ANDMatcher_new lucy_ANDMatcher_new
  #define ANDMatcher_init lucy_ANDMatcher_init
  #define ANDMatcher_Destroy_IMP LUCY_ANDMatcher_Destroy_IMP
  #define ANDMatcher_Next_IMP LUCY_ANDMatcher_Next_IMP
  #define ANDMatcher_Advance_IMP LUCY_ANDMatcher_Advance_IMP
  #define ANDMatcher_Get_Doc_ID_IMP LUCY_ANDMatcher_Get_Doc_ID_IMP
  #define ANDMatcher_Score_IMP LUCY_ANDMatcher_Score_IMP
  #define ANDMatcher_Get_RefCount LUCY_ANDMatcher_Get_RefCount
  #define ANDMatcher_Get_RefCount_t LUCY_ANDMatcher_Get_RefCount_t
  #define ANDMatcher_Inc_RefCount LUCY_ANDMatcher_Inc_RefCount
  #define ANDMatcher_Inc_RefCount_t LUCY_ANDMatcher_Inc_RefCount_t
  #define ANDMatcher_Dec_RefCount LUCY_ANDMatcher_Dec_RefCount
  #define ANDMatcher_Dec_RefCount_t LUCY_ANDMatcher_Dec_RefCount_t
  #define ANDMatcher_To_Host LUCY_ANDMatcher_To_Host
  #define ANDMatcher_To_Host_t LUCY_ANDMatcher_To_Host_t
  #define ANDMatcher_Clone LUCY_ANDMatcher_Clone
  #define ANDMatcher_Clone_t LUCY_ANDMatcher_Clone_t
  #define ANDMatcher_Destroy LUCY_ANDMatcher_Destroy
  #define ANDMatcher_Destroy_t LUCY_ANDMatcher_Destroy_t
  #define ANDMatcher_Equals LUCY_ANDMatcher_Equals
  #define ANDMatcher_Equals_t LUCY_ANDMatcher_Equals_t
  #define ANDMatcher_Compare_To LUCY_ANDMatcher_Compare_To
  #define ANDMatcher_Compare_To_t LUCY_ANDMatcher_Compare_To_t
  #define ANDMatcher_Hash_Sum LUCY_ANDMatcher_Hash_Sum
  #define ANDMatcher_Hash_Sum_t LUCY_ANDMatcher_Hash_Sum_t
  #define ANDMatcher_Get_Class LUCY_ANDMatcher_Get_Class
  #define ANDMatcher_Get_Class_t LUCY_ANDMatcher_Get_Class_t
  #define ANDMatcher_Get_Class_Name LUCY_ANDMatcher_Get_Class_Name
  #define ANDMatcher_Get_Class_Name_t LUCY_ANDMatcher_Get_Class_Name_t
  #define ANDMatcher_Is_A LUCY_ANDMatcher_Is_A
  #define ANDMatcher_Is_A_t LUCY_ANDMatcher_Is_A_t
  #define ANDMatcher_To_String LUCY_ANDMatcher_To_String
  #define ANDMatcher_To_String_t LUCY_ANDMatcher_To_String_t
  #define ANDMatcher_To_I64 LUCY_ANDMatcher_To_I64
  #define ANDMatcher_To_I64_t LUCY_ANDMatcher_To_I64_t
  #define ANDMatcher_To_F64 LUCY_ANDMatcher_To_F64
  #define ANDMatcher_To_F64_t LUCY_ANDMatcher_To_F64_t
  #define ANDMatcher_To_Bool LUCY_ANDMatcher_To_Bool
  #define ANDMatcher_To_Bool_t LUCY_ANDMatcher_To_Bool_t
  #define ANDMatcher_Mimic LUCY_ANDMatcher_Mimic
  #define ANDMatcher_Mimic_t LUCY_ANDMatcher_Mimic_t
  #define ANDMatcher_Next LUCY_ANDMatcher_Next
  #define ANDMatcher_Next_t LUCY_ANDMatcher_Next_t
  #define ANDMatcher_Advance LUCY_ANDMatcher_Advance
  #define ANDMatcher_Advance_t LUCY_ANDMatcher_Advance_t
  #define ANDMatcher_Get_Doc_ID LUCY_ANDMatcher_Get_Doc_ID
  #define ANDMatcher_Get_Doc_ID_t LUCY_ANDMatcher_Get_Doc_ID_t
  #define ANDMatcher_Score LUCY_ANDMatcher_Score
  #define ANDMatcher_Score_t LUCY_ANDMatcher_Score_t
  #define ANDMatcher_Collect LUCY_ANDMatcher_Collect
  #define ANDMatcher_Collect_t LUCY_ANDMatcher_Collect_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_ANDMATCHER */




