/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_COLLECTOR_SORTCOLLECTOR
#define H_LUCY_SEARCH_COLLECTOR_SORTCOLLECTOR 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Collector.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_SORTCOLLECTOR
extern size_t lucy_SortColl_IVARS_OFFSET;
typedef struct lucy_SortCollectorIVARS lucy_SortCollectorIVARS;
static CFISH_INLINE lucy_SortCollectorIVARS*
lucy_SortColl_IVARS(lucy_SortCollector *self) {
   char *ptr = (char*)self + lucy_SortColl_IVARS_OFFSET;
   return (lucy_SortCollectorIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define SortCollectorIVARS lucy_SortCollectorIVARS
  #define SortColl_IVARS lucy_SortColl_IVARS
#endif

struct lucy_SortCollectorIVARS {
    lucy_SegReader* reader;
    lucy_Matcher* matcher;
    int32_t base;
    uint32_t wanted;
    uint32_t total_hits;
    lucy_HitQueue* hit_q;
    lucy_MatchDoc* bumped;
    cfish_VArray* rules;
    lucy_SortCache** sort_caches;
    const void** ord_arrays;
    uint8_t* actions;
    uint8_t* auto_actions;
    uint8_t* derived_actions;
    uint32_t num_rules;
    uint32_t num_actions;
    float bubble_score;
    int32_t bubble_doc;
    int32_t seg_doc_max;
    bool need_score;
    bool need_values;
};

#endif /* C_LUCY_SORTCOLLECTOR */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_SortCollector*
lucy_SortColl_new(lucy_Schema* schema, lucy_SortSpec* sort_spec, uint32_t wanted);

LUCY_VISIBLE lucy_SortCollector*
lucy_SortColl_init(lucy_SortCollector* self, lucy_Schema* schema, lucy_SortSpec* sort_spec, uint32_t wanted);

void
LUCY_SortColl_Destroy_IMP(lucy_SortCollector* self);

void
LUCY_SortColl_Collect_IMP(lucy_SortCollector* self, int32_t doc_id);

void
LUCY_SortColl_Set_Reader_IMP(lucy_SortCollector* self, lucy_SegReader* reader);

bool
LUCY_SortColl_Need_Score_IMP(lucy_SortCollector* self);

cfish_VArray*
LUCY_SortColl_Pop_Match_Docs_IMP(lucy_SortCollector* self);

uint32_t
LUCY_SortColl_Get_Total_Hits_IMP(lucy_SortCollector* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_SortColl_Get_RefCount_t)(lucy_SortCollector *self);

typedef cfish_Obj*
(*LUCY_SortColl_Inc_RefCount_t)(lucy_SortCollector *self);

typedef uint32_t
(*LUCY_SortColl_Dec_RefCount_t)(lucy_SortCollector *self);

typedef void*
(*LUCY_SortColl_To_Host_t)(lucy_SortCollector *self);

typedef cfish_Obj*
(*LUCY_SortColl_Clone_t)(lucy_SortCollector *self);

typedef void
(*LUCY_SortColl_Destroy_t)(lucy_SortCollector *self);

typedef bool
(*LUCY_SortColl_Equals_t)(lucy_SortCollector *self, cfish_Obj* other);

typedef int32_t
(*LUCY_SortColl_Compare_To_t)(lucy_SortCollector *self, cfish_Obj* other);

typedef int32_t
(*LUCY_SortColl_Hash_Sum_t)(lucy_SortCollector *self);

typedef cfish_Class*
(*LUCY_SortColl_Get_Class_t)(lucy_SortCollector *self);

typedef cfish_String*
(*LUCY_SortColl_Get_Class_Name_t)(lucy_SortCollector *self);

typedef bool
(*LUCY_SortColl_Is_A_t)(lucy_SortCollector *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_SortColl_To_String_t)(lucy_SortCollector *self);

typedef int64_t
(*LUCY_SortColl_To_I64_t)(lucy_SortCollector *self);

typedef double
(*LUCY_SortColl_To_F64_t)(lucy_SortCollector *self);

typedef bool
(*LUCY_SortColl_To_Bool_t)(lucy_SortCollector *self);

typedef void
(*LUCY_SortColl_Mimic_t)(lucy_SortCollector *self, cfish_Obj* other);

typedef void
(*LUCY_SortColl_Collect_t)(lucy_SortCollector *self, int32_t doc_id);

typedef void
(*LUCY_SortColl_Set_Reader_t)(lucy_SortCollector *self, lucy_SegReader* reader);

typedef void
(*LUCY_SortColl_Set_Base_t)(lucy_SortCollector *self, int32_t base);

typedef bool
(*LUCY_SortColl_Need_Score_t)(lucy_SortCollector *self);

typedef void
(*LUCY_SortColl_Set_Matcher_t)(lucy_SortCollector *self, lucy_Matcher* matcher);

typedef cfish_VArray*
(*LUCY_SortColl_Pop_Match_Docs_t)(lucy_SortCollector *self);

typedef uint32_t
(*LUCY_SortColl_Get_Total_Hits_t)(lucy_SortCollector *self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_SortColl_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_SortColl_Get_RefCount(lucy_SortCollector *self) {
    const LUCY_SortColl_Get_RefCount_t method = (LUCY_SortColl_Get_RefCount_t)cfish_obj_method(self, LUCY_SortColl_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SortColl_Inc_RefCount(lucy_SortCollector *self) {
    const LUCY_SortColl_Inc_RefCount_t method = (LUCY_SortColl_Inc_RefCount_t)cfish_obj_method(self, LUCY_SortColl_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_SortColl_Dec_RefCount(lucy_SortCollector *self) {
    const LUCY_SortColl_Dec_RefCount_t method = (LUCY_SortColl_Dec_RefCount_t)cfish_obj_method(self, LUCY_SortColl_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_SortColl_To_Host(lucy_SortCollector *self) {
    const LUCY_SortColl_To_Host_t method = (LUCY_SortColl_To_Host_t)cfish_obj_method(self, LUCY_SortColl_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_SortColl_Clone(lucy_SortCollector *self) {
    const LUCY_SortColl_Clone_t method = (LUCY_SortColl_Clone_t)cfish_obj_method(self, LUCY_SortColl_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_SortColl_Destroy(lucy_SortCollector *self) {
    const LUCY_SortColl_Destroy_t method = (LUCY_SortColl_Destroy_t)cfish_obj_method(self, LUCY_SortColl_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_SortColl_Equals(lucy_SortCollector *self, cfish_Obj* other) {
    const LUCY_SortColl_Equals_t method = (LUCY_SortColl_Equals_t)cfish_obj_method(self, LUCY_SortColl_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_SortColl_Compare_To(lucy_SortCollector *self, cfish_Obj* other) {
    const LUCY_SortColl_Compare_To_t method = (LUCY_SortColl_Compare_To_t)cfish_obj_method(self, LUCY_SortColl_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_SortColl_Hash_Sum(lucy_SortCollector *self) {
    const LUCY_SortColl_Hash_Sum_t method = (LUCY_SortColl_Hash_Sum_t)cfish_obj_method(self, LUCY_SortColl_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_SortColl_Get_Class(lucy_SortCollector *self) {
    const LUCY_SortColl_Get_Class_t method = (LUCY_SortColl_Get_Class_t)cfish_obj_method(self, LUCY_SortColl_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_SortColl_Get_Class_Name(lucy_SortCollector *self) {
    const LUCY_SortColl_Get_Class_Name_t method = (LUCY_SortColl_Get_Class_Name_t)cfish_obj_method(self, LUCY_SortColl_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_SortColl_Is_A(lucy_SortCollector *self, cfish_Class* ancestor) {
    const LUCY_SortColl_Is_A_t method = (LUCY_SortColl_Is_A_t)cfish_obj_method(self, LUCY_SortColl_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_SortColl_To_String(lucy_SortCollector *self) {
    const LUCY_SortColl_To_String_t method = (LUCY_SortColl_To_String_t)cfish_obj_method(self, LUCY_SortColl_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_SortColl_To_I64(lucy_SortCollector *self) {
    const LUCY_SortColl_To_I64_t method = (LUCY_SortColl_To_I64_t)cfish_obj_method(self, LUCY_SortColl_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_SortColl_To_F64(lucy_SortCollector *self) {
    const LUCY_SortColl_To_F64_t method = (LUCY_SortColl_To_F64_t)cfish_obj_method(self, LUCY_SortColl_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_SortColl_To_Bool(lucy_SortCollector *self) {
    const LUCY_SortColl_To_Bool_t method = (LUCY_SortColl_To_Bool_t)cfish_obj_method(self, LUCY_SortColl_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_SortColl_Mimic(lucy_SortCollector *self, cfish_Obj* other) {
    const LUCY_SortColl_Mimic_t method = (LUCY_SortColl_Mimic_t)cfish_obj_method(self, LUCY_SortColl_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Collect_OFFSET;
static CFISH_INLINE void
LUCY_SortColl_Collect(lucy_SortCollector *self, int32_t doc_id) {
    const LUCY_SortColl_Collect_t method = (LUCY_SortColl_Collect_t)cfish_obj_method(self, LUCY_SortColl_Collect_OFFSET);
    method(self, doc_id);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Set_Reader_OFFSET;
static CFISH_INLINE void
LUCY_SortColl_Set_Reader(lucy_SortCollector *self, lucy_SegReader* reader) {
    const LUCY_SortColl_Set_Reader_t method = (LUCY_SortColl_Set_Reader_t)cfish_obj_method(self, LUCY_SortColl_Set_Reader_OFFSET);
    method(self, reader);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Set_Base_OFFSET;
static CFISH_INLINE void
LUCY_SortColl_Set_Base(lucy_SortCollector *self, int32_t base) {
    const LUCY_SortColl_Set_Base_t method = (LUCY_SortColl_Set_Base_t)cfish_obj_method(self, LUCY_SortColl_Set_Base_OFFSET);
    method(self, base);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Need_Score_OFFSET;
static CFISH_INLINE bool
LUCY_SortColl_Need_Score(lucy_SortCollector *self) {
    const LUCY_SortColl_Need_Score_t method = (LUCY_SortColl_Need_Score_t)cfish_obj_method(self, LUCY_SortColl_Need_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Set_Matcher_OFFSET;
static CFISH_INLINE void
LUCY_SortColl_Set_Matcher(lucy_SortCollector *self, lucy_Matcher* matcher) {
    const LUCY_SortColl_Set_Matcher_t method = (LUCY_SortColl_Set_Matcher_t)cfish_obj_method(self, LUCY_SortColl_Set_Matcher_OFFSET);
    method(self, matcher);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Pop_Match_Docs_OFFSET;
static CFISH_INLINE cfish_VArray*
LUCY_SortColl_Pop_Match_Docs(lucy_SortCollector *self) {
    const LUCY_SortColl_Pop_Match_Docs_t method = (LUCY_SortColl_Pop_Match_Docs_t)cfish_obj_method(self, LUCY_SortColl_Pop_Match_Docs_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_SortColl_Get_Total_Hits_OFFSET;
static CFISH_INLINE uint32_t
LUCY_SortColl_Get_Total_Hits(lucy_SortCollector *self) {
    const LUCY_SortColl_Get_Total_Hits_t method = (LUCY_SortColl_Get_Total_Hits_t)cfish_obj_method(self, LUCY_SortColl_Get_Total_Hits_OFFSET);
    return method(self);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_SORTCOLLECTOR;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define SortCollector lucy_SortCollector
  #define SORTCOLLECTOR LUCY_SORTCOLLECTOR
  #define SortColl_new lucy_SortColl_new
  #define SortColl_init lucy_SortColl_init
  #define SortColl_Destroy_IMP LUCY_SortColl_Destroy_IMP
  #define SortColl_Collect_IMP LUCY_SortColl_Collect_IMP
  #define SortColl_Set_Reader_IMP LUCY_SortColl_Set_Reader_IMP
  #define SortColl_Need_Score_IMP LUCY_SortColl_Need_Score_IMP
  #define SortColl_Pop_Match_Docs_IMP LUCY_SortColl_Pop_Match_Docs_IMP
  #define SortColl_Get_Total_Hits_IMP LUCY_SortColl_Get_Total_Hits_IMP
  #define SortColl_Get_RefCount LUCY_SortColl_Get_RefCount
  #define SortColl_Get_RefCount_t LUCY_SortColl_Get_RefCount_t
  #define SortColl_Inc_RefCount LUCY_SortColl_Inc_RefCount
  #define SortColl_Inc_RefCount_t LUCY_SortColl_Inc_RefCount_t
  #define SortColl_Dec_RefCount LUCY_SortColl_Dec_RefCount
  #define SortColl_Dec_RefCount_t LUCY_SortColl_Dec_RefCount_t
  #define SortColl_To_Host LUCY_SortColl_To_Host
  #define SortColl_To_Host_t LUCY_SortColl_To_Host_t
  #define SortColl_Clone LUCY_SortColl_Clone
  #define SortColl_Clone_t LUCY_SortColl_Clone_t
  #define SortColl_Destroy LUCY_SortColl_Destroy
  #define SortColl_Destroy_t LUCY_SortColl_Destroy_t
  #define SortColl_Equals LUCY_SortColl_Equals
  #define SortColl_Equals_t LUCY_SortColl_Equals_t
  #define SortColl_Compare_To LUCY_SortColl_Compare_To
  #define SortColl_Compare_To_t LUCY_SortColl_Compare_To_t
  #define SortColl_Hash_Sum LUCY_SortColl_Hash_Sum
  #define SortColl_Hash_Sum_t LUCY_SortColl_Hash_Sum_t
  #define SortColl_Get_Class LUCY_SortColl_Get_Class
  #define SortColl_Get_Class_t LUCY_SortColl_Get_Class_t
  #define SortColl_Get_Class_Name LUCY_SortColl_Get_Class_Name
  #define SortColl_Get_Class_Name_t LUCY_SortColl_Get_Class_Name_t
  #define SortColl_Is_A LUCY_SortColl_Is_A
  #define SortColl_Is_A_t LUCY_SortColl_Is_A_t
  #define SortColl_To_String LUCY_SortColl_To_String
  #define SortColl_To_String_t LUCY_SortColl_To_String_t
  #define SortColl_To_I64 LUCY_SortColl_To_I64
  #define SortColl_To_I64_t LUCY_SortColl_To_I64_t
  #define SortColl_To_F64 LUCY_SortColl_To_F64
  #define SortColl_To_F64_t LUCY_SortColl_To_F64_t
  #define SortColl_To_Bool LUCY_SortColl_To_Bool
  #define SortColl_To_Bool_t LUCY_SortColl_To_Bool_t
  #define SortColl_Mimic LUCY_SortColl_Mimic
  #define SortColl_Mimic_t LUCY_SortColl_Mimic_t
  #define SortColl_Collect LUCY_SortColl_Collect
  #define SortColl_Collect_t LUCY_SortColl_Collect_t
  #define SortColl_Set_Reader LUCY_SortColl_Set_Reader
  #define SortColl_Set_Reader_t LUCY_SortColl_Set_Reader_t
  #define SortColl_Set_Base LUCY_SortColl_Set_Base
  #define SortColl_Set_Base_t LUCY_SortColl_Set_Base_t
  #define SortColl_Need_Score LUCY_SortColl_Need_Score
  #define SortColl_Need_Score_t LUCY_SortColl_Need_Score_t
  #define SortColl_Set_Matcher LUCY_SortColl_Set_Matcher
  #define SortColl_Set_Matcher_t LUCY_SortColl_Set_Matcher_t
  #define SortColl_Pop_Match_Docs LUCY_SortColl_Pop_Match_Docs
  #define SortColl_Pop_Match_Docs_t LUCY_SortColl_Pop_Match_Docs_t
  #define SortColl_Get_Total_Hits LUCY_SortColl_Get_Total_Hits
  #define SortColl_Get_Total_Hits_t LUCY_SortColl_Get_Total_Hits_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_COLLECTOR_SORTCOLLECTOR */




