/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_PHRASEMATCHER
#define H_LUCY_SEARCH_PHRASEMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_PHRASEMATCHER
extern size_t lucy_PhraseMatcher_IVARS_OFFSET;
typedef struct lucy_PhraseMatcherIVARS lucy_PhraseMatcherIVARS;
static CFISH_INLINE lucy_PhraseMatcherIVARS*
lucy_PhraseMatcher_IVARS(lucy_PhraseMatcher *self) {
   char *ptr = (char*)self + lucy_PhraseMatcher_IVARS_OFFSET;
   return (lucy_PhraseMatcherIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define PhraseMatcherIVARS lucy_PhraseMatcherIVARS
  #define PhraseMatcher_IVARS lucy_PhraseMatcher_IVARS
#endif

struct lucy_PhraseMatcherIVARS {
    int32_t doc_id;
    uint32_t num_elements;
    lucy_Similarity* sim;
    lucy_PostingList** plists;
    cfish_ByteBuf* anchor_set;
    float phrase_freq;
    float phrase_boost;
    lucy_Compiler* compiler;
    float weight;
    bool first_time;
    bool more;
};

#endif /* C_LUCY_PHRASEMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_PhraseMatcher*
lucy_PhraseMatcher_new(lucy_Similarity* similarity, cfish_VArray* posting_lists, lucy_Compiler* compiler);

LUCY_VISIBLE lucy_PhraseMatcher*
lucy_PhraseMatcher_init(lucy_PhraseMatcher* self, lucy_Similarity* similarity, cfish_VArray* posting_lists, lucy_Compiler* compiler);

void
LUCY_PhraseMatcher_Destroy_IMP(lucy_PhraseMatcher* self);

int32_t
LUCY_PhraseMatcher_Next_IMP(lucy_PhraseMatcher* self);

int32_t
LUCY_PhraseMatcher_Advance_IMP(lucy_PhraseMatcher* self, int32_t target);

int32_t
LUCY_PhraseMatcher_Get_Doc_ID_IMP(lucy_PhraseMatcher* self);

float
LUCY_PhraseMatcher_Score_IMP(lucy_PhraseMatcher* self);

float
LUCY_PhraseMatcher_Calc_Phrase_Freq_IMP(lucy_PhraseMatcher* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_PhraseMatcher_Get_RefCount_t)(lucy_PhraseMatcher *self);

typedef cfish_Obj*
(*LUCY_PhraseMatcher_Inc_RefCount_t)(lucy_PhraseMatcher *self);

typedef uint32_t
(*LUCY_PhraseMatcher_Dec_RefCount_t)(lucy_PhraseMatcher *self);

typedef void*
(*LUCY_PhraseMatcher_To_Host_t)(lucy_PhraseMatcher *self);

typedef cfish_Obj*
(*LUCY_PhraseMatcher_Clone_t)(lucy_PhraseMatcher *self);

typedef void
(*LUCY_PhraseMatcher_Destroy_t)(lucy_PhraseMatcher *self);

typedef bool
(*LUCY_PhraseMatcher_Equals_t)(lucy_PhraseMatcher *self, cfish_Obj* other);

typedef int32_t
(*LUCY_PhraseMatcher_Compare_To_t)(lucy_PhraseMatcher *self, cfish_Obj* other);

typedef int32_t
(*LUCY_PhraseMatcher_Hash_Sum_t)(lucy_PhraseMatcher *self);

typedef cfish_Class*
(*LUCY_PhraseMatcher_Get_Class_t)(lucy_PhraseMatcher *self);

typedef cfish_String*
(*LUCY_PhraseMatcher_Get_Class_Name_t)(lucy_PhraseMatcher *self);

typedef bool
(*LUCY_PhraseMatcher_Is_A_t)(lucy_PhraseMatcher *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_PhraseMatcher_To_String_t)(lucy_PhraseMatcher *self);

typedef int64_t
(*LUCY_PhraseMatcher_To_I64_t)(lucy_PhraseMatcher *self);

typedef double
(*LUCY_PhraseMatcher_To_F64_t)(lucy_PhraseMatcher *self);

typedef bool
(*LUCY_PhraseMatcher_To_Bool_t)(lucy_PhraseMatcher *self);

typedef void
(*LUCY_PhraseMatcher_Mimic_t)(lucy_PhraseMatcher *self, cfish_Obj* other);

typedef int32_t
(*LUCY_PhraseMatcher_Next_t)(lucy_PhraseMatcher *self);

typedef int32_t
(*LUCY_PhraseMatcher_Advance_t)(lucy_PhraseMatcher *self, int32_t target);

typedef int32_t
(*LUCY_PhraseMatcher_Get_Doc_ID_t)(lucy_PhraseMatcher *self);

typedef float
(*LUCY_PhraseMatcher_Score_t)(lucy_PhraseMatcher *self);

typedef void
(*LUCY_PhraseMatcher_Collect_t)(lucy_PhraseMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions);

typedef float
(*LUCY_PhraseMatcher_Calc_Phrase_Freq_t)(lucy_PhraseMatcher *self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_PhraseMatcher_Get_RefCount(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Get_RefCount_t method = (LUCY_PhraseMatcher_Get_RefCount_t)cfish_obj_method(self, LUCY_PhraseMatcher_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_PhraseMatcher_Inc_RefCount(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Inc_RefCount_t method = (LUCY_PhraseMatcher_Inc_RefCount_t)cfish_obj_method(self, LUCY_PhraseMatcher_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_PhraseMatcher_Dec_RefCount(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Dec_RefCount_t method = (LUCY_PhraseMatcher_Dec_RefCount_t)cfish_obj_method(self, LUCY_PhraseMatcher_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_PhraseMatcher_To_Host(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_To_Host_t method = (LUCY_PhraseMatcher_To_Host_t)cfish_obj_method(self, LUCY_PhraseMatcher_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_PhraseMatcher_Clone(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Clone_t method = (LUCY_PhraseMatcher_Clone_t)cfish_obj_method(self, LUCY_PhraseMatcher_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_PhraseMatcher_Destroy(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Destroy_t method = (LUCY_PhraseMatcher_Destroy_t)cfish_obj_method(self, LUCY_PhraseMatcher_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_PhraseMatcher_Equals(lucy_PhraseMatcher *self, cfish_Obj* other) {
    const LUCY_PhraseMatcher_Equals_t method = (LUCY_PhraseMatcher_Equals_t)cfish_obj_method(self, LUCY_PhraseMatcher_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_PhraseMatcher_Compare_To(lucy_PhraseMatcher *self, cfish_Obj* other) {
    const LUCY_PhraseMatcher_Compare_To_t method = (LUCY_PhraseMatcher_Compare_To_t)cfish_obj_method(self, LUCY_PhraseMatcher_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_PhraseMatcher_Hash_Sum(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Hash_Sum_t method = (LUCY_PhraseMatcher_Hash_Sum_t)cfish_obj_method(self, LUCY_PhraseMatcher_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_PhraseMatcher_Get_Class(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Get_Class_t method = (LUCY_PhraseMatcher_Get_Class_t)cfish_obj_method(self, LUCY_PhraseMatcher_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_PhraseMatcher_Get_Class_Name(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Get_Class_Name_t method = (LUCY_PhraseMatcher_Get_Class_Name_t)cfish_obj_method(self, LUCY_PhraseMatcher_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_PhraseMatcher_Is_A(lucy_PhraseMatcher *self, cfish_Class* ancestor) {
    const LUCY_PhraseMatcher_Is_A_t method = (LUCY_PhraseMatcher_Is_A_t)cfish_obj_method(self, LUCY_PhraseMatcher_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_PhraseMatcher_To_String(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_To_String_t method = (LUCY_PhraseMatcher_To_String_t)cfish_obj_method(self, LUCY_PhraseMatcher_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_PhraseMatcher_To_I64(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_To_I64_t method = (LUCY_PhraseMatcher_To_I64_t)cfish_obj_method(self, LUCY_PhraseMatcher_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_PhraseMatcher_To_F64(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_To_F64_t method = (LUCY_PhraseMatcher_To_F64_t)cfish_obj_method(self, LUCY_PhraseMatcher_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_PhraseMatcher_To_Bool(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_To_Bool_t method = (LUCY_PhraseMatcher_To_Bool_t)cfish_obj_method(self, LUCY_PhraseMatcher_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_PhraseMatcher_Mimic(lucy_PhraseMatcher *self, cfish_Obj* other) {
    const LUCY_PhraseMatcher_Mimic_t method = (LUCY_PhraseMatcher_Mimic_t)cfish_obj_method(self, LUCY_PhraseMatcher_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Next_OFFSET;
static CFISH_INLINE int32_t
LUCY_PhraseMatcher_Next(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Next_t method = (LUCY_PhraseMatcher_Next_t)cfish_obj_method(self, LUCY_PhraseMatcher_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Advance_OFFSET;
static CFISH_INLINE int32_t
LUCY_PhraseMatcher_Advance(lucy_PhraseMatcher *self, int32_t target) {
    const LUCY_PhraseMatcher_Advance_t method = (LUCY_PhraseMatcher_Advance_t)cfish_obj_method(self, LUCY_PhraseMatcher_Advance_OFFSET);
    return method(self, target);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Get_Doc_ID_OFFSET;
static CFISH_INLINE int32_t
LUCY_PhraseMatcher_Get_Doc_ID(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Get_Doc_ID_t method = (LUCY_PhraseMatcher_Get_Doc_ID_t)cfish_obj_method(self, LUCY_PhraseMatcher_Get_Doc_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Score_OFFSET;
static CFISH_INLINE float
LUCY_PhraseMatcher_Score(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Score_t method = (LUCY_PhraseMatcher_Score_t)cfish_obj_method(self, LUCY_PhraseMatcher_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Collect_OFFSET;
static CFISH_INLINE void
LUCY_PhraseMatcher_Collect(lucy_PhraseMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    const LUCY_PhraseMatcher_Collect_t method = (LUCY_PhraseMatcher_Collect_t)cfish_obj_method(self, LUCY_PhraseMatcher_Collect_OFFSET);
    method(self, collector, deletions);
}

extern LUCY_VISIBLE size_t LUCY_PhraseMatcher_Calc_Phrase_Freq_OFFSET;
static CFISH_INLINE float
LUCY_PhraseMatcher_Calc_Phrase_Freq(lucy_PhraseMatcher *self) {
    const LUCY_PhraseMatcher_Calc_Phrase_Freq_t method = (LUCY_PhraseMatcher_Calc_Phrase_Freq_t)cfish_obj_method(self, LUCY_PhraseMatcher_Calc_Phrase_Freq_OFFSET);
    return method(self);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_PHRASEMATCHER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define PhraseMatcher lucy_PhraseMatcher
  #define PHRASEMATCHER LUCY_PHRASEMATCHER
  #define PhraseMatcher_new lucy_PhraseMatcher_new
  #define PhraseMatcher_init lucy_PhraseMatcher_init
  #define PhraseMatcher_Destroy_IMP LUCY_PhraseMatcher_Destroy_IMP
  #define PhraseMatcher_Next_IMP LUCY_PhraseMatcher_Next_IMP
  #define PhraseMatcher_Advance_IMP LUCY_PhraseMatcher_Advance_IMP
  #define PhraseMatcher_Get_Doc_ID_IMP LUCY_PhraseMatcher_Get_Doc_ID_IMP
  #define PhraseMatcher_Score_IMP LUCY_PhraseMatcher_Score_IMP
  #define PhraseMatcher_Calc_Phrase_Freq_IMP LUCY_PhraseMatcher_Calc_Phrase_Freq_IMP
  #define PhraseMatcher_Get_RefCount LUCY_PhraseMatcher_Get_RefCount
  #define PhraseMatcher_Get_RefCount_t LUCY_PhraseMatcher_Get_RefCount_t
  #define PhraseMatcher_Inc_RefCount LUCY_PhraseMatcher_Inc_RefCount
  #define PhraseMatcher_Inc_RefCount_t LUCY_PhraseMatcher_Inc_RefCount_t
  #define PhraseMatcher_Dec_RefCount LUCY_PhraseMatcher_Dec_RefCount
  #define PhraseMatcher_Dec_RefCount_t LUCY_PhraseMatcher_Dec_RefCount_t
  #define PhraseMatcher_To_Host LUCY_PhraseMatcher_To_Host
  #define PhraseMatcher_To_Host_t LUCY_PhraseMatcher_To_Host_t
  #define PhraseMatcher_Clone LUCY_PhraseMatcher_Clone
  #define PhraseMatcher_Clone_t LUCY_PhraseMatcher_Clone_t
  #define PhraseMatcher_Destroy LUCY_PhraseMatcher_Destroy
  #define PhraseMatcher_Destroy_t LUCY_PhraseMatcher_Destroy_t
  #define PhraseMatcher_Equals LUCY_PhraseMatcher_Equals
  #define PhraseMatcher_Equals_t LUCY_PhraseMatcher_Equals_t
  #define PhraseMatcher_Compare_To LUCY_PhraseMatcher_Compare_To
  #define PhraseMatcher_Compare_To_t LUCY_PhraseMatcher_Compare_To_t
  #define PhraseMatcher_Hash_Sum LUCY_PhraseMatcher_Hash_Sum
  #define PhraseMatcher_Hash_Sum_t LUCY_PhraseMatcher_Hash_Sum_t
  #define PhraseMatcher_Get_Class LUCY_PhraseMatcher_Get_Class
  #define PhraseMatcher_Get_Class_t LUCY_PhraseMatcher_Get_Class_t
  #define PhraseMatcher_Get_Class_Name LUCY_PhraseMatcher_Get_Class_Name
  #define PhraseMatcher_Get_Class_Name_t LUCY_PhraseMatcher_Get_Class_Name_t
  #define PhraseMatcher_Is_A LUCY_PhraseMatcher_Is_A
  #define PhraseMatcher_Is_A_t LUCY_PhraseMatcher_Is_A_t
  #define PhraseMatcher_To_String LUCY_PhraseMatcher_To_String
  #define PhraseMatcher_To_String_t LUCY_PhraseMatcher_To_String_t
  #define PhraseMatcher_To_I64 LUCY_PhraseMatcher_To_I64
  #define PhraseMatcher_To_I64_t LUCY_PhraseMatcher_To_I64_t
  #define PhraseMatcher_To_F64 LUCY_PhraseMatcher_To_F64
  #define PhraseMatcher_To_F64_t LUCY_PhraseMatcher_To_F64_t
  #define PhraseMatcher_To_Bool LUCY_PhraseMatcher_To_Bool
  #define PhraseMatcher_To_Bool_t LUCY_PhraseMatcher_To_Bool_t
  #define PhraseMatcher_Mimic LUCY_PhraseMatcher_Mimic
  #define PhraseMatcher_Mimic_t LUCY_PhraseMatcher_Mimic_t
  #define PhraseMatcher_Next LUCY_PhraseMatcher_Next
  #define PhraseMatcher_Next_t LUCY_PhraseMatcher_Next_t
  #define PhraseMatcher_Advance LUCY_PhraseMatcher_Advance
  #define PhraseMatcher_Advance_t LUCY_PhraseMatcher_Advance_t
  #define PhraseMatcher_Get_Doc_ID LUCY_PhraseMatcher_Get_Doc_ID
  #define PhraseMatcher_Get_Doc_ID_t LUCY_PhraseMatcher_Get_Doc_ID_t
  #define PhraseMatcher_Score LUCY_PhraseMatcher_Score
  #define PhraseMatcher_Score_t LUCY_PhraseMatcher_Score_t
  #define PhraseMatcher_Collect LUCY_PhraseMatcher_Collect
  #define PhraseMatcher_Collect_t LUCY_PhraseMatcher_Collect_t
  #define PhraseMatcher_Calc_Phrase_Freq LUCY_PhraseMatcher_Calc_Phrase_Freq
  #define PhraseMatcher_Calc_Phrase_Freq_t LUCY_PhraseMatcher_Calc_Phrase_Freq_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_PHRASEMATCHER */




