/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_RANGEMATCHER
#define H_LUCY_SEARCH_RANGEMATCHER 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Matcher.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RANGEMATCHER
extern size_t lucy_RangeMatcher_IVARS_OFFSET;
typedef struct lucy_RangeMatcherIVARS lucy_RangeMatcherIVARS;
static CFISH_INLINE lucy_RangeMatcherIVARS*
lucy_RangeMatcher_IVARS(lucy_RangeMatcher *self) {
   char *ptr = (char*)self + lucy_RangeMatcher_IVARS_OFFSET;
   return (lucy_RangeMatcherIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define RangeMatcherIVARS lucy_RangeMatcherIVARS
  #define RangeMatcher_IVARS lucy_RangeMatcher_IVARS
#endif

struct lucy_RangeMatcherIVARS {
    int32_t doc_id;
    int32_t doc_max;
    int32_t lower_bound;
    int32_t upper_bound;
    lucy_SortCache* sort_cache;
};

#endif /* C_LUCY_RANGEMATCHER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_RangeMatcher*
lucy_RangeMatcher_new(int32_t lower_bound, int32_t upper_bound, lucy_SortCache* sort_cache, int32_t doc_max);

LUCY_VISIBLE lucy_RangeMatcher*
lucy_RangeMatcher_init(lucy_RangeMatcher* self, int32_t lower_bound, int32_t upper_bound, lucy_SortCache* sort_cache, int32_t doc_max);

void
LUCY_RangeMatcher_Destroy_IMP(lucy_RangeMatcher* self);

int32_t
LUCY_RangeMatcher_Next_IMP(lucy_RangeMatcher* self);

int32_t
LUCY_RangeMatcher_Advance_IMP(lucy_RangeMatcher* self, int32_t target);

int32_t
LUCY_RangeMatcher_Get_Doc_ID_IMP(lucy_RangeMatcher* self);

float
LUCY_RangeMatcher_Score_IMP(lucy_RangeMatcher* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_RangeMatcher_Get_RefCount_t)(lucy_RangeMatcher *self);

typedef cfish_Obj*
(*LUCY_RangeMatcher_Inc_RefCount_t)(lucy_RangeMatcher *self);

typedef uint32_t
(*LUCY_RangeMatcher_Dec_RefCount_t)(lucy_RangeMatcher *self);

typedef void*
(*LUCY_RangeMatcher_To_Host_t)(lucy_RangeMatcher *self);

typedef cfish_Obj*
(*LUCY_RangeMatcher_Clone_t)(lucy_RangeMatcher *self);

typedef void
(*LUCY_RangeMatcher_Destroy_t)(lucy_RangeMatcher *self);

typedef bool
(*LUCY_RangeMatcher_Equals_t)(lucy_RangeMatcher *self, cfish_Obj* other);

typedef int32_t
(*LUCY_RangeMatcher_Compare_To_t)(lucy_RangeMatcher *self, cfish_Obj* other);

typedef int32_t
(*LUCY_RangeMatcher_Hash_Sum_t)(lucy_RangeMatcher *self);

typedef cfish_Class*
(*LUCY_RangeMatcher_Get_Class_t)(lucy_RangeMatcher *self);

typedef cfish_String*
(*LUCY_RangeMatcher_Get_Class_Name_t)(lucy_RangeMatcher *self);

typedef bool
(*LUCY_RangeMatcher_Is_A_t)(lucy_RangeMatcher *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_RangeMatcher_To_String_t)(lucy_RangeMatcher *self);

typedef int64_t
(*LUCY_RangeMatcher_To_I64_t)(lucy_RangeMatcher *self);

typedef double
(*LUCY_RangeMatcher_To_F64_t)(lucy_RangeMatcher *self);

typedef bool
(*LUCY_RangeMatcher_To_Bool_t)(lucy_RangeMatcher *self);

typedef void
(*LUCY_RangeMatcher_Mimic_t)(lucy_RangeMatcher *self, cfish_Obj* other);

typedef int32_t
(*LUCY_RangeMatcher_Next_t)(lucy_RangeMatcher *self);

typedef int32_t
(*LUCY_RangeMatcher_Advance_t)(lucy_RangeMatcher *self, int32_t target);

typedef int32_t
(*LUCY_RangeMatcher_Get_Doc_ID_t)(lucy_RangeMatcher *self);

typedef float
(*LUCY_RangeMatcher_Score_t)(lucy_RangeMatcher *self);

typedef void
(*LUCY_RangeMatcher_Collect_t)(lucy_RangeMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_RangeMatcher_Get_RefCount(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Get_RefCount_t method = (LUCY_RangeMatcher_Get_RefCount_t)cfish_obj_method(self, LUCY_RangeMatcher_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeMatcher_Inc_RefCount(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Inc_RefCount_t method = (LUCY_RangeMatcher_Inc_RefCount_t)cfish_obj_method(self, LUCY_RangeMatcher_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_RangeMatcher_Dec_RefCount(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Dec_RefCount_t method = (LUCY_RangeMatcher_Dec_RefCount_t)cfish_obj_method(self, LUCY_RangeMatcher_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_RangeMatcher_To_Host(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_To_Host_t method = (LUCY_RangeMatcher_To_Host_t)cfish_obj_method(self, LUCY_RangeMatcher_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeMatcher_Clone(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Clone_t method = (LUCY_RangeMatcher_Clone_t)cfish_obj_method(self, LUCY_RangeMatcher_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_RangeMatcher_Destroy(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Destroy_t method = (LUCY_RangeMatcher_Destroy_t)cfish_obj_method(self, LUCY_RangeMatcher_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_RangeMatcher_Equals(lucy_RangeMatcher *self, cfish_Obj* other) {
    const LUCY_RangeMatcher_Equals_t method = (LUCY_RangeMatcher_Equals_t)cfish_obj_method(self, LUCY_RangeMatcher_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_RangeMatcher_Compare_To(lucy_RangeMatcher *self, cfish_Obj* other) {
    const LUCY_RangeMatcher_Compare_To_t method = (LUCY_RangeMatcher_Compare_To_t)cfish_obj_method(self, LUCY_RangeMatcher_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_RangeMatcher_Hash_Sum(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Hash_Sum_t method = (LUCY_RangeMatcher_Hash_Sum_t)cfish_obj_method(self, LUCY_RangeMatcher_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_RangeMatcher_Get_Class(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Get_Class_t method = (LUCY_RangeMatcher_Get_Class_t)cfish_obj_method(self, LUCY_RangeMatcher_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RangeMatcher_Get_Class_Name(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Get_Class_Name_t method = (LUCY_RangeMatcher_Get_Class_Name_t)cfish_obj_method(self, LUCY_RangeMatcher_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_RangeMatcher_Is_A(lucy_RangeMatcher *self, cfish_Class* ancestor) {
    const LUCY_RangeMatcher_Is_A_t method = (LUCY_RangeMatcher_Is_A_t)cfish_obj_method(self, LUCY_RangeMatcher_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RangeMatcher_To_String(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_To_String_t method = (LUCY_RangeMatcher_To_String_t)cfish_obj_method(self, LUCY_RangeMatcher_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_RangeMatcher_To_I64(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_To_I64_t method = (LUCY_RangeMatcher_To_I64_t)cfish_obj_method(self, LUCY_RangeMatcher_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_RangeMatcher_To_F64(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_To_F64_t method = (LUCY_RangeMatcher_To_F64_t)cfish_obj_method(self, LUCY_RangeMatcher_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_RangeMatcher_To_Bool(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_To_Bool_t method = (LUCY_RangeMatcher_To_Bool_t)cfish_obj_method(self, LUCY_RangeMatcher_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_RangeMatcher_Mimic(lucy_RangeMatcher *self, cfish_Obj* other) {
    const LUCY_RangeMatcher_Mimic_t method = (LUCY_RangeMatcher_Mimic_t)cfish_obj_method(self, LUCY_RangeMatcher_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Next_OFFSET;
static CFISH_INLINE int32_t
LUCY_RangeMatcher_Next(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Next_t method = (LUCY_RangeMatcher_Next_t)cfish_obj_method(self, LUCY_RangeMatcher_Next_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Advance_OFFSET;
static CFISH_INLINE int32_t
LUCY_RangeMatcher_Advance(lucy_RangeMatcher *self, int32_t target) {
    const LUCY_RangeMatcher_Advance_t method = (LUCY_RangeMatcher_Advance_t)cfish_obj_method(self, LUCY_RangeMatcher_Advance_OFFSET);
    return method(self, target);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Get_Doc_ID_OFFSET;
static CFISH_INLINE int32_t
LUCY_RangeMatcher_Get_Doc_ID(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Get_Doc_ID_t method = (LUCY_RangeMatcher_Get_Doc_ID_t)cfish_obj_method(self, LUCY_RangeMatcher_Get_Doc_ID_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Score_OFFSET;
static CFISH_INLINE float
LUCY_RangeMatcher_Score(lucy_RangeMatcher *self) {
    const LUCY_RangeMatcher_Score_t method = (LUCY_RangeMatcher_Score_t)cfish_obj_method(self, LUCY_RangeMatcher_Score_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeMatcher_Collect_OFFSET;
static CFISH_INLINE void
LUCY_RangeMatcher_Collect(lucy_RangeMatcher *self, lucy_Collector* collector, lucy_Matcher* deletions) {
    const LUCY_RangeMatcher_Collect_t method = (LUCY_RangeMatcher_Collect_t)cfish_obj_method(self, LUCY_RangeMatcher_Collect_OFFSET);
    method(self, collector, deletions);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_RANGEMATCHER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RangeMatcher lucy_RangeMatcher
  #define RANGEMATCHER LUCY_RANGEMATCHER
  #define RangeMatcher_new lucy_RangeMatcher_new
  #define RangeMatcher_init lucy_RangeMatcher_init
  #define RangeMatcher_Destroy_IMP LUCY_RangeMatcher_Destroy_IMP
  #define RangeMatcher_Next_IMP LUCY_RangeMatcher_Next_IMP
  #define RangeMatcher_Advance_IMP LUCY_RangeMatcher_Advance_IMP
  #define RangeMatcher_Get_Doc_ID_IMP LUCY_RangeMatcher_Get_Doc_ID_IMP
  #define RangeMatcher_Score_IMP LUCY_RangeMatcher_Score_IMP
  #define RangeMatcher_Get_RefCount LUCY_RangeMatcher_Get_RefCount
  #define RangeMatcher_Get_RefCount_t LUCY_RangeMatcher_Get_RefCount_t
  #define RangeMatcher_Inc_RefCount LUCY_RangeMatcher_Inc_RefCount
  #define RangeMatcher_Inc_RefCount_t LUCY_RangeMatcher_Inc_RefCount_t
  #define RangeMatcher_Dec_RefCount LUCY_RangeMatcher_Dec_RefCount
  #define RangeMatcher_Dec_RefCount_t LUCY_RangeMatcher_Dec_RefCount_t
  #define RangeMatcher_To_Host LUCY_RangeMatcher_To_Host
  #define RangeMatcher_To_Host_t LUCY_RangeMatcher_To_Host_t
  #define RangeMatcher_Clone LUCY_RangeMatcher_Clone
  #define RangeMatcher_Clone_t LUCY_RangeMatcher_Clone_t
  #define RangeMatcher_Destroy LUCY_RangeMatcher_Destroy
  #define RangeMatcher_Destroy_t LUCY_RangeMatcher_Destroy_t
  #define RangeMatcher_Equals LUCY_RangeMatcher_Equals
  #define RangeMatcher_Equals_t LUCY_RangeMatcher_Equals_t
  #define RangeMatcher_Compare_To LUCY_RangeMatcher_Compare_To
  #define RangeMatcher_Compare_To_t LUCY_RangeMatcher_Compare_To_t
  #define RangeMatcher_Hash_Sum LUCY_RangeMatcher_Hash_Sum
  #define RangeMatcher_Hash_Sum_t LUCY_RangeMatcher_Hash_Sum_t
  #define RangeMatcher_Get_Class LUCY_RangeMatcher_Get_Class
  #define RangeMatcher_Get_Class_t LUCY_RangeMatcher_Get_Class_t
  #define RangeMatcher_Get_Class_Name LUCY_RangeMatcher_Get_Class_Name
  #define RangeMatcher_Get_Class_Name_t LUCY_RangeMatcher_Get_Class_Name_t
  #define RangeMatcher_Is_A LUCY_RangeMatcher_Is_A
  #define RangeMatcher_Is_A_t LUCY_RangeMatcher_Is_A_t
  #define RangeMatcher_To_String LUCY_RangeMatcher_To_String
  #define RangeMatcher_To_String_t LUCY_RangeMatcher_To_String_t
  #define RangeMatcher_To_I64 LUCY_RangeMatcher_To_I64
  #define RangeMatcher_To_I64_t LUCY_RangeMatcher_To_I64_t
  #define RangeMatcher_To_F64 LUCY_RangeMatcher_To_F64
  #define RangeMatcher_To_F64_t LUCY_RangeMatcher_To_F64_t
  #define RangeMatcher_To_Bool LUCY_RangeMatcher_To_Bool
  #define RangeMatcher_To_Bool_t LUCY_RangeMatcher_To_Bool_t
  #define RangeMatcher_Mimic LUCY_RangeMatcher_Mimic
  #define RangeMatcher_Mimic_t LUCY_RangeMatcher_Mimic_t
  #define RangeMatcher_Next LUCY_RangeMatcher_Next
  #define RangeMatcher_Next_t LUCY_RangeMatcher_Next_t
  #define RangeMatcher_Advance LUCY_RangeMatcher_Advance
  #define RangeMatcher_Advance_t LUCY_RangeMatcher_Advance_t
  #define RangeMatcher_Get_Doc_ID LUCY_RangeMatcher_Get_Doc_ID
  #define RangeMatcher_Get_Doc_ID_t LUCY_RangeMatcher_Get_Doc_ID_t
  #define RangeMatcher_Score LUCY_RangeMatcher_Score
  #define RangeMatcher_Score_t LUCY_RangeMatcher_Score_t
  #define RangeMatcher_Collect LUCY_RangeMatcher_Collect
  #define RangeMatcher_Collect_t LUCY_RangeMatcher_Collect_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_RANGEMATCHER */




