/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_SEARCH_RANGEQUERY
#define H_LUCY_SEARCH_RANGEQUERY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Query.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RANGEQUERY
extern size_t lucy_RangeQuery_IVARS_OFFSET;
typedef struct lucy_RangeQueryIVARS lucy_RangeQueryIVARS;
static CFISH_INLINE lucy_RangeQueryIVARS*
lucy_RangeQuery_IVARS(lucy_RangeQuery *self) {
   char *ptr = (char*)self + lucy_RangeQuery_IVARS_OFFSET;
   return (lucy_RangeQueryIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define RangeQueryIVARS lucy_RangeQueryIVARS
  #define RangeQuery_IVARS lucy_RangeQuery_IVARS
#endif

struct lucy_RangeQueryIVARS {
    float boost;
    cfish_String* field;
    cfish_Obj* lower_term;
    cfish_Obj* upper_term;
    bool include_lower;
    bool include_upper;
};

#endif /* C_LUCY_RANGEQUERY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_RangeQuery*
lucy_RangeQuery_new(cfish_String* field, cfish_Obj* lower_term, cfish_Obj* upper_term, bool include_lower, bool include_upper);

LUCY_VISIBLE lucy_RangeQuery*
lucy_RangeQuery_init(lucy_RangeQuery* self, cfish_String* field, cfish_Obj* lower_term, cfish_Obj* upper_term, bool include_lower, bool include_upper);

void
LUCY_RangeQuery_Destroy_IMP(lucy_RangeQuery* self);

bool
LUCY_RangeQuery_Equals_IMP(lucy_RangeQuery* self, cfish_Obj* other);

cfish_String*
LUCY_RangeQuery_To_String_IMP(lucy_RangeQuery* self);

lucy_RangeCompiler*
LUCY_RangeQuery_Make_Compiler_IMP(lucy_RangeQuery* self, lucy_Searcher* searcher, float boost, bool subordinate);

void
LUCY_RangeQuery_Serialize_IMP(lucy_RangeQuery* self, lucy_OutStream* outstream);

lucy_RangeQuery*
LUCY_RangeQuery_Deserialize_IMP(lucy_RangeQuery* self, lucy_InStream* instream);

cfish_Obj*
LUCY_RangeQuery_Dump_IMP(lucy_RangeQuery* self);

cfish_Obj*
LUCY_RangeQuery_Load_IMP(lucy_RangeQuery* self, cfish_Obj* dump);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_RangeQuery_Get_RefCount_t)(lucy_RangeQuery *self);

typedef cfish_Obj*
(*LUCY_RangeQuery_Inc_RefCount_t)(lucy_RangeQuery *self);

typedef uint32_t
(*LUCY_RangeQuery_Dec_RefCount_t)(lucy_RangeQuery *self);

typedef void*
(*LUCY_RangeQuery_To_Host_t)(lucy_RangeQuery *self);

typedef cfish_Obj*
(*LUCY_RangeQuery_Clone_t)(lucy_RangeQuery *self);

typedef void
(*LUCY_RangeQuery_Destroy_t)(lucy_RangeQuery *self);

typedef bool
(*LUCY_RangeQuery_Equals_t)(lucy_RangeQuery *self, cfish_Obj* other);

typedef int32_t
(*LUCY_RangeQuery_Compare_To_t)(lucy_RangeQuery *self, cfish_Obj* other);

typedef int32_t
(*LUCY_RangeQuery_Hash_Sum_t)(lucy_RangeQuery *self);

typedef cfish_Class*
(*LUCY_RangeQuery_Get_Class_t)(lucy_RangeQuery *self);

typedef cfish_String*
(*LUCY_RangeQuery_Get_Class_Name_t)(lucy_RangeQuery *self);

typedef bool
(*LUCY_RangeQuery_Is_A_t)(lucy_RangeQuery *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_RangeQuery_To_String_t)(lucy_RangeQuery *self);

typedef int64_t
(*LUCY_RangeQuery_To_I64_t)(lucy_RangeQuery *self);

typedef double
(*LUCY_RangeQuery_To_F64_t)(lucy_RangeQuery *self);

typedef bool
(*LUCY_RangeQuery_To_Bool_t)(lucy_RangeQuery *self);

typedef void
(*LUCY_RangeQuery_Mimic_t)(lucy_RangeQuery *self, cfish_Obj* other);

typedef lucy_RangeCompiler*
(*LUCY_RangeQuery_Make_Compiler_t)(lucy_RangeQuery *self, lucy_Searcher* searcher, float boost, bool subordinate);

typedef void
(*LUCY_RangeQuery_Set_Boost_t)(lucy_RangeQuery *self, float boost);

typedef float
(*LUCY_RangeQuery_Get_Boost_t)(lucy_RangeQuery *self);

typedef void
(*LUCY_RangeQuery_Serialize_t)(lucy_RangeQuery *self, lucy_OutStream* outstream);

typedef lucy_RangeQuery*
(*LUCY_RangeQuery_Deserialize_t)(lucy_RangeQuery *self, lucy_InStream* instream);

typedef cfish_Obj*
(*LUCY_RangeQuery_Dump_t)(lucy_RangeQuery *self);

typedef cfish_Obj*
(*LUCY_RangeQuery_Load_t)(lucy_RangeQuery *self, cfish_Obj* dump);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_RangeQuery_Get_RefCount(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Get_RefCount_t method = (LUCY_RangeQuery_Get_RefCount_t)cfish_obj_method(self, LUCY_RangeQuery_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeQuery_Inc_RefCount(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Inc_RefCount_t method = (LUCY_RangeQuery_Inc_RefCount_t)cfish_obj_method(self, LUCY_RangeQuery_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_RangeQuery_Dec_RefCount(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Dec_RefCount_t method = (LUCY_RangeQuery_Dec_RefCount_t)cfish_obj_method(self, LUCY_RangeQuery_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_RangeQuery_To_Host(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_To_Host_t method = (LUCY_RangeQuery_To_Host_t)cfish_obj_method(self, LUCY_RangeQuery_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeQuery_Clone(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Clone_t method = (LUCY_RangeQuery_Clone_t)cfish_obj_method(self, LUCY_RangeQuery_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_RangeQuery_Destroy(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Destroy_t method = (LUCY_RangeQuery_Destroy_t)cfish_obj_method(self, LUCY_RangeQuery_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_RangeQuery_Equals(lucy_RangeQuery *self, cfish_Obj* other) {
    const LUCY_RangeQuery_Equals_t method = (LUCY_RangeQuery_Equals_t)cfish_obj_method(self, LUCY_RangeQuery_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_RangeQuery_Compare_To(lucy_RangeQuery *self, cfish_Obj* other) {
    const LUCY_RangeQuery_Compare_To_t method = (LUCY_RangeQuery_Compare_To_t)cfish_obj_method(self, LUCY_RangeQuery_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_RangeQuery_Hash_Sum(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Hash_Sum_t method = (LUCY_RangeQuery_Hash_Sum_t)cfish_obj_method(self, LUCY_RangeQuery_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_RangeQuery_Get_Class(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Get_Class_t method = (LUCY_RangeQuery_Get_Class_t)cfish_obj_method(self, LUCY_RangeQuery_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RangeQuery_Get_Class_Name(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Get_Class_Name_t method = (LUCY_RangeQuery_Get_Class_Name_t)cfish_obj_method(self, LUCY_RangeQuery_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_RangeQuery_Is_A(lucy_RangeQuery *self, cfish_Class* ancestor) {
    const LUCY_RangeQuery_Is_A_t method = (LUCY_RangeQuery_Is_A_t)cfish_obj_method(self, LUCY_RangeQuery_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RangeQuery_To_String(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_To_String_t method = (LUCY_RangeQuery_To_String_t)cfish_obj_method(self, LUCY_RangeQuery_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_RangeQuery_To_I64(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_To_I64_t method = (LUCY_RangeQuery_To_I64_t)cfish_obj_method(self, LUCY_RangeQuery_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_RangeQuery_To_F64(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_To_F64_t method = (LUCY_RangeQuery_To_F64_t)cfish_obj_method(self, LUCY_RangeQuery_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_RangeQuery_To_Bool(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_To_Bool_t method = (LUCY_RangeQuery_To_Bool_t)cfish_obj_method(self, LUCY_RangeQuery_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_RangeQuery_Mimic(lucy_RangeQuery *self, cfish_Obj* other) {
    const LUCY_RangeQuery_Mimic_t method = (LUCY_RangeQuery_Mimic_t)cfish_obj_method(self, LUCY_RangeQuery_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Make_Compiler_OFFSET;
static CFISH_INLINE lucy_RangeCompiler*
LUCY_RangeQuery_Make_Compiler(lucy_RangeQuery *self, lucy_Searcher* searcher, float boost, bool subordinate) {
    const LUCY_RangeQuery_Make_Compiler_t method = (LUCY_RangeQuery_Make_Compiler_t)cfish_obj_method(self, LUCY_RangeQuery_Make_Compiler_OFFSET);
    return method(self, searcher, boost, subordinate);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Set_Boost_OFFSET;
static CFISH_INLINE void
LUCY_RangeQuery_Set_Boost(lucy_RangeQuery *self, float boost) {
    const LUCY_RangeQuery_Set_Boost_t method = (LUCY_RangeQuery_Set_Boost_t)cfish_obj_method(self, LUCY_RangeQuery_Set_Boost_OFFSET);
    method(self, boost);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Get_Boost_OFFSET;
static CFISH_INLINE float
LUCY_RangeQuery_Get_Boost(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Get_Boost_t method = (LUCY_RangeQuery_Get_Boost_t)cfish_obj_method(self, LUCY_RangeQuery_Get_Boost_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Serialize_OFFSET;
static CFISH_INLINE void
LUCY_RangeQuery_Serialize(lucy_RangeQuery *self, lucy_OutStream* outstream) {
    const LUCY_RangeQuery_Serialize_t method = (LUCY_RangeQuery_Serialize_t)cfish_obj_method(self, LUCY_RangeQuery_Serialize_OFFSET);
    method(self, outstream);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Deserialize_OFFSET;
static CFISH_INLINE lucy_RangeQuery*
LUCY_RangeQuery_Deserialize(lucy_RangeQuery *self, lucy_InStream* instream) {
    const LUCY_RangeQuery_Deserialize_t method = (LUCY_RangeQuery_Deserialize_t)cfish_obj_method(self, LUCY_RangeQuery_Deserialize_OFFSET);
    return method(self, instream);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Dump_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeQuery_Dump(lucy_RangeQuery *self) {
    const LUCY_RangeQuery_Dump_t method = (LUCY_RangeQuery_Dump_t)cfish_obj_method(self, LUCY_RangeQuery_Dump_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeQuery_Load_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeQuery_Load(lucy_RangeQuery *self, cfish_Obj* dump) {
    const LUCY_RangeQuery_Load_t method = (LUCY_RangeQuery_Load_t)cfish_obj_method(self, LUCY_RangeQuery_Load_OFFSET);
    return method(self, dump);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_RANGEQUERY;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RangeQuery lucy_RangeQuery
  #define RANGEQUERY LUCY_RANGEQUERY
  #define RangeQuery_new lucy_RangeQuery_new
  #define RangeQuery_init lucy_RangeQuery_init
  #define RangeQuery_Destroy_IMP LUCY_RangeQuery_Destroy_IMP
  #define RangeQuery_Equals_IMP LUCY_RangeQuery_Equals_IMP
  #define RangeQuery_To_String_IMP LUCY_RangeQuery_To_String_IMP
  #define RangeQuery_Make_Compiler_IMP LUCY_RangeQuery_Make_Compiler_IMP
  #define RangeQuery_Serialize_IMP LUCY_RangeQuery_Serialize_IMP
  #define RangeQuery_Deserialize_IMP LUCY_RangeQuery_Deserialize_IMP
  #define RangeQuery_Dump_IMP LUCY_RangeQuery_Dump_IMP
  #define RangeQuery_Load_IMP LUCY_RangeQuery_Load_IMP
  #define RangeQuery_Get_RefCount LUCY_RangeQuery_Get_RefCount
  #define RangeQuery_Get_RefCount_t LUCY_RangeQuery_Get_RefCount_t
  #define RangeQuery_Inc_RefCount LUCY_RangeQuery_Inc_RefCount
  #define RangeQuery_Inc_RefCount_t LUCY_RangeQuery_Inc_RefCount_t
  #define RangeQuery_Dec_RefCount LUCY_RangeQuery_Dec_RefCount
  #define RangeQuery_Dec_RefCount_t LUCY_RangeQuery_Dec_RefCount_t
  #define RangeQuery_To_Host LUCY_RangeQuery_To_Host
  #define RangeQuery_To_Host_t LUCY_RangeQuery_To_Host_t
  #define RangeQuery_Clone LUCY_RangeQuery_Clone
  #define RangeQuery_Clone_t LUCY_RangeQuery_Clone_t
  #define RangeQuery_Destroy LUCY_RangeQuery_Destroy
  #define RangeQuery_Destroy_t LUCY_RangeQuery_Destroy_t
  #define RangeQuery_Equals LUCY_RangeQuery_Equals
  #define RangeQuery_Equals_t LUCY_RangeQuery_Equals_t
  #define RangeQuery_Compare_To LUCY_RangeQuery_Compare_To
  #define RangeQuery_Compare_To_t LUCY_RangeQuery_Compare_To_t
  #define RangeQuery_Hash_Sum LUCY_RangeQuery_Hash_Sum
  #define RangeQuery_Hash_Sum_t LUCY_RangeQuery_Hash_Sum_t
  #define RangeQuery_Get_Class LUCY_RangeQuery_Get_Class
  #define RangeQuery_Get_Class_t LUCY_RangeQuery_Get_Class_t
  #define RangeQuery_Get_Class_Name LUCY_RangeQuery_Get_Class_Name
  #define RangeQuery_Get_Class_Name_t LUCY_RangeQuery_Get_Class_Name_t
  #define RangeQuery_Is_A LUCY_RangeQuery_Is_A
  #define RangeQuery_Is_A_t LUCY_RangeQuery_Is_A_t
  #define RangeQuery_To_String LUCY_RangeQuery_To_String
  #define RangeQuery_To_String_t LUCY_RangeQuery_To_String_t
  #define RangeQuery_To_I64 LUCY_RangeQuery_To_I64
  #define RangeQuery_To_I64_t LUCY_RangeQuery_To_I64_t
  #define RangeQuery_To_F64 LUCY_RangeQuery_To_F64
  #define RangeQuery_To_F64_t LUCY_RangeQuery_To_F64_t
  #define RangeQuery_To_Bool LUCY_RangeQuery_To_Bool
  #define RangeQuery_To_Bool_t LUCY_RangeQuery_To_Bool_t
  #define RangeQuery_Mimic LUCY_RangeQuery_Mimic
  #define RangeQuery_Mimic_t LUCY_RangeQuery_Mimic_t
  #define RangeQuery_Make_Compiler LUCY_RangeQuery_Make_Compiler
  #define RangeQuery_Make_Compiler_t LUCY_RangeQuery_Make_Compiler_t
  #define RangeQuery_Set_Boost LUCY_RangeQuery_Set_Boost
  #define RangeQuery_Set_Boost_t LUCY_RangeQuery_Set_Boost_t
  #define RangeQuery_Get_Boost LUCY_RangeQuery_Get_Boost
  #define RangeQuery_Get_Boost_t LUCY_RangeQuery_Get_Boost_t
  #define RangeQuery_Serialize LUCY_RangeQuery_Serialize
  #define RangeQuery_Serialize_t LUCY_RangeQuery_Serialize_t
  #define RangeQuery_Deserialize LUCY_RangeQuery_Deserialize
  #define RangeQuery_Deserialize_t LUCY_RangeQuery_Deserialize_t
  #define RangeQuery_Dump LUCY_RangeQuery_Dump
  #define RangeQuery_Dump_t LUCY_RangeQuery_Dump_t
  #define RangeQuery_Load LUCY_RangeQuery_Load
  #define RangeQuery_Load_t LUCY_RangeQuery_Load_t
#endif /* LUCY_USE_SHORT_NAMES */



/* Include the header for this class's parent. 
 */

#include "Lucy/Search/Compiler.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_RANGECOMPILER
extern size_t lucy_RangeCompiler_IVARS_OFFSET;
typedef struct lucy_RangeCompilerIVARS lucy_RangeCompilerIVARS;
static CFISH_INLINE lucy_RangeCompilerIVARS*
lucy_RangeCompiler_IVARS(lucy_RangeCompiler *self) {
   char *ptr = (char*)self + lucy_RangeCompiler_IVARS_OFFSET;
   return (lucy_RangeCompilerIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define RangeCompilerIVARS lucy_RangeCompilerIVARS
  #define RangeCompiler_IVARS lucy_RangeCompiler_IVARS
#endif

struct lucy_RangeCompilerIVARS {
    float boost;
    lucy_Query* parent;
    lucy_Similarity* sim;
};

#endif /* C_LUCY_RANGECOMPILER */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_RangeCompiler*
lucy_RangeCompiler_new(lucy_RangeQuery* parent, lucy_Searcher* searcher, float boost);

LUCY_VISIBLE lucy_RangeCompiler*
lucy_RangeCompiler_init(lucy_RangeCompiler* self, lucy_RangeQuery* parent, lucy_Searcher* searcher, float boost);

lucy_Matcher*
LUCY_RangeCompiler_Make_Matcher_IMP(lucy_RangeCompiler* self, lucy_SegReader* reader, bool need_score);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_RangeCompiler_Get_RefCount_t)(lucy_RangeCompiler *self);

typedef cfish_Obj*
(*LUCY_RangeCompiler_Inc_RefCount_t)(lucy_RangeCompiler *self);

typedef uint32_t
(*LUCY_RangeCompiler_Dec_RefCount_t)(lucy_RangeCompiler *self);

typedef void*
(*LUCY_RangeCompiler_To_Host_t)(lucy_RangeCompiler *self);

typedef cfish_Obj*
(*LUCY_RangeCompiler_Clone_t)(lucy_RangeCompiler *self);

typedef void
(*LUCY_RangeCompiler_Destroy_t)(lucy_RangeCompiler *self);

typedef bool
(*LUCY_RangeCompiler_Equals_t)(lucy_RangeCompiler *self, cfish_Obj* other);

typedef int32_t
(*LUCY_RangeCompiler_Compare_To_t)(lucy_RangeCompiler *self, cfish_Obj* other);

typedef int32_t
(*LUCY_RangeCompiler_Hash_Sum_t)(lucy_RangeCompiler *self);

typedef cfish_Class*
(*LUCY_RangeCompiler_Get_Class_t)(lucy_RangeCompiler *self);

typedef cfish_String*
(*LUCY_RangeCompiler_Get_Class_Name_t)(lucy_RangeCompiler *self);

typedef bool
(*LUCY_RangeCompiler_Is_A_t)(lucy_RangeCompiler *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_RangeCompiler_To_String_t)(lucy_RangeCompiler *self);

typedef int64_t
(*LUCY_RangeCompiler_To_I64_t)(lucy_RangeCompiler *self);

typedef double
(*LUCY_RangeCompiler_To_F64_t)(lucy_RangeCompiler *self);

typedef bool
(*LUCY_RangeCompiler_To_Bool_t)(lucy_RangeCompiler *self);

typedef void
(*LUCY_RangeCompiler_Mimic_t)(lucy_RangeCompiler *self, cfish_Obj* other);

typedef lucy_Compiler*
(*LUCY_RangeCompiler_Make_Compiler_t)(lucy_RangeCompiler *self, lucy_Searcher* searcher, float boost, bool subordinate);

typedef void
(*LUCY_RangeCompiler_Set_Boost_t)(lucy_RangeCompiler *self, float boost);

typedef float
(*LUCY_RangeCompiler_Get_Boost_t)(lucy_RangeCompiler *self);

typedef void
(*LUCY_RangeCompiler_Serialize_t)(lucy_RangeCompiler *self, lucy_OutStream* outstream);

typedef lucy_Compiler*
(*LUCY_RangeCompiler_Deserialize_t)(lucy_RangeCompiler *self, lucy_InStream* instream);

typedef cfish_Obj*
(*LUCY_RangeCompiler_Dump_t)(lucy_RangeCompiler *self);

typedef cfish_Obj*
(*LUCY_RangeCompiler_Load_t)(lucy_RangeCompiler *self, cfish_Obj* dump);

typedef lucy_Matcher*
(*LUCY_RangeCompiler_Make_Matcher_t)(lucy_RangeCompiler *self, lucy_SegReader* reader, bool need_score);

typedef float
(*LUCY_RangeCompiler_Get_Weight_t)(lucy_RangeCompiler *self);

typedef lucy_Similarity*
(*LUCY_RangeCompiler_Get_Similarity_t)(lucy_RangeCompiler *self);

typedef lucy_Query*
(*LUCY_RangeCompiler_Get_Parent_t)(lucy_RangeCompiler *self);

typedef float
(*LUCY_RangeCompiler_Sum_Of_Squared_Weights_t)(lucy_RangeCompiler *self);

typedef void
(*LUCY_RangeCompiler_Apply_Norm_Factor_t)(lucy_RangeCompiler *self, float factor);

typedef void
(*LUCY_RangeCompiler_Normalize_t)(lucy_RangeCompiler *self);

typedef cfish_VArray*
(*LUCY_RangeCompiler_Highlight_Spans_t)(lucy_RangeCompiler *self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, cfish_String* field);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_RangeCompiler_Get_RefCount(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Get_RefCount_t method = (LUCY_RangeCompiler_Get_RefCount_t)cfish_obj_method(self, LUCY_RangeCompiler_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeCompiler_Inc_RefCount(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Inc_RefCount_t method = (LUCY_RangeCompiler_Inc_RefCount_t)cfish_obj_method(self, LUCY_RangeCompiler_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_RangeCompiler_Dec_RefCount(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Dec_RefCount_t method = (LUCY_RangeCompiler_Dec_RefCount_t)cfish_obj_method(self, LUCY_RangeCompiler_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_RangeCompiler_To_Host(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_To_Host_t method = (LUCY_RangeCompiler_To_Host_t)cfish_obj_method(self, LUCY_RangeCompiler_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeCompiler_Clone(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Clone_t method = (LUCY_RangeCompiler_Clone_t)cfish_obj_method(self, LUCY_RangeCompiler_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_RangeCompiler_Destroy(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Destroy_t method = (LUCY_RangeCompiler_Destroy_t)cfish_obj_method(self, LUCY_RangeCompiler_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_RangeCompiler_Equals(lucy_RangeCompiler *self, cfish_Obj* other) {
    const LUCY_RangeCompiler_Equals_t method = (LUCY_RangeCompiler_Equals_t)cfish_obj_method(self, LUCY_RangeCompiler_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_RangeCompiler_Compare_To(lucy_RangeCompiler *self, cfish_Obj* other) {
    const LUCY_RangeCompiler_Compare_To_t method = (LUCY_RangeCompiler_Compare_To_t)cfish_obj_method(self, LUCY_RangeCompiler_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_RangeCompiler_Hash_Sum(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Hash_Sum_t method = (LUCY_RangeCompiler_Hash_Sum_t)cfish_obj_method(self, LUCY_RangeCompiler_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_RangeCompiler_Get_Class(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Get_Class_t method = (LUCY_RangeCompiler_Get_Class_t)cfish_obj_method(self, LUCY_RangeCompiler_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RangeCompiler_Get_Class_Name(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Get_Class_Name_t method = (LUCY_RangeCompiler_Get_Class_Name_t)cfish_obj_method(self, LUCY_RangeCompiler_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_RangeCompiler_Is_A(lucy_RangeCompiler *self, cfish_Class* ancestor) {
    const LUCY_RangeCompiler_Is_A_t method = (LUCY_RangeCompiler_Is_A_t)cfish_obj_method(self, LUCY_RangeCompiler_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_RangeCompiler_To_String(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_To_String_t method = (LUCY_RangeCompiler_To_String_t)cfish_obj_method(self, LUCY_RangeCompiler_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_RangeCompiler_To_I64(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_To_I64_t method = (LUCY_RangeCompiler_To_I64_t)cfish_obj_method(self, LUCY_RangeCompiler_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_RangeCompiler_To_F64(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_To_F64_t method = (LUCY_RangeCompiler_To_F64_t)cfish_obj_method(self, LUCY_RangeCompiler_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_RangeCompiler_To_Bool(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_To_Bool_t method = (LUCY_RangeCompiler_To_Bool_t)cfish_obj_method(self, LUCY_RangeCompiler_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_RangeCompiler_Mimic(lucy_RangeCompiler *self, cfish_Obj* other) {
    const LUCY_RangeCompiler_Mimic_t method = (LUCY_RangeCompiler_Mimic_t)cfish_obj_method(self, LUCY_RangeCompiler_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Make_Compiler_OFFSET;
static CFISH_INLINE lucy_Compiler*
LUCY_RangeCompiler_Make_Compiler(lucy_RangeCompiler *self, lucy_Searcher* searcher, float boost, bool subordinate) {
    const LUCY_RangeCompiler_Make_Compiler_t method = (LUCY_RangeCompiler_Make_Compiler_t)cfish_obj_method(self, LUCY_RangeCompiler_Make_Compiler_OFFSET);
    return method(self, searcher, boost, subordinate);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Set_Boost_OFFSET;
static CFISH_INLINE void
LUCY_RangeCompiler_Set_Boost(lucy_RangeCompiler *self, float boost) {
    const LUCY_RangeCompiler_Set_Boost_t method = (LUCY_RangeCompiler_Set_Boost_t)cfish_obj_method(self, LUCY_RangeCompiler_Set_Boost_OFFSET);
    method(self, boost);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Get_Boost_OFFSET;
static CFISH_INLINE float
LUCY_RangeCompiler_Get_Boost(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Get_Boost_t method = (LUCY_RangeCompiler_Get_Boost_t)cfish_obj_method(self, LUCY_RangeCompiler_Get_Boost_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Serialize_OFFSET;
static CFISH_INLINE void
LUCY_RangeCompiler_Serialize(lucy_RangeCompiler *self, lucy_OutStream* outstream) {
    const LUCY_RangeCompiler_Serialize_t method = (LUCY_RangeCompiler_Serialize_t)cfish_obj_method(self, LUCY_RangeCompiler_Serialize_OFFSET);
    method(self, outstream);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Deserialize_OFFSET;
static CFISH_INLINE lucy_Compiler*
LUCY_RangeCompiler_Deserialize(lucy_RangeCompiler *self, lucy_InStream* instream) {
    const LUCY_RangeCompiler_Deserialize_t method = (LUCY_RangeCompiler_Deserialize_t)cfish_obj_method(self, LUCY_RangeCompiler_Deserialize_OFFSET);
    return method(self, instream);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Dump_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeCompiler_Dump(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Dump_t method = (LUCY_RangeCompiler_Dump_t)cfish_obj_method(self, LUCY_RangeCompiler_Dump_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Load_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_RangeCompiler_Load(lucy_RangeCompiler *self, cfish_Obj* dump) {
    const LUCY_RangeCompiler_Load_t method = (LUCY_RangeCompiler_Load_t)cfish_obj_method(self, LUCY_RangeCompiler_Load_OFFSET);
    return method(self, dump);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Make_Matcher_OFFSET;
static CFISH_INLINE lucy_Matcher*
LUCY_RangeCompiler_Make_Matcher(lucy_RangeCompiler *self, lucy_SegReader* reader, bool need_score) {
    const LUCY_RangeCompiler_Make_Matcher_t method = (LUCY_RangeCompiler_Make_Matcher_t)cfish_obj_method(self, LUCY_RangeCompiler_Make_Matcher_OFFSET);
    return method(self, reader, need_score);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Get_Weight_OFFSET;
static CFISH_INLINE float
LUCY_RangeCompiler_Get_Weight(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Get_Weight_t method = (LUCY_RangeCompiler_Get_Weight_t)cfish_obj_method(self, LUCY_RangeCompiler_Get_Weight_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Get_Similarity_OFFSET;
static CFISH_INLINE lucy_Similarity*
LUCY_RangeCompiler_Get_Similarity(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Get_Similarity_t method = (LUCY_RangeCompiler_Get_Similarity_t)cfish_obj_method(self, LUCY_RangeCompiler_Get_Similarity_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Get_Parent_OFFSET;
static CFISH_INLINE lucy_Query*
LUCY_RangeCompiler_Get_Parent(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Get_Parent_t method = (LUCY_RangeCompiler_Get_Parent_t)cfish_obj_method(self, LUCY_RangeCompiler_Get_Parent_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Sum_Of_Squared_Weights_OFFSET;
static CFISH_INLINE float
LUCY_RangeCompiler_Sum_Of_Squared_Weights(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Sum_Of_Squared_Weights_t method = (LUCY_RangeCompiler_Sum_Of_Squared_Weights_t)cfish_obj_method(self, LUCY_RangeCompiler_Sum_Of_Squared_Weights_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Apply_Norm_Factor_OFFSET;
static CFISH_INLINE void
LUCY_RangeCompiler_Apply_Norm_Factor(lucy_RangeCompiler *self, float factor) {
    const LUCY_RangeCompiler_Apply_Norm_Factor_t method = (LUCY_RangeCompiler_Apply_Norm_Factor_t)cfish_obj_method(self, LUCY_RangeCompiler_Apply_Norm_Factor_OFFSET);
    method(self, factor);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Normalize_OFFSET;
static CFISH_INLINE void
LUCY_RangeCompiler_Normalize(lucy_RangeCompiler *self) {
    const LUCY_RangeCompiler_Normalize_t method = (LUCY_RangeCompiler_Normalize_t)cfish_obj_method(self, LUCY_RangeCompiler_Normalize_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_RangeCompiler_Highlight_Spans_OFFSET;
static CFISH_INLINE cfish_VArray*
LUCY_RangeCompiler_Highlight_Spans(lucy_RangeCompiler *self, lucy_Searcher* searcher, lucy_DocVector* doc_vec, cfish_String* field) {
    const LUCY_RangeCompiler_Highlight_Spans_t method = (LUCY_RangeCompiler_Highlight_Spans_t)cfish_obj_method(self, LUCY_RangeCompiler_Highlight_Spans_OFFSET);
    return method(self, searcher, doc_vec, field);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_RANGECOMPILER;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define RangeCompiler lucy_RangeCompiler
  #define RANGECOMPILER LUCY_RANGECOMPILER
  #define RangeCompiler_new lucy_RangeCompiler_new
  #define RangeCompiler_init lucy_RangeCompiler_init
  #define RangeCompiler_Make_Matcher_IMP LUCY_RangeCompiler_Make_Matcher_IMP
  #define RangeCompiler_Get_RefCount LUCY_RangeCompiler_Get_RefCount
  #define RangeCompiler_Get_RefCount_t LUCY_RangeCompiler_Get_RefCount_t
  #define RangeCompiler_Inc_RefCount LUCY_RangeCompiler_Inc_RefCount
  #define RangeCompiler_Inc_RefCount_t LUCY_RangeCompiler_Inc_RefCount_t
  #define RangeCompiler_Dec_RefCount LUCY_RangeCompiler_Dec_RefCount
  #define RangeCompiler_Dec_RefCount_t LUCY_RangeCompiler_Dec_RefCount_t
  #define RangeCompiler_To_Host LUCY_RangeCompiler_To_Host
  #define RangeCompiler_To_Host_t LUCY_RangeCompiler_To_Host_t
  #define RangeCompiler_Clone LUCY_RangeCompiler_Clone
  #define RangeCompiler_Clone_t LUCY_RangeCompiler_Clone_t
  #define RangeCompiler_Destroy LUCY_RangeCompiler_Destroy
  #define RangeCompiler_Destroy_t LUCY_RangeCompiler_Destroy_t
  #define RangeCompiler_Equals LUCY_RangeCompiler_Equals
  #define RangeCompiler_Equals_t LUCY_RangeCompiler_Equals_t
  #define RangeCompiler_Compare_To LUCY_RangeCompiler_Compare_To
  #define RangeCompiler_Compare_To_t LUCY_RangeCompiler_Compare_To_t
  #define RangeCompiler_Hash_Sum LUCY_RangeCompiler_Hash_Sum
  #define RangeCompiler_Hash_Sum_t LUCY_RangeCompiler_Hash_Sum_t
  #define RangeCompiler_Get_Class LUCY_RangeCompiler_Get_Class
  #define RangeCompiler_Get_Class_t LUCY_RangeCompiler_Get_Class_t
  #define RangeCompiler_Get_Class_Name LUCY_RangeCompiler_Get_Class_Name
  #define RangeCompiler_Get_Class_Name_t LUCY_RangeCompiler_Get_Class_Name_t
  #define RangeCompiler_Is_A LUCY_RangeCompiler_Is_A
  #define RangeCompiler_Is_A_t LUCY_RangeCompiler_Is_A_t
  #define RangeCompiler_To_String LUCY_RangeCompiler_To_String
  #define RangeCompiler_To_String_t LUCY_RangeCompiler_To_String_t
  #define RangeCompiler_To_I64 LUCY_RangeCompiler_To_I64
  #define RangeCompiler_To_I64_t LUCY_RangeCompiler_To_I64_t
  #define RangeCompiler_To_F64 LUCY_RangeCompiler_To_F64
  #define RangeCompiler_To_F64_t LUCY_RangeCompiler_To_F64_t
  #define RangeCompiler_To_Bool LUCY_RangeCompiler_To_Bool
  #define RangeCompiler_To_Bool_t LUCY_RangeCompiler_To_Bool_t
  #define RangeCompiler_Mimic LUCY_RangeCompiler_Mimic
  #define RangeCompiler_Mimic_t LUCY_RangeCompiler_Mimic_t
  #define RangeCompiler_Make_Compiler LUCY_RangeCompiler_Make_Compiler
  #define RangeCompiler_Make_Compiler_t LUCY_RangeCompiler_Make_Compiler_t
  #define RangeCompiler_Set_Boost LUCY_RangeCompiler_Set_Boost
  #define RangeCompiler_Set_Boost_t LUCY_RangeCompiler_Set_Boost_t
  #define RangeCompiler_Get_Boost LUCY_RangeCompiler_Get_Boost
  #define RangeCompiler_Get_Boost_t LUCY_RangeCompiler_Get_Boost_t
  #define RangeCompiler_Serialize LUCY_RangeCompiler_Serialize
  #define RangeCompiler_Serialize_t LUCY_RangeCompiler_Serialize_t
  #define RangeCompiler_Deserialize LUCY_RangeCompiler_Deserialize
  #define RangeCompiler_Deserialize_t LUCY_RangeCompiler_Deserialize_t
  #define RangeCompiler_Dump LUCY_RangeCompiler_Dump
  #define RangeCompiler_Dump_t LUCY_RangeCompiler_Dump_t
  #define RangeCompiler_Load LUCY_RangeCompiler_Load
  #define RangeCompiler_Load_t LUCY_RangeCompiler_Load_t
  #define RangeCompiler_Make_Matcher LUCY_RangeCompiler_Make_Matcher
  #define RangeCompiler_Make_Matcher_t LUCY_RangeCompiler_Make_Matcher_t
  #define RangeCompiler_Get_Weight LUCY_RangeCompiler_Get_Weight
  #define RangeCompiler_Get_Weight_t LUCY_RangeCompiler_Get_Weight_t
  #define RangeCompiler_Get_Similarity LUCY_RangeCompiler_Get_Similarity
  #define RangeCompiler_Get_Similarity_t LUCY_RangeCompiler_Get_Similarity_t
  #define RangeCompiler_Get_Parent LUCY_RangeCompiler_Get_Parent
  #define RangeCompiler_Get_Parent_t LUCY_RangeCompiler_Get_Parent_t
  #define RangeCompiler_Sum_Of_Squared_Weights LUCY_RangeCompiler_Sum_Of_Squared_Weights
  #define RangeCompiler_Sum_Of_Squared_Weights_t LUCY_RangeCompiler_Sum_Of_Squared_Weights_t
  #define RangeCompiler_Apply_Norm_Factor LUCY_RangeCompiler_Apply_Norm_Factor
  #define RangeCompiler_Apply_Norm_Factor_t LUCY_RangeCompiler_Apply_Norm_Factor_t
  #define RangeCompiler_Normalize LUCY_RangeCompiler_Normalize
  #define RangeCompiler_Normalize_t LUCY_RangeCompiler_Normalize_t
  #define RangeCompiler_Highlight_Spans LUCY_RangeCompiler_Highlight_Spans
  #define RangeCompiler_Highlight_Spans_t LUCY_RangeCompiler_Highlight_Spans_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_SEARCH_RANGEQUERY */




