/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_STORE_INSTREAM
#define H_LUCY_STORE_INSTREAM 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_INSTREAM
extern size_t lucy_InStream_IVARS_OFFSET;
typedef struct lucy_InStreamIVARS lucy_InStreamIVARS;
static CFISH_INLINE lucy_InStreamIVARS*
lucy_InStream_IVARS(lucy_InStream *self) {
   char *ptr = (char*)self + lucy_InStream_IVARS_OFFSET;
   return (lucy_InStreamIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define InStreamIVARS lucy_InStreamIVARS
  #define InStream_IVARS lucy_InStream_IVARS
#endif

struct lucy_InStreamIVARS {
    int64_t offset;
    int64_t len;
    const char* buf;
    const char* limit;
    cfish_String* filename;
    lucy_FileHandle* file_handle;
    lucy_FileWindow* window;
};

#endif /* C_LUCY_INSTREAM */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_InStream*
lucy_InStream_open(cfish_Obj* file);

LUCY_VISIBLE lucy_InStream*
lucy_InStream_do_open(lucy_InStream* self, cfish_Obj* file);

lucy_InStream*
LUCY_InStream_Clone_IMP(lucy_InStream* self);

void
LUCY_InStream_Destroy_IMP(lucy_InStream* self);

lucy_InStream*
LUCY_InStream_Reopen_IMP(lucy_InStream* self, cfish_String* filename, int64_t offset, int64_t len);

void
LUCY_InStream_Close_IMP(lucy_InStream* self);

LUCY_VISIBLE void
LUCY_InStream_Seek_IMP(lucy_InStream* self, int64_t target);

LUCY_VISIBLE int64_t
LUCY_InStream_Tell_IMP(lucy_InStream* self);

LUCY_VISIBLE int64_t
LUCY_InStream_Length_IMP(lucy_InStream* self);

void
LUCY_InStream_Refill_IMP(lucy_InStream* self);

void
LUCY_InStream_Fill_IMP(lucy_InStream* self, int64_t amount);

LUCY_VISIBLE const char*
LUCY_InStream_Buf_IMP(lucy_InStream* self, size_t request);

LUCY_VISIBLE void
LUCY_InStream_Advance_Buf_IMP(lucy_InStream* self, const char* buf);

LUCY_VISIBLE void
LUCY_InStream_Read_Bytes_IMP(lucy_InStream* self, char* buf, size_t len);

LUCY_VISIBLE int8_t
LUCY_InStream_Read_I8_IMP(lucy_InStream* self);

LUCY_VISIBLE uint8_t
LUCY_InStream_Read_U8_IMP(lucy_InStream* self);

LUCY_VISIBLE int32_t
LUCY_InStream_Read_I32_IMP(lucy_InStream* self);

LUCY_VISIBLE uint32_t
LUCY_InStream_Read_U32_IMP(lucy_InStream* self);

LUCY_VISIBLE int64_t
LUCY_InStream_Read_I64_IMP(lucy_InStream* self);

LUCY_VISIBLE uint64_t
LUCY_InStream_Read_U64_IMP(lucy_InStream* self);

LUCY_VISIBLE float
LUCY_InStream_Read_F32_IMP(lucy_InStream* self);

LUCY_VISIBLE double
LUCY_InStream_Read_F64_IMP(lucy_InStream* self);

uint32_t
LUCY_InStream_Read_C32_IMP(lucy_InStream* self);

LUCY_VISIBLE uint64_t
LUCY_InStream_Read_C64_IMP(lucy_InStream* self);

LUCY_VISIBLE int
LUCY_InStream_Read_Raw_C64_IMP(lucy_InStream* self, char* buf);

cfish_String*
LUCY_InStream_Get_Filename_IMP(lucy_InStream* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_InStream_Get_RefCount_t)(lucy_InStream *self);

typedef cfish_Obj*
(*LUCY_InStream_Inc_RefCount_t)(lucy_InStream *self);

typedef uint32_t
(*LUCY_InStream_Dec_RefCount_t)(lucy_InStream *self);

typedef void*
(*LUCY_InStream_To_Host_t)(lucy_InStream *self);

typedef lucy_InStream*
(*LUCY_InStream_Clone_t)(lucy_InStream *self);

typedef void
(*LUCY_InStream_Destroy_t)(lucy_InStream *self);

typedef bool
(*LUCY_InStream_Equals_t)(lucy_InStream *self, cfish_Obj* other);

typedef int32_t
(*LUCY_InStream_Compare_To_t)(lucy_InStream *self, cfish_Obj* other);

typedef int32_t
(*LUCY_InStream_Hash_Sum_t)(lucy_InStream *self);

typedef cfish_Class*
(*LUCY_InStream_Get_Class_t)(lucy_InStream *self);

typedef cfish_String*
(*LUCY_InStream_Get_Class_Name_t)(lucy_InStream *self);

typedef bool
(*LUCY_InStream_Is_A_t)(lucy_InStream *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_InStream_To_String_t)(lucy_InStream *self);

typedef int64_t
(*LUCY_InStream_To_I64_t)(lucy_InStream *self);

typedef double
(*LUCY_InStream_To_F64_t)(lucy_InStream *self);

typedef bool
(*LUCY_InStream_To_Bool_t)(lucy_InStream *self);

typedef void
(*LUCY_InStream_Mimic_t)(lucy_InStream *self, cfish_Obj* other);

typedef lucy_InStream*
(*LUCY_InStream_Reopen_t)(lucy_InStream *self, cfish_String* filename, int64_t offset, int64_t len);

typedef void
(*LUCY_InStream_Close_t)(lucy_InStream *self);

typedef void
(*LUCY_InStream_Seek_t)(lucy_InStream *self, int64_t target);

typedef int64_t
(*LUCY_InStream_Tell_t)(lucy_InStream *self);

typedef int64_t
(*LUCY_InStream_Length_t)(lucy_InStream *self);

typedef void
(*LUCY_InStream_Refill_t)(lucy_InStream *self);

typedef void
(*LUCY_InStream_Fill_t)(lucy_InStream *self, int64_t amount);

typedef const char*
(*LUCY_InStream_Buf_t)(lucy_InStream *self, size_t request);

typedef void
(*LUCY_InStream_Advance_Buf_t)(lucy_InStream *self, const char* buf);

typedef void
(*LUCY_InStream_Read_Bytes_t)(lucy_InStream *self, char* buf, size_t len);

typedef int8_t
(*LUCY_InStream_Read_I8_t)(lucy_InStream *self);

typedef uint8_t
(*LUCY_InStream_Read_U8_t)(lucy_InStream *self);

typedef int32_t
(*LUCY_InStream_Read_I32_t)(lucy_InStream *self);

typedef uint32_t
(*LUCY_InStream_Read_U32_t)(lucy_InStream *self);

typedef int64_t
(*LUCY_InStream_Read_I64_t)(lucy_InStream *self);

typedef uint64_t
(*LUCY_InStream_Read_U64_t)(lucy_InStream *self);

typedef float
(*LUCY_InStream_Read_F32_t)(lucy_InStream *self);

typedef double
(*LUCY_InStream_Read_F64_t)(lucy_InStream *self);

typedef uint32_t
(*LUCY_InStream_Read_C32_t)(lucy_InStream *self);

typedef uint64_t
(*LUCY_InStream_Read_C64_t)(lucy_InStream *self);

typedef int
(*LUCY_InStream_Read_Raw_C64_t)(lucy_InStream *self, char* buf);

typedef cfish_String*
(*LUCY_InStream_Get_Filename_t)(lucy_InStream *self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_InStream_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_InStream_Get_RefCount(lucy_InStream *self) {
    const LUCY_InStream_Get_RefCount_t method = (LUCY_InStream_Get_RefCount_t)cfish_obj_method(self, LUCY_InStream_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_InStream_Inc_RefCount(lucy_InStream *self) {
    const LUCY_InStream_Inc_RefCount_t method = (LUCY_InStream_Inc_RefCount_t)cfish_obj_method(self, LUCY_InStream_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_InStream_Dec_RefCount(lucy_InStream *self) {
    const LUCY_InStream_Dec_RefCount_t method = (LUCY_InStream_Dec_RefCount_t)cfish_obj_method(self, LUCY_InStream_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_InStream_To_Host(lucy_InStream *self) {
    const LUCY_InStream_To_Host_t method = (LUCY_InStream_To_Host_t)cfish_obj_method(self, LUCY_InStream_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Clone_OFFSET;
static CFISH_INLINE lucy_InStream*
LUCY_InStream_Clone(lucy_InStream *self) {
    const LUCY_InStream_Clone_t method = (LUCY_InStream_Clone_t)cfish_obj_method(self, LUCY_InStream_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_InStream_Destroy(lucy_InStream *self) {
    const LUCY_InStream_Destroy_t method = (LUCY_InStream_Destroy_t)cfish_obj_method(self, LUCY_InStream_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_InStream_Equals(lucy_InStream *self, cfish_Obj* other) {
    const LUCY_InStream_Equals_t method = (LUCY_InStream_Equals_t)cfish_obj_method(self, LUCY_InStream_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_InStream_Compare_To(lucy_InStream *self, cfish_Obj* other) {
    const LUCY_InStream_Compare_To_t method = (LUCY_InStream_Compare_To_t)cfish_obj_method(self, LUCY_InStream_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_InStream_Hash_Sum(lucy_InStream *self) {
    const LUCY_InStream_Hash_Sum_t method = (LUCY_InStream_Hash_Sum_t)cfish_obj_method(self, LUCY_InStream_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_InStream_Get_Class(lucy_InStream *self) {
    const LUCY_InStream_Get_Class_t method = (LUCY_InStream_Get_Class_t)cfish_obj_method(self, LUCY_InStream_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_InStream_Get_Class_Name(lucy_InStream *self) {
    const LUCY_InStream_Get_Class_Name_t method = (LUCY_InStream_Get_Class_Name_t)cfish_obj_method(self, LUCY_InStream_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_InStream_Is_A(lucy_InStream *self, cfish_Class* ancestor) {
    const LUCY_InStream_Is_A_t method = (LUCY_InStream_Is_A_t)cfish_obj_method(self, LUCY_InStream_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_InStream_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_InStream_To_String(lucy_InStream *self) {
    const LUCY_InStream_To_String_t method = (LUCY_InStream_To_String_t)cfish_obj_method(self, LUCY_InStream_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_InStream_To_I64(lucy_InStream *self) {
    const LUCY_InStream_To_I64_t method = (LUCY_InStream_To_I64_t)cfish_obj_method(self, LUCY_InStream_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_InStream_To_F64(lucy_InStream *self) {
    const LUCY_InStream_To_F64_t method = (LUCY_InStream_To_F64_t)cfish_obj_method(self, LUCY_InStream_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_InStream_To_Bool(lucy_InStream *self) {
    const LUCY_InStream_To_Bool_t method = (LUCY_InStream_To_Bool_t)cfish_obj_method(self, LUCY_InStream_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_InStream_Mimic(lucy_InStream *self, cfish_Obj* other) {
    const LUCY_InStream_Mimic_t method = (LUCY_InStream_Mimic_t)cfish_obj_method(self, LUCY_InStream_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Reopen_OFFSET;
static CFISH_INLINE lucy_InStream*
LUCY_InStream_Reopen(lucy_InStream *self, cfish_String* filename, int64_t offset, int64_t len) {
    const LUCY_InStream_Reopen_t method = (LUCY_InStream_Reopen_t)cfish_obj_method(self, LUCY_InStream_Reopen_OFFSET);
    return method(self, filename, offset, len);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Close_OFFSET;
static CFISH_INLINE void
LUCY_InStream_Close(lucy_InStream *self) {
    const LUCY_InStream_Close_t method = (LUCY_InStream_Close_t)cfish_obj_method(self, LUCY_InStream_Close_OFFSET);
    method(self);
}

extern size_t LUCY_InStream_Seek_OFFSET;
#define LUCY_InStream_Seek(self, target) \
    LUCY_InStream_Seek_IMP((lucy_InStream*)self, target)

extern size_t LUCY_InStream_Tell_OFFSET;
#define LUCY_InStream_Tell(self) \
    LUCY_InStream_Tell_IMP((lucy_InStream*)self)

extern size_t LUCY_InStream_Length_OFFSET;
#define LUCY_InStream_Length(self) \
    LUCY_InStream_Length_IMP((lucy_InStream*)self)

extern LUCY_VISIBLE size_t LUCY_InStream_Refill_OFFSET;
static CFISH_INLINE void
LUCY_InStream_Refill(lucy_InStream *self) {
    const LUCY_InStream_Refill_t method = (LUCY_InStream_Refill_t)cfish_obj_method(self, LUCY_InStream_Refill_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_InStream_Fill_OFFSET;
static CFISH_INLINE void
LUCY_InStream_Fill(lucy_InStream *self, int64_t amount) {
    const LUCY_InStream_Fill_t method = (LUCY_InStream_Fill_t)cfish_obj_method(self, LUCY_InStream_Fill_OFFSET);
    method(self, amount);
}

extern size_t LUCY_InStream_Buf_OFFSET;
#define LUCY_InStream_Buf(self, request) \
    LUCY_InStream_Buf_IMP((lucy_InStream*)self, request)

extern size_t LUCY_InStream_Advance_Buf_OFFSET;
#define LUCY_InStream_Advance_Buf(self, buf) \
    LUCY_InStream_Advance_Buf_IMP((lucy_InStream*)self, buf)

extern size_t LUCY_InStream_Read_Bytes_OFFSET;
#define LUCY_InStream_Read_Bytes(self, buf, len) \
    LUCY_InStream_Read_Bytes_IMP((lucy_InStream*)self, buf, len)

extern size_t LUCY_InStream_Read_I8_OFFSET;
#define LUCY_InStream_Read_I8(self) \
    LUCY_InStream_Read_I8_IMP((lucy_InStream*)self)

extern size_t LUCY_InStream_Read_U8_OFFSET;
#define LUCY_InStream_Read_U8(self) \
    LUCY_InStream_Read_U8_IMP((lucy_InStream*)self)

extern size_t LUCY_InStream_Read_I32_OFFSET;
#define LUCY_InStream_Read_I32(self) \
    LUCY_InStream_Read_I32_IMP((lucy_InStream*)self)

extern size_t LUCY_InStream_Read_U32_OFFSET;
#define LUCY_InStream_Read_U32(self) \
    LUCY_InStream_Read_U32_IMP((lucy_InStream*)self)

extern size_t LUCY_InStream_Read_I64_OFFSET;
#define LUCY_InStream_Read_I64(self) \
    LUCY_InStream_Read_I64_IMP((lucy_InStream*)self)

extern size_t LUCY_InStream_Read_U64_OFFSET;
#define LUCY_InStream_Read_U64(self) \
    LUCY_InStream_Read_U64_IMP((lucy_InStream*)self)

extern size_t LUCY_InStream_Read_F32_OFFSET;
#define LUCY_InStream_Read_F32(self) \
    LUCY_InStream_Read_F32_IMP((lucy_InStream*)self)

extern size_t LUCY_InStream_Read_F64_OFFSET;
#define LUCY_InStream_Read_F64(self) \
    LUCY_InStream_Read_F64_IMP((lucy_InStream*)self)

extern LUCY_VISIBLE size_t LUCY_InStream_Read_C32_OFFSET;
static CFISH_INLINE uint32_t
LUCY_InStream_Read_C32(lucy_InStream *self) {
    const LUCY_InStream_Read_C32_t method = (LUCY_InStream_Read_C32_t)cfish_obj_method(self, LUCY_InStream_Read_C32_OFFSET);
    return method(self);
}

extern size_t LUCY_InStream_Read_C64_OFFSET;
#define LUCY_InStream_Read_C64(self) \
    LUCY_InStream_Read_C64_IMP((lucy_InStream*)self)

extern size_t LUCY_InStream_Read_Raw_C64_OFFSET;
#define LUCY_InStream_Read_Raw_C64(self, buf) \
    LUCY_InStream_Read_Raw_C64_IMP((lucy_InStream*)self, buf)

extern LUCY_VISIBLE size_t LUCY_InStream_Get_Filename_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_InStream_Get_Filename(lucy_InStream *self) {
    const LUCY_InStream_Get_Filename_t method = (LUCY_InStream_Get_Filename_t)cfish_obj_method(self, LUCY_InStream_Get_Filename_OFFSET);
    return method(self);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_INSTREAM;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define InStream lucy_InStream
  #define INSTREAM LUCY_INSTREAM
  #define InStream_open lucy_InStream_open
  #define InStream_do_open lucy_InStream_do_open
  #define InStream_Clone_IMP LUCY_InStream_Clone_IMP
  #define InStream_Destroy_IMP LUCY_InStream_Destroy_IMP
  #define InStream_Reopen_IMP LUCY_InStream_Reopen_IMP
  #define InStream_Close_IMP LUCY_InStream_Close_IMP
  #define InStream_Seek_IMP LUCY_InStream_Seek_IMP
  #define InStream_Tell_IMP LUCY_InStream_Tell_IMP
  #define InStream_Length_IMP LUCY_InStream_Length_IMP
  #define InStream_Refill_IMP LUCY_InStream_Refill_IMP
  #define InStream_Fill_IMP LUCY_InStream_Fill_IMP
  #define InStream_Buf_IMP LUCY_InStream_Buf_IMP
  #define InStream_Advance_Buf_IMP LUCY_InStream_Advance_Buf_IMP
  #define InStream_Read_Bytes_IMP LUCY_InStream_Read_Bytes_IMP
  #define InStream_Read_I8_IMP LUCY_InStream_Read_I8_IMP
  #define InStream_Read_U8_IMP LUCY_InStream_Read_U8_IMP
  #define InStream_Read_I32_IMP LUCY_InStream_Read_I32_IMP
  #define InStream_Read_U32_IMP LUCY_InStream_Read_U32_IMP
  #define InStream_Read_I64_IMP LUCY_InStream_Read_I64_IMP
  #define InStream_Read_U64_IMP LUCY_InStream_Read_U64_IMP
  #define InStream_Read_F32_IMP LUCY_InStream_Read_F32_IMP
  #define InStream_Read_F64_IMP LUCY_InStream_Read_F64_IMP
  #define InStream_Read_C32_IMP LUCY_InStream_Read_C32_IMP
  #define InStream_Read_C64_IMP LUCY_InStream_Read_C64_IMP
  #define InStream_Read_Raw_C64_IMP LUCY_InStream_Read_Raw_C64_IMP
  #define InStream_Get_Filename_IMP LUCY_InStream_Get_Filename_IMP
  #define InStream_Get_RefCount LUCY_InStream_Get_RefCount
  #define InStream_Get_RefCount_t LUCY_InStream_Get_RefCount_t
  #define InStream_Inc_RefCount LUCY_InStream_Inc_RefCount
  #define InStream_Inc_RefCount_t LUCY_InStream_Inc_RefCount_t
  #define InStream_Dec_RefCount LUCY_InStream_Dec_RefCount
  #define InStream_Dec_RefCount_t LUCY_InStream_Dec_RefCount_t
  #define InStream_To_Host LUCY_InStream_To_Host
  #define InStream_To_Host_t LUCY_InStream_To_Host_t
  #define InStream_Clone LUCY_InStream_Clone
  #define InStream_Clone_t LUCY_InStream_Clone_t
  #define InStream_Destroy LUCY_InStream_Destroy
  #define InStream_Destroy_t LUCY_InStream_Destroy_t
  #define InStream_Equals LUCY_InStream_Equals
  #define InStream_Equals_t LUCY_InStream_Equals_t
  #define InStream_Compare_To LUCY_InStream_Compare_To
  #define InStream_Compare_To_t LUCY_InStream_Compare_To_t
  #define InStream_Hash_Sum LUCY_InStream_Hash_Sum
  #define InStream_Hash_Sum_t LUCY_InStream_Hash_Sum_t
  #define InStream_Get_Class LUCY_InStream_Get_Class
  #define InStream_Get_Class_t LUCY_InStream_Get_Class_t
  #define InStream_Get_Class_Name LUCY_InStream_Get_Class_Name
  #define InStream_Get_Class_Name_t LUCY_InStream_Get_Class_Name_t
  #define InStream_Is_A LUCY_InStream_Is_A
  #define InStream_Is_A_t LUCY_InStream_Is_A_t
  #define InStream_To_String LUCY_InStream_To_String
  #define InStream_To_String_t LUCY_InStream_To_String_t
  #define InStream_To_I64 LUCY_InStream_To_I64
  #define InStream_To_I64_t LUCY_InStream_To_I64_t
  #define InStream_To_F64 LUCY_InStream_To_F64
  #define InStream_To_F64_t LUCY_InStream_To_F64_t
  #define InStream_To_Bool LUCY_InStream_To_Bool
  #define InStream_To_Bool_t LUCY_InStream_To_Bool_t
  #define InStream_Mimic LUCY_InStream_Mimic
  #define InStream_Mimic_t LUCY_InStream_Mimic_t
  #define InStream_Reopen LUCY_InStream_Reopen
  #define InStream_Reopen_t LUCY_InStream_Reopen_t
  #define InStream_Close LUCY_InStream_Close
  #define InStream_Close_t LUCY_InStream_Close_t
  #define InStream_Seek LUCY_InStream_Seek
  #define InStream_Seek_t LUCY_InStream_Seek_t
  #define InStream_Tell LUCY_InStream_Tell
  #define InStream_Tell_t LUCY_InStream_Tell_t
  #define InStream_Length LUCY_InStream_Length
  #define InStream_Length_t LUCY_InStream_Length_t
  #define InStream_Refill LUCY_InStream_Refill
  #define InStream_Refill_t LUCY_InStream_Refill_t
  #define InStream_Fill LUCY_InStream_Fill
  #define InStream_Fill_t LUCY_InStream_Fill_t
  #define InStream_Buf LUCY_InStream_Buf
  #define InStream_Buf_t LUCY_InStream_Buf_t
  #define InStream_Advance_Buf LUCY_InStream_Advance_Buf
  #define InStream_Advance_Buf_t LUCY_InStream_Advance_Buf_t
  #define InStream_Read_Bytes LUCY_InStream_Read_Bytes
  #define InStream_Read_Bytes_t LUCY_InStream_Read_Bytes_t
  #define InStream_Read_I8 LUCY_InStream_Read_I8
  #define InStream_Read_I8_t LUCY_InStream_Read_I8_t
  #define InStream_Read_U8 LUCY_InStream_Read_U8
  #define InStream_Read_U8_t LUCY_InStream_Read_U8_t
  #define InStream_Read_I32 LUCY_InStream_Read_I32
  #define InStream_Read_I32_t LUCY_InStream_Read_I32_t
  #define InStream_Read_U32 LUCY_InStream_Read_U32
  #define InStream_Read_U32_t LUCY_InStream_Read_U32_t
  #define InStream_Read_I64 LUCY_InStream_Read_I64
  #define InStream_Read_I64_t LUCY_InStream_Read_I64_t
  #define InStream_Read_U64 LUCY_InStream_Read_U64
  #define InStream_Read_U64_t LUCY_InStream_Read_U64_t
  #define InStream_Read_F32 LUCY_InStream_Read_F32
  #define InStream_Read_F32_t LUCY_InStream_Read_F32_t
  #define InStream_Read_F64 LUCY_InStream_Read_F64
  #define InStream_Read_F64_t LUCY_InStream_Read_F64_t
  #define InStream_Read_C32 LUCY_InStream_Read_C32
  #define InStream_Read_C32_t LUCY_InStream_Read_C32_t
  #define InStream_Read_C64 LUCY_InStream_Read_C64
  #define InStream_Read_C64_t LUCY_InStream_Read_C64_t
  #define InStream_Read_Raw_C64 LUCY_InStream_Read_Raw_C64
  #define InStream_Read_Raw_C64_t LUCY_InStream_Read_Raw_C64_t
  #define InStream_Get_Filename LUCY_InStream_Get_Filename
  #define InStream_Get_Filename_t LUCY_InStream_Get_Filename_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_STORE_INSTREAM */




