/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_LUCY_UTIL_BBSORTEX
#define H_LUCY_UTIL_BBSORTEX 1


#ifdef __cplusplus
extern "C" {
#endif

#include "lucy_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Lucy/Util/SortExternal.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_LUCY_BBSORTEX
extern size_t lucy_BBSortEx_IVARS_OFFSET;
typedef struct lucy_BBSortExIVARS lucy_BBSortExIVARS;
static CFISH_INLINE lucy_BBSortExIVARS*
lucy_BBSortEx_IVARS(lucy_BBSortEx *self) {
   char *ptr = (char*)self + lucy_BBSortEx_IVARS_OFFSET;
   return (lucy_BBSortExIVARS*)ptr;
}
#ifdef LUCY_USE_SHORT_NAMES
  #define BBSortExIVARS lucy_BBSortExIVARS
  #define BBSortEx_IVARS lucy_BBSortEx_IVARS
#endif

struct lucy_BBSortExIVARS {
    cfish_Obj** buffer;
    uint32_t buf_cap;
    uint32_t buf_max;
    uint32_t buf_tick;
    cfish_Obj** scratch;
    uint32_t scratch_cap;
    cfish_VArray* runs;
    uint32_t num_slices;
    cfish_Obj*** slice_starts;
    uint32_t* slice_sizes;
    uint32_t mem_thresh;
    bool flipped;
    cfish_VArray* external;
    uint32_t external_tick;
    uint32_t mem_consumed;
};

#endif /* C_LUCY_BBSORTEX */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

LUCY_VISIBLE lucy_BBSortEx*
lucy_BBSortEx_new(uint32_t mem_thresh, cfish_VArray* external);

LUCY_VISIBLE lucy_BBSortEx*
lucy_BBSortEx_init(lucy_BBSortEx* self, uint32_t mem_thresh, cfish_VArray* external);

void
LUCY_BBSortEx_Destroy_IMP(lucy_BBSortEx* self);

int
LUCY_BBSortEx_Compare_IMP(lucy_BBSortEx* self, void* va, void* vb);

void
LUCY_BBSortEx_Flush_IMP(lucy_BBSortEx* self);

void
LUCY_BBSortEx_Feed_IMP(lucy_BBSortEx* self, cfish_Obj* item);

void
LUCY_BBSortEx_Flip_IMP(lucy_BBSortEx* self);

uint32_t
LUCY_BBSortEx_Refill_IMP(lucy_BBSortEx* self);

void
LUCY_BBSortEx_Clear_Buffer_IMP(lucy_BBSortEx* self);

cfish_VArray*
LUCY_BBSortEx_Peek_Cache_IMP(lucy_BBSortEx* self);

cfish_Obj*
LUCY_BBSortEx_Peek_Last_IMP(lucy_BBSortEx* self);

uint32_t
LUCY_BBSortEx_Get_Num_Runs_IMP(lucy_BBSortEx* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*LUCY_BBSortEx_Get_RefCount_t)(lucy_BBSortEx *self);

typedef cfish_Obj*
(*LUCY_BBSortEx_Inc_RefCount_t)(lucy_BBSortEx *self);

typedef uint32_t
(*LUCY_BBSortEx_Dec_RefCount_t)(lucy_BBSortEx *self);

typedef void*
(*LUCY_BBSortEx_To_Host_t)(lucy_BBSortEx *self);

typedef cfish_Obj*
(*LUCY_BBSortEx_Clone_t)(lucy_BBSortEx *self);

typedef void
(*LUCY_BBSortEx_Destroy_t)(lucy_BBSortEx *self);

typedef bool
(*LUCY_BBSortEx_Equals_t)(lucy_BBSortEx *self, cfish_Obj* other);

typedef int32_t
(*LUCY_BBSortEx_Compare_To_t)(lucy_BBSortEx *self, cfish_Obj* other);

typedef int32_t
(*LUCY_BBSortEx_Hash_Sum_t)(lucy_BBSortEx *self);

typedef cfish_Class*
(*LUCY_BBSortEx_Get_Class_t)(lucy_BBSortEx *self);

typedef cfish_String*
(*LUCY_BBSortEx_Get_Class_Name_t)(lucy_BBSortEx *self);

typedef bool
(*LUCY_BBSortEx_Is_A_t)(lucy_BBSortEx *self, cfish_Class* ancestor);

typedef cfish_String*
(*LUCY_BBSortEx_To_String_t)(lucy_BBSortEx *self);

typedef int64_t
(*LUCY_BBSortEx_To_I64_t)(lucy_BBSortEx *self);

typedef double
(*LUCY_BBSortEx_To_F64_t)(lucy_BBSortEx *self);

typedef bool
(*LUCY_BBSortEx_To_Bool_t)(lucy_BBSortEx *self);

typedef void
(*LUCY_BBSortEx_Mimic_t)(lucy_BBSortEx *self, cfish_Obj* other);

typedef int
(*LUCY_BBSortEx_Compare_t)(lucy_BBSortEx *self, void* va, void* vb);

typedef void
(*LUCY_BBSortEx_Flush_t)(lucy_BBSortEx *self);

typedef void
(*LUCY_BBSortEx_Feed_t)(lucy_BBSortEx *self, cfish_Obj* item);

typedef void
(*LUCY_BBSortEx_Flip_t)(lucy_BBSortEx *self);

typedef cfish_Obj*
(*LUCY_BBSortEx_Fetch_t)(lucy_BBSortEx *self);

typedef cfish_Obj*
(*LUCY_BBSortEx_Peek_t)(lucy_BBSortEx *self);

typedef void
(*LUCY_BBSortEx_Add_Run_t)(lucy_BBSortEx *self, lucy_SortExternal* run);

typedef void
(*LUCY_BBSortEx_Shrink_t)(lucy_BBSortEx *self);

typedef uint32_t
(*LUCY_BBSortEx_Refill_t)(lucy_BBSortEx *self);

typedef void
(*LUCY_BBSortEx_Sort_Buffer_t)(lucy_BBSortEx *self);

typedef void
(*LUCY_BBSortEx_Clear_Buffer_t)(lucy_BBSortEx *self);

typedef uint32_t
(*LUCY_BBSortEx_Buffer_Count_t)(lucy_BBSortEx *self);

typedef void
(*LUCY_BBSortEx_Grow_Buffer_t)(lucy_BBSortEx *self, uint32_t cap);

typedef void
(*LUCY_BBSortEx_Set_Mem_Thresh_t)(lucy_BBSortEx *self, uint32_t mem_thresh);

typedef cfish_VArray*
(*LUCY_BBSortEx_Peek_Cache_t)(lucy_BBSortEx *self);

typedef cfish_Obj*
(*LUCY_BBSortEx_Peek_Last_t)(lucy_BBSortEx *self);

typedef uint32_t
(*LUCY_BBSortEx_Get_Num_Runs_t)(lucy_BBSortEx *self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_BBSortEx_Get_RefCount(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Get_RefCount_t method = (LUCY_BBSortEx_Get_RefCount_t)cfish_obj_method(self, LUCY_BBSortEx_Get_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_BBSortEx_Inc_RefCount(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Inc_RefCount_t method = (LUCY_BBSortEx_Inc_RefCount_t)cfish_obj_method(self, LUCY_BBSortEx_Inc_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
LUCY_BBSortEx_Dec_RefCount(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Dec_RefCount_t method = (LUCY_BBSortEx_Dec_RefCount_t)cfish_obj_method(self, LUCY_BBSortEx_Dec_RefCount_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_To_Host_OFFSET;
static CFISH_INLINE void*
LUCY_BBSortEx_To_Host(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_To_Host_t method = (LUCY_BBSortEx_To_Host_t)cfish_obj_method(self, LUCY_BBSortEx_To_Host_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_BBSortEx_Clone(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Clone_t method = (LUCY_BBSortEx_Clone_t)cfish_obj_method(self, LUCY_BBSortEx_Clone_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Destroy_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Destroy(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Destroy_t method = (LUCY_BBSortEx_Destroy_t)cfish_obj_method(self, LUCY_BBSortEx_Destroy_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Equals_OFFSET;
static CFISH_INLINE bool
LUCY_BBSortEx_Equals(lucy_BBSortEx *self, cfish_Obj* other) {
    const LUCY_BBSortEx_Equals_t method = (LUCY_BBSortEx_Equals_t)cfish_obj_method(self, LUCY_BBSortEx_Equals_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Compare_To_OFFSET;
static CFISH_INLINE int32_t
LUCY_BBSortEx_Compare_To(lucy_BBSortEx *self, cfish_Obj* other) {
    const LUCY_BBSortEx_Compare_To_t method = (LUCY_BBSortEx_Compare_To_t)cfish_obj_method(self, LUCY_BBSortEx_Compare_To_OFFSET);
    return method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
LUCY_BBSortEx_Hash_Sum(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Hash_Sum_t method = (LUCY_BBSortEx_Hash_Sum_t)cfish_obj_method(self, LUCY_BBSortEx_Hash_Sum_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
LUCY_BBSortEx_Get_Class(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Get_Class_t method = (LUCY_BBSortEx_Get_Class_t)cfish_obj_method(self, LUCY_BBSortEx_Get_Class_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_BBSortEx_Get_Class_Name(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Get_Class_Name_t method = (LUCY_BBSortEx_Get_Class_Name_t)cfish_obj_method(self, LUCY_BBSortEx_Get_Class_Name_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Is_A_OFFSET;
static CFISH_INLINE bool
LUCY_BBSortEx_Is_A(lucy_BBSortEx *self, cfish_Class* ancestor) {
    const LUCY_BBSortEx_Is_A_t method = (LUCY_BBSortEx_Is_A_t)cfish_obj_method(self, LUCY_BBSortEx_Is_A_OFFSET);
    return method(self, ancestor);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_To_String_OFFSET;
static CFISH_INLINE cfish_String*
LUCY_BBSortEx_To_String(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_To_String_t method = (LUCY_BBSortEx_To_String_t)cfish_obj_method(self, LUCY_BBSortEx_To_String_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_To_I64_OFFSET;
static CFISH_INLINE int64_t
LUCY_BBSortEx_To_I64(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_To_I64_t method = (LUCY_BBSortEx_To_I64_t)cfish_obj_method(self, LUCY_BBSortEx_To_I64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_To_F64_OFFSET;
static CFISH_INLINE double
LUCY_BBSortEx_To_F64(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_To_F64_t method = (LUCY_BBSortEx_To_F64_t)cfish_obj_method(self, LUCY_BBSortEx_To_F64_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_To_Bool_OFFSET;
static CFISH_INLINE bool
LUCY_BBSortEx_To_Bool(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_To_Bool_t method = (LUCY_BBSortEx_To_Bool_t)cfish_obj_method(self, LUCY_BBSortEx_To_Bool_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Mimic_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Mimic(lucy_BBSortEx *self, cfish_Obj* other) {
    const LUCY_BBSortEx_Mimic_t method = (LUCY_BBSortEx_Mimic_t)cfish_obj_method(self, LUCY_BBSortEx_Mimic_OFFSET);
    method(self, other);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Compare_OFFSET;
static CFISH_INLINE int
LUCY_BBSortEx_Compare(lucy_BBSortEx *self, void* va, void* vb) {
    const LUCY_BBSortEx_Compare_t method = (LUCY_BBSortEx_Compare_t)cfish_obj_method(self, LUCY_BBSortEx_Compare_OFFSET);
    return method(self, va, vb);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Flush_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Flush(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Flush_t method = (LUCY_BBSortEx_Flush_t)cfish_obj_method(self, LUCY_BBSortEx_Flush_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Feed_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Feed(lucy_BBSortEx *self, cfish_Obj* item) {
    const LUCY_BBSortEx_Feed_t method = (LUCY_BBSortEx_Feed_t)cfish_obj_method(self, LUCY_BBSortEx_Feed_OFFSET);
    method(self, item);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Flip_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Flip(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Flip_t method = (LUCY_BBSortEx_Flip_t)cfish_obj_method(self, LUCY_BBSortEx_Flip_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Fetch_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_BBSortEx_Fetch(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Fetch_t method = (LUCY_BBSortEx_Fetch_t)cfish_obj_method(self, LUCY_BBSortEx_Fetch_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Peek_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_BBSortEx_Peek(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Peek_t method = (LUCY_BBSortEx_Peek_t)cfish_obj_method(self, LUCY_BBSortEx_Peek_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Add_Run_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Add_Run(lucy_BBSortEx *self, lucy_SortExternal* run) {
    const LUCY_BBSortEx_Add_Run_t method = (LUCY_BBSortEx_Add_Run_t)cfish_obj_method(self, LUCY_BBSortEx_Add_Run_OFFSET);
    method(self, run);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Shrink_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Shrink(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Shrink_t method = (LUCY_BBSortEx_Shrink_t)cfish_obj_method(self, LUCY_BBSortEx_Shrink_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Refill_OFFSET;
static CFISH_INLINE uint32_t
LUCY_BBSortEx_Refill(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Refill_t method = (LUCY_BBSortEx_Refill_t)cfish_obj_method(self, LUCY_BBSortEx_Refill_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Sort_Buffer_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Sort_Buffer(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Sort_Buffer_t method = (LUCY_BBSortEx_Sort_Buffer_t)cfish_obj_method(self, LUCY_BBSortEx_Sort_Buffer_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Clear_Buffer_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Clear_Buffer(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Clear_Buffer_t method = (LUCY_BBSortEx_Clear_Buffer_t)cfish_obj_method(self, LUCY_BBSortEx_Clear_Buffer_OFFSET);
    method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Buffer_Count_OFFSET;
static CFISH_INLINE uint32_t
LUCY_BBSortEx_Buffer_Count(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Buffer_Count_t method = (LUCY_BBSortEx_Buffer_Count_t)cfish_obj_method(self, LUCY_BBSortEx_Buffer_Count_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Grow_Buffer_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Grow_Buffer(lucy_BBSortEx *self, uint32_t cap) {
    const LUCY_BBSortEx_Grow_Buffer_t method = (LUCY_BBSortEx_Grow_Buffer_t)cfish_obj_method(self, LUCY_BBSortEx_Grow_Buffer_OFFSET);
    method(self, cap);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Set_Mem_Thresh_OFFSET;
static CFISH_INLINE void
LUCY_BBSortEx_Set_Mem_Thresh(lucy_BBSortEx *self, uint32_t mem_thresh) {
    const LUCY_BBSortEx_Set_Mem_Thresh_t method = (LUCY_BBSortEx_Set_Mem_Thresh_t)cfish_obj_method(self, LUCY_BBSortEx_Set_Mem_Thresh_OFFSET);
    method(self, mem_thresh);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Peek_Cache_OFFSET;
static CFISH_INLINE cfish_VArray*
LUCY_BBSortEx_Peek_Cache(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Peek_Cache_t method = (LUCY_BBSortEx_Peek_Cache_t)cfish_obj_method(self, LUCY_BBSortEx_Peek_Cache_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Peek_Last_OFFSET;
static CFISH_INLINE cfish_Obj*
LUCY_BBSortEx_Peek_Last(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Peek_Last_t method = (LUCY_BBSortEx_Peek_Last_t)cfish_obj_method(self, LUCY_BBSortEx_Peek_Last_OFFSET);
    return method(self);
}

extern LUCY_VISIBLE size_t LUCY_BBSortEx_Get_Num_Runs_OFFSET;
static CFISH_INLINE uint32_t
LUCY_BBSortEx_Get_Num_Runs(lucy_BBSortEx *self) {
    const LUCY_BBSortEx_Get_Num_Runs_t method = (LUCY_BBSortEx_Get_Num_Runs_t)cfish_obj_method(self, LUCY_BBSortEx_Get_Num_Runs_OFFSET);
    return method(self);
}



/* Declare the Class singleton for this class.
 */

extern LUCY_VISIBLE cfish_Class *LUCY_BBSORTEX;

/* Define "short names" for this class's symbols.
 */

#ifdef LUCY_USE_SHORT_NAMES
  #define BBSortEx lucy_BBSortEx
  #define BBSORTEX LUCY_BBSORTEX
  #define BBSortEx_new lucy_BBSortEx_new
  #define BBSortEx_init lucy_BBSortEx_init
  #define BBSortEx_Destroy_IMP LUCY_BBSortEx_Destroy_IMP
  #define BBSortEx_Compare_IMP LUCY_BBSortEx_Compare_IMP
  #define BBSortEx_Flush_IMP LUCY_BBSortEx_Flush_IMP
  #define BBSortEx_Feed_IMP LUCY_BBSortEx_Feed_IMP
  #define BBSortEx_Flip_IMP LUCY_BBSortEx_Flip_IMP
  #define BBSortEx_Refill_IMP LUCY_BBSortEx_Refill_IMP
  #define BBSortEx_Clear_Buffer_IMP LUCY_BBSortEx_Clear_Buffer_IMP
  #define BBSortEx_Peek_Cache_IMP LUCY_BBSortEx_Peek_Cache_IMP
  #define BBSortEx_Peek_Last_IMP LUCY_BBSortEx_Peek_Last_IMP
  #define BBSortEx_Get_Num_Runs_IMP LUCY_BBSortEx_Get_Num_Runs_IMP
  #define BBSortEx_Get_RefCount LUCY_BBSortEx_Get_RefCount
  #define BBSortEx_Get_RefCount_t LUCY_BBSortEx_Get_RefCount_t
  #define BBSortEx_Inc_RefCount LUCY_BBSortEx_Inc_RefCount
  #define BBSortEx_Inc_RefCount_t LUCY_BBSortEx_Inc_RefCount_t
  #define BBSortEx_Dec_RefCount LUCY_BBSortEx_Dec_RefCount
  #define BBSortEx_Dec_RefCount_t LUCY_BBSortEx_Dec_RefCount_t
  #define BBSortEx_To_Host LUCY_BBSortEx_To_Host
  #define BBSortEx_To_Host_t LUCY_BBSortEx_To_Host_t
  #define BBSortEx_Clone LUCY_BBSortEx_Clone
  #define BBSortEx_Clone_t LUCY_BBSortEx_Clone_t
  #define BBSortEx_Destroy LUCY_BBSortEx_Destroy
  #define BBSortEx_Destroy_t LUCY_BBSortEx_Destroy_t
  #define BBSortEx_Equals LUCY_BBSortEx_Equals
  #define BBSortEx_Equals_t LUCY_BBSortEx_Equals_t
  #define BBSortEx_Compare_To LUCY_BBSortEx_Compare_To
  #define BBSortEx_Compare_To_t LUCY_BBSortEx_Compare_To_t
  #define BBSortEx_Hash_Sum LUCY_BBSortEx_Hash_Sum
  #define BBSortEx_Hash_Sum_t LUCY_BBSortEx_Hash_Sum_t
  #define BBSortEx_Get_Class LUCY_BBSortEx_Get_Class
  #define BBSortEx_Get_Class_t LUCY_BBSortEx_Get_Class_t
  #define BBSortEx_Get_Class_Name LUCY_BBSortEx_Get_Class_Name
  #define BBSortEx_Get_Class_Name_t LUCY_BBSortEx_Get_Class_Name_t
  #define BBSortEx_Is_A LUCY_BBSortEx_Is_A
  #define BBSortEx_Is_A_t LUCY_BBSortEx_Is_A_t
  #define BBSortEx_To_String LUCY_BBSortEx_To_String
  #define BBSortEx_To_String_t LUCY_BBSortEx_To_String_t
  #define BBSortEx_To_I64 LUCY_BBSortEx_To_I64
  #define BBSortEx_To_I64_t LUCY_BBSortEx_To_I64_t
  #define BBSortEx_To_F64 LUCY_BBSortEx_To_F64
  #define BBSortEx_To_F64_t LUCY_BBSortEx_To_F64_t
  #define BBSortEx_To_Bool LUCY_BBSortEx_To_Bool
  #define BBSortEx_To_Bool_t LUCY_BBSortEx_To_Bool_t
  #define BBSortEx_Mimic LUCY_BBSortEx_Mimic
  #define BBSortEx_Mimic_t LUCY_BBSortEx_Mimic_t
  #define BBSortEx_Compare LUCY_BBSortEx_Compare
  #define BBSortEx_Compare_t LUCY_BBSortEx_Compare_t
  #define BBSortEx_Flush LUCY_BBSortEx_Flush
  #define BBSortEx_Flush_t LUCY_BBSortEx_Flush_t
  #define BBSortEx_Feed LUCY_BBSortEx_Feed
  #define BBSortEx_Feed_t LUCY_BBSortEx_Feed_t
  #define BBSortEx_Flip LUCY_BBSortEx_Flip
  #define BBSortEx_Flip_t LUCY_BBSortEx_Flip_t
  #define BBSortEx_Fetch LUCY_BBSortEx_Fetch
  #define BBSortEx_Fetch_t LUCY_BBSortEx_Fetch_t
  #define BBSortEx_Peek LUCY_BBSortEx_Peek
  #define BBSortEx_Peek_t LUCY_BBSortEx_Peek_t
  #define BBSortEx_Add_Run LUCY_BBSortEx_Add_Run
  #define BBSortEx_Add_Run_t LUCY_BBSortEx_Add_Run_t
  #define BBSortEx_Shrink LUCY_BBSortEx_Shrink
  #define BBSortEx_Shrink_t LUCY_BBSortEx_Shrink_t
  #define BBSortEx_Refill LUCY_BBSortEx_Refill
  #define BBSortEx_Refill_t LUCY_BBSortEx_Refill_t
  #define BBSortEx_Sort_Buffer LUCY_BBSortEx_Sort_Buffer
  #define BBSortEx_Sort_Buffer_t LUCY_BBSortEx_Sort_Buffer_t
  #define BBSortEx_Clear_Buffer LUCY_BBSortEx_Clear_Buffer
  #define BBSortEx_Clear_Buffer_t LUCY_BBSortEx_Clear_Buffer_t
  #define BBSortEx_Buffer_Count LUCY_BBSortEx_Buffer_Count
  #define BBSortEx_Buffer_Count_t LUCY_BBSortEx_Buffer_Count_t
  #define BBSortEx_Grow_Buffer LUCY_BBSortEx_Grow_Buffer
  #define BBSortEx_Grow_Buffer_t LUCY_BBSortEx_Grow_Buffer_t
  #define BBSortEx_Set_Mem_Thresh LUCY_BBSortEx_Set_Mem_Thresh
  #define BBSortEx_Set_Mem_Thresh_t LUCY_BBSortEx_Set_Mem_Thresh_t
  #define BBSortEx_Peek_Cache LUCY_BBSortEx_Peek_Cache
  #define BBSortEx_Peek_Cache_t LUCY_BBSortEx_Peek_Cache_t
  #define BBSortEx_Peek_Last LUCY_BBSortEx_Peek_Last
  #define BBSortEx_Peek_Last_t LUCY_BBSortEx_Peek_Last_t
  #define BBSortEx_Get_Num_Runs LUCY_BBSortEx_Get_Num_Runs
  #define BBSortEx_Get_Num_Runs_t LUCY_BBSortEx_Get_Num_Runs_t
#endif /* LUCY_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_LUCY_UTIL_BBSORTEX */




